Package: exactextractr
Title: Fast Extraction from Raster Datasets using Polygons
Version: 0.10.1
Authors@R: c(
        person("Daniel", "Baston", email = "dbaston@isciences.com", role = c("aut", "cre")),
        person("ISciences, LLC", role="cph"))
Description: Quickly and accurately summarizes raster values over polygonal areas ("zonal statistics").
Depends: R (>= 3.4.0)
License: Apache License (== 2.0)
SystemRequirements: GEOS (>= 3.5.0)
Imports: Rcpp (>= 0.12.12), methods, raster, sf (>= 0.9.0),
URL: https://isciences.gitlab.io/exactextractr/,
        https://github.com/isciences/exactextractr
BugReports: https://github.com/isciences/exactextractr/issues
LinkingTo: Rcpp
Suggests: dplyr, foreign, knitr, ncdf4, rmarkdown, testthat, terra (>=
        1.5.17)
Encoding: UTF-8
RoxygenNote: 7.3.2
VignetteBuilder: knitr
NeedsCompilation: yes
Packaged: 2025-12-01 15:52:14 UTC; dan
Author: Daniel Baston [aut, cre],
  ISciences, LLC [cph]
Maintainer: Daniel Baston <dbaston@isciences.com>
Repository: CRAN
Date/Publication: 2025-12-01 16:50:18 UTC
Built: R 4.6.0; x86_64-apple-darwin20; 2026-04-27 22:13:10 UTC; unix
Archs: exactextractr.so.dSYM

# Generated by roxygen2: do not edit by hand

exportMethods(coverage_fraction)
exportMethods(exact_extract)
exportMethods(exact_resample)
exportMethods(rasterize_polygons)
import(raster)
import(sf)
importFrom(Rcpp,evalCpp)
importFrom(methods,setMethod)
useDynLib(exactextractr)

# exactextractr

[![Build Status](https://gitlab.com/isciences/exactextractr/badges/master/pipeline.svg)](https://gitlab.com/isciences/exactextractr/-/pipelines)
[![coverage report](https://gitlab.com/isciences/exactextractr/badges/master/coverage.svg)](https://isciences.gitlab.io/exactextractr/coverage.html)
[![CRAN](http://www.r-pkg.org/badges/version/exactextractr)](https://cran.r-project.org/package=exactextractr)
[![cran checks](https://badges.cranchecks.info/worst/exactextractr.svg)](https://cran.r-project.org/web/checks/check_results_exactextractr.html)
 
`exactextractr` is an R package that quickly and accurately summarizes raster
values over polygonal areas, commonly referred to as _zonal statistics_. Unlike
most zonal statistics implementations, it handles grid cells that are partially
covered by a polygon. Despite this, it performs faster other packages for many
real-world applications.

![Example Graphic](https://gitlab.com/isciences/exactextractr/-/raw/assets/readme/brazil_precip.png).

Calculations are performed using the C++
[`exactextract`](https://github.com/isciences/exactextract) tool. Additional
background and a description of the method is available
[here](https://github.com/isciences/exactextract#background).
Full package reference documentation is available
[here](https://isciences.gitlab.io/exactextractr/reference).

### Basic Usage

The package provides an
[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html)
method that operates analogously to the
[`extract`](https://www.rdocumentation.org/packages/raster/topics/extract)
method in the
[`raster`](https://CRAN.R-project.org/package=raster) package.
The snippet below demonstrates the use of this function to compute monthly mean precipitation for each municipality in Brazil.

```r
library(raster)
library(sf)
library(exactextractr)

# Pull municipal boundaries for Brazil
brazil <- st_as_sf(getData('GADM', country='BRA', level=2))

# Pull gridded precipitation data
prec <- getData('worldclim', var='prec', res=10)

# Calculate vector of mean December precipitation amount for each municipality
brazil$mean_dec_prec <- exact_extract(prec[[12]], brazil, 'mean')

# Calculate data frame of min and max precipitation for all months
brazil <- cbind(brazil, exact_extract(prec, brazil, c('min', 'max')))
```

#### Summary Operations

`exactextractr` can summarize raster values using several named operations as well
as arbitrary R functions. Where applicable, a named operation will provide
better performance and reduced memory usage relative to an equivalent R function.
Named operations are specified by providing a character vector with one or more 
operation names to the `fun` parameter of [`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html).

The following summary operations are supported:

| Name                   | Description    |                     
| ---------------------- |--------------- |
| `count`                | Sum of all cell coverage fractions. |
| `majority` (or `mode`) | The raster value with the largest sum of coverage fractions. |
| `max`                  | Maximum value of cells that intersect the polygon, ignoring coverage fractions. |
| `mean`                 | Mean value of cells that intersect the polygon, weighted by the fraction of the cell that is covered. |
| `median`               | Median value of cells that intersect the polygon, weighted by the fraction of the cell that is covered. |
| `quantile`             | Arbitrary quantile value of cells that intersect the polygon, weighted by the fraction of the cell that is covered. |
| `min`                  | Minimum value of cells that intersect the polygon, ignoring coverage fractions. |
| `minority`             | The raster value with the smallest sum of coverage fractions. |
| `sum`                  | Sum of values of raster cells that intersect the polygon, with each raster value weighted by its coverage fraction. |
| `variety`              | The number of distinct raster values in cells wholly or partially covered by the polygon. |
| `variance`             | The population variance of cell values, weighted by the fraction of each cell that is covered by the polygon. |
| `stdev`                | The population standard deviation of cell values, weighted by the fraction of each cell that is covered by the polygon. |
| `coefficient_of_variation` | The population coefficient of variation of cell values, weighted by the fraction of each cell that is covered by the polygon. |
| `frac`                 | Fraction of covered cells that are occupied by each distinct raster value. |

Three additional summary operations require the use of a second weighting raster,
provided in the `weights` argument to 
[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html):

| Name                   | Description    |                     
| ---------------------- |--------------- |
| `weighted_mean`        | Mean value of defined (non-`NA`) cells that intersect the polygon, weighted by the product of the coverage fraction and the value of a second weighting raster. |
| `weighted_sum`         | Sum of defined (non-`NA`) values of raster cells that intersect the polygon, multiplied by the coverage fraction and the value of a second weighting raster. |
| `weighted_variance`    | Population variance of defined (non-`NA`) values of cells that intersect the polygon, weighted by the product of the coverage fraction and the value of a second weighting raster. |
| `weighted_stdev`       | Population standard deviation of defined (non-`NA`) values of raster cells that intersect the polygon, multiplied by the coverage fraction and the value of a second weighting raster. |
| `weighted_frac`        | Fraction of covered cells that are occupied by each distinct raster value, with coverage fractions multiplied by the value of a second weighting raster. |

Weighted usage is discussed in more detail [below](#weighted-usage).

Undefined (`NA`) values are ignored in all of the named summary operations when 
they occur in the value raster. When they occur in the weighting raster, they 
cause the result of the summary operation to be `NA`.

#### Summary Functions

In addition to the summary operations described above,
[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html)
can accept an R function to summarize the cells covered by the polygon. Because
[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html)
takes into account the fraction of the cell that is covered by the polygon, the
summary function must take two arguments: the value of the raster in each cell
touched by the polygon, and the fraction of that cell area that is covered by
the polygon. (This differs from
[`raster::extract`](https://www.rdocumentation.org/packages/raster/topics/extract),
where the summary function takes the vector of raster values as a single argument
and effectively assumes that the coverage fraction is `1.0`.)

An example of a built-in function with the appropriate signature is 
[`weighted.mean`](https://www.rdocumentation.org/packages/stats/topics/weighted.mean).
Some examples of custom summary functions are:

```r
# Number of cells covered by the polygon (raster values are ignored)
exact_extract(rast, poly, function(values, coverage_fraction)
                            sum(coverage_fraction))

# Sum of defined raster values within the polygon, accounting for coverage fraction
exact_extract(rast, poly, function(values, coverage_fraction)
                            sum(values * coverage_fraction, na.rm=TRUE))

# Number of distinct raster values within the polygon (coverage fractions are ignored)
exact_extract(rast, poly, function(values, coverage_fraction)
                            length(unique(values)))

# Number of distinct raster values in cells more than 10% covered by the polygon
exact_extract(rast, poly, function(values, coverage_fraction)
                            length(unique(values[coverage_fraction > 0.1])))
```

### Weighted Usage

[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html)
allows for calculation of summary statistics based on
multiple raster layers, such as a population-weighted temperature.
The weighting raster must use the same coordinate system as the primary raster,
and it must use a grid that is compatible with the primary raster. (The resolutions and
extents of the rasters need not be the same, but the higher resolution must must be an 
integer multiple of the lower resolution, and the cell boundaries of both rasters must
coincide with cell boundaries in the higher-resolution grid.)

One application of this feature is the calculation of zonal statistics on
raster data in geographic coordinates. The previous calculation of mean
precipitation amount across Brazilian municipalities assumed that each raster
cell covered the same area, which is not correct for rasters in geographic
coordinates (latitude/longitude).

We can correct for varying cell areas by creating a weighting raster with the area of
each cell in the primary raster using the 
[`area`](https://www.rdocumentation.org/packages/raster/topics/area) function
from the `raster` package.

#### Weighted Summary Operations

Performing a weighted summary with the `weighted_mean` and `weighted_sum` operations
is as simple as providing a weighting
[`RasterLayer`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
or
[`RasterStack`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
to the `weights` argument of
[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html).

The area-weighted mean precipitation calculation can be expressed as:

```r
brazil$mean_dec_prec_weighted <- exact_extract(prec[[12]], brazil, 'weighted_mean', weights = area(prec))
```

With the relatively small polygons used in this example, the error introduced
by assuming constant cell area is negligible. However, for large polygons that 
span a wide range of latitudes, this may not be the case.

#### Weighted Summary Functions

A weighting raster can also be provided when an R summary function is used.
When a weighting raster is provided, the summary function must accept a third
argument containing the values of the weighting raster.

An equivalent to the `weighted_mean` usage above could be written as:

```r
brazil$mean_dec_prec_weighted <- 
  exact_extract(prec[[12]], brazil, function(values, coverage_frac, weights) {
    weighted.mean(values, coverage_frac * weights)
  }, weights = area(prec))
```

Or, to calculate the area-weighted mean precipitation for all months:

```r
brazil <- cbind(brazil,
  exact_extract(prec, brazil, function(values, coverage_frac, weights) {
    weighted.mean(values, coverage_frac * weights)
  },
  weights = area(prec),
  stack_apply = TRUE))
```

In this example, the `stack_apply` argument is set to `TRUE` so that the summary function
will be applied to each layer of `prec` independently. (If `stack_apply = FALSE`,
the summary function will be called with all values of `prec` in a 12-column
data frame.)

### Additional Usages

#### Multi-Raster Summary Functions

A multi-raster summary function can also be written to implement complex
behavior that requires that multiple layers in a
[`RasterStack`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
be considered simultaneously.

Here, we compute an area-weighted average temperature by calling
[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html)
with a
[`RasterStack`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
of minimum and maximum temperatures, and a
[`RasterLayer`](https://www.rdocumentation.org/packages/raster/topics/Raster-class),
of cell areas.

```r
tmin <- getData('worldclim', var = 'tmin', res = 10)
tmax <- getData('worldclim', var = 'tmax', res = 10)

temp <- stack(tmin[[12]], tmax[[12]])

brazil$tavg_dec <- exact_extract(temp, brazil,
  function(values, coverage_fraction, weights) {
    tavg <- 0.5*(values$tmin12 + values$tmax12)
    weighted.mean(tavg, coverage_fraction * weights)
  }, weights = area(prec))
```

When 
[`exact_extract`](https://isciences.gitlab.io/exactextractr/reference/exact_extract.html)
is called with a 
[`RasterStack`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
of values or weights and `stack_apply = FALSE` (the default), the values or
weights from each layer of the 
[`RasterStack`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
will be provided to the summary function as a data frame.

In the example above, the summary function is provided with a data frame of
values (containing the values for each layer in the `temp` stack), a vector of
coverage fractions, and a vector of weights.

#### Multi-Valued Summary Functions

In some cases, it is desirable for a summary function to return multiple values
for each input feature. A common application is to summarize the fraction of
each polygon that is covered by a given class of a categorical raster.
This can be accomplished by writing a summary function that returns a one-row
data frame for each input feature. The data frames for each feature will be 
combined into a single data frame using using `rbind` or, if it is available, `dplyr::bind_rows`.

In this example, the mean temperature for each municipality is returned for
each altitude category.

```r
altitude <- getData('alt', country = 'BRA')

prec_for_altitude <- exact_extract(prec[[12]], brazil, function(prec, frac, alt) {
  # ignore cells with unknown altitude
  prec <- prec[!is.na(alt)]
  frac <- frac[!is.na(alt)]
  alt <- alt[!is.na(alt)]
  
  low <- !is.na(alt) & alt < 500
  high <- !is.na(alt) & alt >= 500

  data.frame(
    prec_low_alt = weighted.mean(prec[low], frac[low]),
    prec_high_alt = weighted.mean(prec[high], frac[high])
  )
}, weights = altitude)
```

### Rasterization

`exactextractr` can rasterize polygons though computation of the coverage
fraction in each cell. The
[`coverage_fraction`](https://isciences.gitlab.io/exactextractr/reference/coverage_fraction.html)
function returns a
[`RasterLayer`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
with values from 0 to 1 indicating the fraction of each cell that is covered by
the polygon. Because this function generates a
[`RasterLayer`](https://www.rdocumentation.org/packages/raster/topics/Raster-class)
for each feature in the input dataset, it can quickly consume a large amount of
memory. Depending on the analysis being performed, it may be advisable to
manually loop over the features in the input dataset and combine the generated
rasters during each iteration.

### Performance

For typical applications, `exactextractr` is much faster than the `raster`
package and somewhat faster than the `terra` package. An example benchmark
is below:

```r
brazil <- st_as_sf(getData('GADM', country='BRA', level=1))
brazil_spat <- as(brazil, 'SpatVector')

prec_rast <- getData('worldclim', var='prec', res=10)
prec_terra <- rast(prec_rast) 
prec12_rast <- prec_rast[[12]]
prec12_terra <- rast(prec_rast[[12]])

microbenchmark(
  extract(prec_rast, brazil, mean, na.rm = TRUE),
  extract(prec_terra, brazil_spat, mean, na.rm = TRUE),
  exact_extract(prec_rast, brazil, 'mean', progress = FALSE),
  exact_extract(prec_terra, brazil, 'mean', progress = FALSE),
  extract(prec12_rast, brazil, mean, na.rm = TRUE),
  extract(prec12_terra, brazil_spat, mean, na.rm = TRUE),
  exact_extract(prec12_rast, brazil, 'mean', progress = FALSE),
  exact_extract(prec12_terra, brazil, 'mean', progress = FALSE),
  times = 5)

```
| Package       | Raster Type | Layers | Expression                                                     | Time (ms)    |                     
| ------------  | ----------- | ------ |---------------------------------------- |--------------------- |
| raster        | RasterLayer | 1      |          `extract(prec_rast, brazil, mean, na.rm = TRUE)`| 48708           | 
| terra         | SpatRaster  | 1      | `extract(prec_terra, brazil_spat, mean, na.rm = TRUE)`|   436           | 
| exactextractr | RasterLayer | 1      | `exact_extract(prec_rast, brazil, "mean", progress = FALSE)`|  1541           | 
| exactextractr | SpatRaster  | 1      | `exact_extract(prec_terra, brazil, "mean", progress = FALSE)`|   129           | 
| raster        | RasterStack | 12     |            `extract(prec12_rast, brazil, mean, na.rm = TRUE)`| 10148           | 
| terra         | SpatRaster  | 12     |      `extract(prec12_terra, brazil_spat, mean, na.rm = TRUE)`|   266           | 
| exactextractr | RasterLayer | 12     |`exact_extract(prec12_rast, brazil, "mean", progress = FALSE)`|   222           | 
| exactextractr | SpatRaster  | 12     |`exact_extract(prec12_terra, brazil, "mean", progress = FALSE)`|   112           | 

Actual performance is a complex topic that can vary dramatically depending on
factors such as:

- the number of layers in the input raster(s)
- the data type of input rasters (for best performance, use a `terra::SpatRaster`)
- the raster file format (GeoTIFF, netCDF, etc)
- the chunking strategy used by the raster file (striped, tiled, etc.)
- the relative size of the area to be read and the GDAL block cache

If `exact_extract` is called with `progress = TRUE`, messages will be emitted
if the package detects a situation that could lead to poor performance, such
as a raster chunk size that is too large to allow caching of blocks between
vector features.

If performance is poor, it may be possible to improve performance by:

- increasing the `max_cells_in_memory` parameter
- increasing the size of the GDAL block cache
- rewriting the input rasters to use a different chunking scheme
- processing inputs as batches of nearby polygons


# Accuracy

Results from `exactextractr` are more accurate than other common
implementations because raster pixels that are partially covered by polygons
are considered.  The significance of partial coverage increases for polygons
that are small or irregularly shaped. For the 5500 Brazilian municipalities
used in the example, the error introduced by incorrectly handling partial
coverage is less than 1% for 88% of municipalities and reaches a maximum of 9%.

### Dependencies

Installation requires version 3.5 or greater of the
[GEOS](https://libgeos.org/) geometry processing library.  It is recommended
to use the most recent released version for best performance. On Windows,
GEOS will be downloaded automatically as part of package install. On MacOS, it
can be installed using Homebrew (`brew install geos`). On Linux, it can be
installed from system package repositories (`apt-get install libgeos-dev` on
Debian/Ubuntu, or `yum install libgeos-devel` on CentOS/RedHat.)

# exactextract

[![Build Status](https://gitlab.com/isciences/exactextract/badges/master/pipeline.svg)](https://gitlab.com/isciences/exactextract/pipelines)
[![codecov](https://codecov.io/gl/isciences/exactextract/branch/master/graph/badge.svg)](https://codecov.io/gl/isciences/exactextract)
[![Doxygen](https://img.shields.io/badge/Doxygen-documentation-brightgreen.svg)](https://isciences.gitlab.io/exactextract)

`exactextract` provides a fast and accurate algorithm for summarizing values in the portion of a raster dataset that is covered by a polygon, often referred to as **zonal statistics**. Unlike other zonal statistics implementations, it takes into account raster cells that are partially covered by the polygon.

<img align="right" width="380" height="380" src="https://gitlab.com/isciences/exactextract/-/raw/master/doc/exactextract.svg" />

### Background

Accurate zonal statistics calculation requires determining the fraction of each raster cell that is covered by the polygon. In a naive solution to the problem, each raster cell can be expressed as a polygon whose intersection with the input polygon is computed using polygon clipping routines such as those offered in [JTS](https://github.com/locationtech/jts), [GEOS](https://github.com/OSGeo/geos), [CGAL](https://github.com/CGAL/cgal), or other libraries. However, polygon clipping algorithms are relatively expensive, and the performance of this approach is typically unacceptable unless raster resolution and polygon complexity are low. 

To achieve better performance, most zonal statistics implementations sacrifice accuracy by assuming that each cell of the raster is either wholly inside or outside of the polygon. This inside/outside determination can take various forms, for example:

- ArcGIS rasterizes the input polygon, then extracts the raster values from cells within the input polygon. Cells are interpreted to be either wholly within or outside of the polygon, depending on how the polygon is rasterized.
- [QGIS](https://qgis.org/en/site/) compares the centroid of each raster cell to the polygon boundary, initially considering cells to be wholly within or outside of the polygon based on the centroid. However, if fewer than two cell centroids fall within the polygon, an exact vector-based calculation is performed instead ([source](https://github.com/qgis/QGIS/blob/d5626d92360efffb4b8085389c8d64072ef65833/src/analysis/vector/qgszonalstatistics.cpp#L266)).
- Python's [rasterstats](https://pythonhosted.org/rasterstats/) also considers cells to be wholly within or outside of the polygon, but allows the user to decide to include cells only if their centroid is within the polygon, or if any portion of the cell touches the polygon ([docs](https://pythonhosted.org/rasterstats/manual.html#rasterization-strategy)).
- R's [raster](https://cran.r-project.org/web/packages/raster/index.html) package also uses a centroid test to determine if cells are inside or outside of the polygon. It includes a convenient method of disaggregating the raster by a factor of 10 before performing the analysis, which reduces the error incurred by ignoring partially covered cells but reduces performance substantially ([source](https://github.com/cran/raster/blob/4d218a7565d3994682557b8ae4d5b52bc2f54241/R/rasterizePolygons.R#L415)). The [velox](https://cran.r-project.org/web/packages/velox/index.html) package provides a faster implementation of the centroid test but does not provide a method for disaggregation. 

### Method used in `exactextract`

`exactextract` computes the portion of each cell that is covered by a polygon using an algorithm that proceeds as follows:

1. Each ring of a polygon is traversed a single time, making note of when it enters or exits a raster cell.
2. For each raster cell that was touched by a ring, the fraction of the cell covered by the polygon is computed. This is done by identifying all counter-clockwise-bounded areas within the cell.
3. Any cell that was not touched by the ring is known to be either entirely inside or outside of the polygon (i.e., its covered fraction is either `0` or `1`). A point-in-polygon test is used to determine which, and the `0` or `1` value is then propagated outward using a flood fill algorithm. Depending on the structure of the polygon, a handful of point-in-polygon tests may be necessary.

### Additional Features

`exactextract` can compute statistics against two rasters simultaneously, with a second raster containing weighting values.
The weighting raster does not need to have the same resolution and extent as the value raster, but the resolutions of the two rasters must be integer multiple of each other, and any difference between the grid origin points must be an integer multiple of the smallest cell size.

### Compiling

`exactextract` requires the following:

* A C++14 compiler (e.g., gcc 5.0+)
* CMake 3.8+
* [GEOS](https://github.com/libgeos/geos) version 3.5+
* [GDAL](https://github.com/osgeo/GDAL) version 2.0+ (For CLI binary)

It can be built as follows on Linux as follows:

```bash
git clone https://github.com/isciences/exactextract
cd exactextract
mkdir cmake-build-release
cd cmake-build-release
cmake -DCMAKE_BUILD_TYPE=Release ..
make
sudo make install
```

There are three options available to control what gets compiled. They are each ON by default.
- `BUILD_CLI` will build main program (which requires GDAL)
- `BUILD_TEST` will build the catch_test suite
- `BUILD_DOC` will build the doxygen documentation if doxygen is available

To build just the library and test suite, you can use these options as follows to turn off the CLI (which means GDAL isn't required) and disable the documentation build. The tests and library are built, the tests run, and the library installed if the tests were run successfully:

```bash
git clone https://github.com/isciences/exactextract
cd exactextract
mkdir cmake-build-release
cd cmake-build-release
cmake -DBUILD_CLI:=OFF -DBUILD_DOC:=OFF -DCMAKE_BUILD_TYPE=Release ..
make
./catch_tests && sudo make install
```

### Using `exactextract`

`exactextract` provides a simple command-line interface that uses GDAL to read a vector data source and one or more raster files, perform zonal statistics, and write output to a CSV, netCDF, or other tabular formats supported by GDAL.
In addition to the command-line executable, an R package ([`exactextractr`](https://github.com/isciences/exactextractr)) allows some functionality of `exactextract` to be used with R `sf` and `raster` objects.

Command line documentation can be accessed by `exactextract -h`.

A minimal usage is as follows, in which we want to compute a mean temperature for each country:

```bash
exactextract \
  -r "temp:temperature_2018.tif" \
  -p countries.shp \
  -f country_name \
  -s "mean(temp)" \
  -o mean_temperature.csv
```

In this example, `exactextract` will summarize temperatures stored in `temperature_2018.tif` over the country boundaries stored in `countries.shp`.
  * The `-r` argument provides the location for of the raster input and specifies that we'd like to refer to it later on using the name `temp`.
    The location may be specified as a filename or any other location understood by GDAL.
    For example, a single variable within a netCDF file can be accessed using `-r temp:NETCDF:outputs.nc:tmp2m`.
    In files with more than one band, the band number (1-indexed) can be specified using square brackets, e.g., `-r temp:temperature.tif[4]`.
  * The `-p` argument provides the location for the polygon input.
    As with the `-r` argument, this can be a file name or some other location understood by GDAL, such as a PostGIS vector source (`-p "PG:dbname=basins[public.basins_lev05]"`).
  * The `-f` argument indicates that we'd like the field `country_name` from the shapefile to be included as a field in the output file.
  * The `-s` argument instructs `exactextract` to compute the mean of the raster we refer to as `temp` for each polygon.
    These values will be stored as a field called `temp_mean` in the output file.
  * The `-o` argument indicates the location of the output file.
    The format of the output file is inferred by GDAL using the file extension.

With reasonable real-world inputs, the processing time of `exactextract` is roughly divided evenly between (a) I/O (reading raster cells, which may require decompression) and (b) computing the area of each raster cell that is covered by each polygon.
In common usage, we might want to perform many calculations in which one or both of these steps can be reused, such as:

  * Computing the mean, min, and max temperatures in each country
  * Computing the mean temperature for several different years, each of which is stored in a separate but congruent raster files (having the same extent and resolution)

The following more advanced usage shows how `exactextract` might be called to perform multiple calculations at once, reusing work where possible:

```bash
exactextract \
  -r "temp_2016:temperature_2016.tif" \
  -r "temp_2017:temperature_2017.tif" \
  -r "temp_2018:temperature_2018.tif" \
  -p countries.shp \
  -f country_name \
  -s "min(temp_2016)" \
  -s "mean(temp_2016)" \
  -s "max(temp_2016)" \
  -s "min(temp_2017)" \
  -s "mean(temp_2017)" \
  -s "max(temp_2017)" \
  -s "min(temp_2017)" \
  -s "mean(temp_2017)" \
  -s "max(temp_2017)" \
  -o temp_summary.csv
```

In this case, the output `temp_summary.csv` file would contain the fields `min_temp_2016`, `mean_temp_2016`, etc. Each raster would be read only a single time, and each polygon/raster overlay would be performed a single time, because the three input rasters have the same extent and resolution.

Another more advanced usage of `exactextract` involves calculations in which the values of one raster are weighted by the values of a second raster.
For example, we may wish to calculate both a standard and population-weighted mean temperature for each country:

```bash
exactextract \
  -r "temp:temperature_2018.tif" \
  -r "pop:world_population.tif" \
  -p countries.shp \
  -f country_name \
  -s "mean(temp)" \
  -s "pop_weighted_mean=weighted_mean(temp,pop)" \
  -o mean_temperature.csv
```

This also demonstrates the ability to control the name of a stat's output column by prefixing the stat name with an output column name.

Further details on weighted statistics are provided in the section below.

### Supported Statistics

The statistics supported by `exactextract` are summarized in the table below.
A formula is provided for each statistic, in which
x<sub>i</sub> represents the value of the *ith* raster cell,
c<sub>i</sub> represents the fraction of the *ith* raster cell that is covered by the polygon, and
w<sub>i</sub> represents the weight of the *ith* raster cell.
Values in the "example result" column refer to the value and weighting rasters shown below.
In these images, values of the "value raster" range from 1 to 4, and values of the "weighting raster" range from 5 to 8.
The area covered by the polygon is shaded purple.

| Example Value Raster | Example Weighting Raster |
| -------------------- | ------------------------ |
| <img align="left" width="200" height="200" src="https://gitlab.com/isciences/exactextract/-/raw/master/doc/readme_example_values.svg" /> | <img align="left" width="200" height="200" src="https://gitlab.com/isciences/exactextract/-/raw/master/doc/readme_example_weights.svg" /> | 


| Name           | Formula                                                                              | Description                                                                     | Typical Application  | Example Result |
| -------------- | ------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------- | -------------------- |--------------- |
| count          | &Sigma;c<sub>i</sub>                                                                 | Sum of all cell coverage fractions. | | 0.5 + 0 + 1 + 0.25 = 1.75 |
| sum            | &Sigma;x<sub>i</sub>c<sub>i</sub>                                                    | Sum of values of raster cells that intersect the polygon, with each raster value weighted by its coverage fraction. | Total population | 0.5&times;1 + 0&times;2 + 1.0&times;3 + 0.25&times;4 = 4.5 |
| mean           | (&Sigma;x<sub>i</sub>c<sub>i</sub>)/(&Sigma;c<sub>i</sub>)                           | Mean value of cells that intersect the polygon, weighted by the percent of the cell that is covered. | Average temperature | 4.5/1.75 = 2.57 |
| weighted_sum   | &Sigma;x<sub>i</sub>c<sub>i</sub>w<sub>i</sub>                                       | Sum of raster cells covered by the polygon, with each raster value weighted by its coverage fraction and weighting raster value. | Total crop production lost | 0.5&times;1&times;5 + 0&times;2&times;6 + 1.0&times;3&times;7 + 0.25&times;4&times;8 = 31.5
| weighted_mean  | (&Sigma;x<sub>i</sub>c<sub>i</sub>w<sub>i</sub>)/(&Sigma;c<sub>i</sub>w<sub>i</sub>) | Mean value of cells that intersect the polygon, weighted by the product over the coverage fraction and the weighting raster. | Population-weighted average temperature | 31.5 / (0.5&times;5 + 0&times;6 + 1.0&times;7 + 0.25&times;8) = 2.74
| min            | -                                                                                    | Minimum value of cells that intersect the polygon, not taking coverage fractions or weighting raster values into account. | Minimum elevation | 1 |
| max            | -                                                                                    | Maximum value of cells that intersect the polygon, not taking coverage fractions or weighting raster values into account.  | Maximum temperature | 4 |
| minority       | -                                                                                    | The raster value occupying the least number of cells, taking into account cell coverage fractions but not weighting raster values. | Least common land cover type | - |
| majority       | -                                                                                    | The raster value occupying the greatest number of cells, taking into account cell coverage fractions but not weighting raster values. | Most common land cover type | - |
| variety        | -                                                                                    | The number of distinct raster values in cells wholly or partially covered by the polygon. | Number of land cover types | - |
| variance       | (&Sigma;c<sub>i</sub>(x<sub>i</sub> - x&#773;)<sup>2</sup>)/(&Sigma;c<sub>i</sub>)                | Population variance of cell values that intersect the polygon, taking into account coverage fraction. | - | 1.10 |
| stdev          | &Sqrt;variance                                                                       | Population standard deviation of cell values that intersect the polygon, taking into account coverage fraction. | - | 1.05 |
| coefficient_of_variation | stdev / mean                                                               | Population coefficient of variation of cell values that intersect the polygon, taking into account coverage fraction. | - | 0.41 |

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7
)
knitr::opts_knit$set(
  global.par = TRUE
)

## ----include = FALSE----------------------------------------------------------
par(mar = c(1, 1, 1, 1))

## ----setup, message = FALSE---------------------------------------------------
library(exactextractr)
library(dplyr)
library(sf)
library(raster)

## -----------------------------------------------------------------------------
clc <- raster(system.file('sao_miguel/clc2018_v2020_20u1.tif',
                     package = 'exactextractr'))
concelhos <- st_read(system.file('sao_miguel/concelhos.gpkg',
                                 package = 'exactextractr'),
                     quiet = TRUE)

## ----echo = FALSE-------------------------------------------------------------
corine_palette <- c(
  "#e6004d", "#ff0000", "#cc4df2", "#cc0000", "#e6cccc", "#e6cce6", "#a600cc",
  "#a64d00", "#ff4dff", "#ffa6ff", "#ffe6ff", "#ffffa8", "#ffff00", "#e6e600",
  "#e68000", "#f2a64d", "#e6a600", "#e6e64d", "#ffe6a6", "#ffe64d", "#e6cc4d",
  "#f2cca6", "#80ff00", "#00a600", "#4dff00", "#ccf24d", "#a6ff80", "#a6e64d",
  "#a6f200", "#e6e6e6", "#cccccc", "#ccffcc", "#000000", "#a6e6cc", "#a6a6ff",
  "#4d4dff", "#ccccff", "#e6e6ff", "#a6a6e6", "#00ccf2", "#80f2e6", "#00ffa6",
  "#a6ffe6", "#e6f2ff", "#ffffff")

plot(clc, col = corine_palette,
     axes = FALSE, legend = FALSE)
plot(st_geometry(concelhos), add = TRUE)

## -----------------------------------------------------------------------------
clc_classes <- foreign::read.dbf(system.file('sao_miguel/clc2018_v2020_20u1.tif.vat.dbf',
                                             package = 'exactextractr'),
                                 as.is = TRUE) %>%
  dplyr::select(value = Value,
                landcov = LABEL3)

levels(clc) <- list(data.frame(ID = clc_classes$value,
                               landcov = clc_classes$landcov))

## -----------------------------------------------------------------------------
factorValues(clc, c(2, 18, 24))

## ----landcov-mode-------------------------------------------------------------
landcov_mode <- exact_extract(clc, concelhos, 'mode', 
                              append_cols = 'name', progress = FALSE) %>%
  inner_join(clc_classes, by=c(mode = 'value'))

## ----landcov-mode-table, echo = FALSE-----------------------------------------
landcov_mode %>%
  dplyr::select(-mode) %>%
  knitr::kable()

## ----landcov-fracs, message = FALSE-------------------------------------------
landcov_fracs <- exact_extract(clc, concelhos, function(df) {
  df %>%
    mutate(frac_total = coverage_fraction / sum(coverage_fraction)) %>%
    group_by(name, value) %>%
    summarize(freq = sum(frac_total))
}, summarize_df = TRUE, include_cols = 'name', progress = FALSE)

## -----------------------------------------------------------------------------
head(landcov_fracs)

## ----landcov-fracs-table------------------------------------------------------
landcov_fracs %>%
  inner_join(clc_classes, by = 'value') %>%
  group_by(name) %>%
  arrange(desc(freq)) %>%
  slice_head(n = 3) %>%
  mutate(freq = sprintf('%0.1f%%', 100*freq)) %>%
  knitr::kable()

## ----landcov-areas, message = FALSE-------------------------------------------
landcov_areas <- exact_extract(clc, concelhos, function(df) {
  df %>%
    group_by(name, value) %>%
    summarize(area_km2 = sum(coverage_area) / 1e6)
}, summarize_df = TRUE, coverage_area = TRUE, include_cols = 'name', progress = FALSE)

## ----landcov-areas-table, echo = FALSE----------------------------------------
landcov_areas %>%
  inner_join(clc_classes, by = 'value') %>%
  dplyr::select(-value) %>%
  group_by(name) %>%
  arrange(desc(area_km2)) %>%
  slice_head(n = 3) %>%
  knitr::kable()

## ----load-pop-density---------------------------------------------------------
pop_density <- raster(system.file('sao_miguel/gpw_v411_2020_density_2020.tif',
                                  package = 'exactextractr'))

## ----landcov-pop-areas, message = FALSE, results = FALSE----------------------
landcov_pop_areas <- exact_extract(clc, concelhos, function(df) {
  df %>%
    group_by(name, value) %>%
    summarize(pop = sum(coverage_area * weight / 1e6)) %>%
    mutate(pop_frac = pop / sum(pop))
}, weights = pop_density, coverage_area = TRUE,
   summarize_df = TRUE, include_cols = 'name')

## ----landcov-pop-areas-table, echo = FALSE------------------------------------
landcov_pop_areas %>%
  inner_join(clc_classes, by = 'value') %>%
  group_by(name) %>%
  arrange(desc(pop_frac)) %>%
  slice_head(n = 1) %>%
  dplyr::select(name, landcov, pop, pop_frac) %>%
  mutate(pop = round(pop),
         pop_frac = round(pop_frac, 3)) %>%
  knitr::kable()

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7
)
knitr::opts_knit$set(
  global.par = TRUE
)

## ----include = FALSE----------------------------------------------------------
par(mar = c(1, 1, 1, 1))

## ----setup, message = FALSE---------------------------------------------------
library(dplyr)
library(exactextractr)
library(raster)
library(sf)

## ----load-data-1--------------------------------------------------------------
pop_count <- raster(system.file('sao_miguel/gpw_v411_2020_count_2020.tif',
                                package = 'exactextractr'))
concelhos <- st_read(system.file('sao_miguel/concelhos.gpkg',
                                 package = 'exactextractr'),
                     quiet = TRUE)
plot(pop_count, axes = FALSE)
plot(st_geometry(concelhos), add = TRUE)

## ----total-pop-cellstats------------------------------------------------------
cellStats(pop_count, 'sum')

## ----echo = FALSE-------------------------------------------------------------
sao_miguel_pop <- cellStats(pop_count, 'sum')

## ----extract-example----------------------------------------------------------
exact_extract(pop_count, concelhos, 'sum', progress = FALSE)

## ----extract-pop-by-sum, cache = TRUE-----------------------------------------
concelho_pop <- exact_extract(pop_count, concelhos, 'sum', 
                              append_cols = 'name', progress = FALSE) %>%
  rename(pop = sum) %>%
  arrange(desc(pop)) %>%
  bind_rows(summarize(., name = 'Total', pop = sum(pop)))

## ----echo = FALSE-------------------------------------------------------------
concelho_pop %>%
  mutate(pop = prettyNum(round(pop), big.mark = ',')) %>%
  knitr::kable()

## ----calc-missing-pop, echo=FALSE, results='hide'-----------------------------
total_pop <- filter(concelho_pop, name == 'Total') %>% pull(pop)
missing_pop_pct <- (sao_miguel_pop - total_pop) / sao_miguel_pop
missing_pop_pct

## ----plot-pop-ponta-delgada---------------------------------------------------
plot.new()
plot.window(xlim = c(-25.75, -25.55), ylim = c(37.70, 37.77))
rect(par("usr")[1], par("usr")[3], par("usr")[2], par("usr")[4], col = "#9cc0f9")
plot(pop_count, add = TRUE, axes = FALSE, alpha = 0.8, horizontal = TRUE)
plot(st_geometry(concelhos), add = TRUE)

## ----load-data-2--------------------------------------------------------------
pop_density <- raster(system.file('sao_miguel/gpw_v411_2020_density_2020.tif',
                                  package = 'exactextractr'))

## ----pop-from-density, cache = TRUE-------------------------------------------
concelho_pop2 <- exact_extract(pop_density, concelhos, 
                               function(density, frac, area) {
                                 sum(density * frac * area)
                               }, 
                               weights = raster::area(pop_density),
                               append_cols = 'name',
                               progress = FALSE)

## ----echo = FALSE-------------------------------------------------------------
concelho_pop2 %>%
  rename(pop = result) %>%
  arrange(desc(pop)) %>%
  bind_rows(summarize(., name = 'Total', pop = sum(pop))) %>%
  mutate(pop = prettyNum(round(pop), big.mark = ',')) %>%
  knitr::kable()

## ----pop-missing-from-density, echo=FALSE, results='hide'---------------------
missing_pop_pct <- 100 * (sao_miguel_pop - sum(concelho_pop2$result)) / sao_miguel_pop
stopifnot(missing_pop_pct < 1)

## ----pop-from-density-2, results = 'hide'-------------------------------------
exact_extract(pop_density, concelhos, 'weighted_sum', weights = 'area')

## ----plot-elevation-----------------------------------------------------------
elev <- raster(system.file('sao_miguel/eu_dem_v11.tif', package = 'exactextractr'))

plot(elev, axes = FALSE, box = FALSE)
plot(st_geometry(concelhos), add = TRUE)

## ----pop-weighted-mean-elev, results = 'hide'---------------------------------
exact_extract(elev, concelhos,  'weighted_mean', weights = pop_density)

## ----pop-weighted-mean-elev-2, results = 'hide'-------------------------------
exact_extract(elev, concelhos,
              function(df) {
                weighted.mean(x = df$value,
                              w = df$coverage_fraction * df$pop_density * df$area,
                              na.rm = TRUE)},
              weights = stack(list(pop_density = pop_density,
                                   area = area(pop_density))),
              summarize_df = TRUE,
              progress = FALSE)

## ----pop-weighted-mean-elev-3-------------------------------------------------
concelho_mean_elev <- exact_extract(elev, concelhos, c('mean', 'weighted_mean'), 
                                    weights = pop_density,
                                    coverage_area = TRUE, 
                                    append_cols = 'name', progress = FALSE)

## ----echo = FALSE-------------------------------------------------------------
concelho_mean_elev %>%
  rename(mean_elev = mean,
         pop_weighted_mean_elev = weighted_mean) %>%
  arrange(name) %>%
  knitr::kable()

# Copyright (c) 2018-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

setGeneric("exact_extract", function(x, y, ...)
	standardGeneric("exact_extract"))

#' Extract or summarize values from rasters
#'
#' Extracts the values of cells in a raster (`RasterLayer`, `RasterStack`
#' `RasterBrick`, or `SpatRaster`) that are covered by polygons in a
#' simple feature collection (`sf` or `sfc`) or `SpatialPolygonsDataFrame`.
#' Returns either a summary of the extracted values or the extracted values
#' themselves.
#'
#' @details
#' `exact_extract` extracts the values of cells in a raster that are covered
#' by polygonal features in a simple feature collection (`sf` or `sfc`) or
#' `SpatialPolygonDataFrame`, as well as the fraction or area of each cell that
#' is covered by the feature. Pixels covered by all parts of the polygon are
#' considered. If an (invalid) multipart polygon covers the same pixels more
#' than once, the pixel may have a coverage fraction greater than one.
#'
#' The function can either return pixel values directly to the caller, or can
#' return the result of a predefined summary operation or user-defined R
#' function applied to the values. These three approaches are described in the
#' subsections below.
#'
#' ## Returning extracted values directly
#'
#' If `fun` is not specified, `exact_extract` will return a list with
#' one data frame for each feature in the input feature collection. The data
#' frame will contain a column with cell values from each layer in the input
#' raster (and optional weighting raster) and a column indicating
#' the fraction or area of the cell that is covered by the polygon.
#'
#' If the input rasters have only one layer, the value and weight columns in the
#' data frame will be named `values` or `weights`. When the input rasters have
#' more than one layer, the columns will be named according to `names(x)` and
#' `names(weights)`. The column containing pixel coverage will be called
#' `coverage_fraction` when `coverage_area = FALSE`, or `coverage_area` when
#' `coverage_area = TRUE`. Additional columns can be added to the returned data
#' frames with the `include_area`, `include_cell`, and `include_xy` arguments.
#'
#' If the output data frames for multiple features are to be combined (e.g.,
#' with `rbind`), it may be useful to include identifying column(s) from the
#' input features in the returned data frames using `include_cols`.
#'
#' ## Predefined summary operations
#'
#' Often the individual pixel values are not needed; only one or more summary
#' statistics (e.g., mean, sum) is required for each feature. Common summary
#' statistics can be calculated by `exact_extract` directly using a predefined
#' summary operation. Where possible, this approach is advantageous because it
#' allows the package to calculate the statistics incrementally, avoiding the
#' need to store all pixel values in memory at the same time. This allows the
#' package to process arbitrarily large data with a small amount of memory. (The
#' `max_pixels_in_memory` argument can be used to fine-tune the amount of memory
#' made available to `exact_extract`.)
#'
#' To summarize pixel values using a predefined summary option, `fun` should be
#' set to a character vector of one or more operation names. If the input raster
#' has a single layer and a single summary operation is specified,
#' `exact_extract` will return a vector with the result of the summary operation
#' for each feature in the input. If the input raster has multiple layers, or if
#' multiple summary operations are specified, `exact_extract` will return a data
#' frame with a row for each feature and a column for each summary operation /
#' layer combination. (The `force_df` option can be used to always return a data
#' frame instead of a vector.)
#'
#' The following summary operations are supported:
#'
#'  * `min` - the minimum non-`NA` value in any raster cell wholly or
#'            partially covered by the polygon
#'  * `max` - the maximum non-`NA` value in any raster cell wholly or
#'            partially covered by the polygon
#'  * `count` - the sum of fractions of raster cells with non-`NA`
#'              values covered by the polygon
#'  * `sum`   - the sum of non-`NA` raster cell values, multiplied by
#'              the fraction of the cell that is covered by the polygon
#'  * `mean` - the mean cell value, weighted by the fraction of each cell
#'             that is covered by the polygon
#'  * `median` - the median cell value, weighted by the fraction of each cell
#'               that is covered by the polygon
#'  * `quantile` - arbitrary quantile(s) of cell values, specified in
#'                 `quantiles`, weighted by the fraction of each cell that is
#'                  covered by the polygon
#'  * `mode` - the most common cell value, weighted by the fraction of
#'             each cell that is covered by the polygon. Where multiple
#'             values occupy the same maximum number of weighted cells,
#'             the largest value will be returned.
#'  * `majority` - synonym for `mode`
#'  * `minority` - the least common cell value, weighted by the fraction
#'                 of each cell that is covered by the polygon. Where
#'                 multiple values occupy the same minimum number of
#'                 weighted cells, the smallest value will be returned.
#'  * `variety` - the number of distinct values in cells that are wholly or
#'                partially covered by the polygon.
#'  * `variance` - the population variance of cell values, weighted by the
#'                 fraction of each cell that is covered by the polygon.
#'  * `stdev` - the population standard deviation of cell values, weighted by
#'              the fraction of each cell that is covered by the polygon.
#'  * `coefficient_of_variation` - the population coefficient of variation of
#'                                 cell values, weighted by the fraction of each
#'                                 cell that is covered by the polygon.
#'  * `weighted_mean` - the mean cell value, weighted by the product of
#'                      the fraction of each cell covered by the polygon
#'                      and the value of a second weighting raster provided
#'                      as `weights`
#'  * `weighted_sum` - the sum of defined raster cell values, multiplied by
#'                     the fraction of each cell that is covered by the polygon
#'                     and the value of a second weighting raster provided
#'                     as `weights`
#'  * `weighted_stdev` - the population standard deviation of cell values,
#'                       weighted by the product of the fraction of each cell
#'                       covered by the polygon and the value of a second
#'                       weighting raster provided as `weights`
#'  * `weighted_variance` - the population variance of cell values, weighted by
#'                          the product of the fraction of each cell covered by
#'                          the polygon and the value of a second weighting
#'                          raster provided as `weights`
#'  * `frac` - returns one column for each possible value of `x`, with the
#'             the fraction of defined raster cells that are equal to that
#'             value.
#'  * `weighted_frac` - returns one column for each possible value of `x`,
#'                      with the fraction of defined cells that are equal
#'                      to that value, weighted by `weights.`
#'
#' In all of the summary operations, `NA` values in the the primary raster (`x`)
#' raster are ignored (i.e., `na.rm = TRUE`.) If `NA` values occur in the
#' weighting raster, the result of the weighted operation will be `NA`. `NA`
#' values in both `x` and `weights` can be replaced on-the-fly using the
#' `default_value` and `default_weight` arguments.
#'
#' ## User-defined summary functions
#'
#' If no predefined summary operation is suitable, a user-defined R function may
#' be provided as `fun`. The function will be called once for each feature and
#' must return either a single value or a data frame. The results of the
#' function for each feature will be combined and returned by `exact_extract`.
#'
#' The simplest way to write a summary function is to set
#' argument `summarize_df = TRUE`. (For backwards compatibility, this is not the
#' default.) In this mode, the summary function takes the signature
#' `function(df, ...)` where `df` is the same data frame that would be returned
#' by `exact_extract` with `fun = NULL`.
#'
#' With `summarize_df = FALSE`, the function must have the signature
#' `function(values, coverage_fractions, ...)` when weights are not used, and
#' `function(values, coverage_fractions, weights, ...)` when weights are used.
#' If the value and weight rasters each have a single layer, the function arguments
#' will be vectors; if either has multiple layers, the function arguments will
#' be data frames, with column names taken from the names of the value/weight
#' rasters. Values brought in through the `include_xy`, `include_area`,
#' `include_cell`, and `include_cols` arguments will be added to the `values`
#' data frame. For most applications, it is simpler to set `summarize_df = TRUE`
#' and work with all inputs in a single data frame.
#'
#' @param     x a `RasterLayer`, `RasterStack`, `RasterBrick`, or `SpatRaster`
#' @param     y a `sf`, `sfc`, `SpatialPolygonsDataFrame`, or `SpatialPolygons`
#'            object with polygonal geometries
#' @param     fun an optional function or character vector, as described below
#' @param     weights  a weighting raster to be used with the `weighted_mean`
#'                     and `weighted_sum` summary operations or a user-defined
#'                     summary function. When `weights` is set to `'area'`, the
#'                     cell areas of `x` will be calculated and used as weights.
#' @param     coverage_area  if `TRUE`, output pixel `coverage_area`
#'                           instead of `coverage_fraction`
#' @param     default_value  an optional value to use instead of `NA` in `x`
#' @param     default_weight an optional value to use instead of `NA` in `weights`
#' @param     quantiles   quantiles to be computed when `fun = 'quantile'`
#' @param     append_cols when `fun` is not `NULL`, an optional character vector
#'                        of columns from `y` to be included in returned data frame.
#' @param     force_df always return a data frame instead of a vector, even if
#'                     `x` has only one layer and `fun` has length 1
#' @param     summarize_df  pass values, coverage fraction/area, and weights to
#'                          `fun` as a single data frame instead of
#'                          separate arguments.
#' @param     full_colnames include the names of `x` and `weights` in
#'                          the names of the data frame for each feature, even if
#'                          `x` or `weights` has only one layer.
#'                          This is useful when the results of multiple
#'                          calls to `exact_extract` are combined with
#'                          `cbind`.
#' @param     colname_fun an optional function used to construct column names.
#'                        Should accept arguments `values` (name of value layer),
#'                        `weights` (name of weight layer), `fun_name` (value of
#'                        `fun`), `fun_value` (value associated with `fun`, for
#'                        `fun %in% c('quantile', 'frac', 'weighted_frac)`
#'                        `nvalues` (number of value layers), `weights`
#'                        (number of weight layers)
#' @param     include_area if `TRUE`, and `fun` is `NULL`, augment
#'                       the data frame for each feature with a column
#'                       for the cell area. If the units of the raster CRS are
#'                       degrees, the area in square meters will be calculated
#'                       based on a spherical approximation of Earth. Otherwise,
#'                       a Cartesian area will be calculated (and will be the
#'                       same for all pixels.) If `TRUE` and `fun` is
#'                       not `NULL`, add `area` to the data frame passed
#'                       to `fun` for each feature.
#' @param     include_cell if `TRUE`, and `fun` is `NULL`, augment
#'                       the data frame for each feature with a column
#'                       for the cell index (`cell`). If `TRUE` and
#'                       `fun` is not `NULL`, add `cell` to the
#'                       data frame passed to `fun` for each feature.
#' @param     include_cols an optional character vector of column names in
#'                         `y` to be added to the data frame for each
#'                         feature that is either returned (when `fun` is
#'                         `NULL`) or passed to `fun`.
#' @param     include_xy if `TRUE`, and `fun` is `NULL`, augment
#'                       the returned data frame for each feature with columns
#'                       for cell center coordinates (`x` and `y`). If
#'                       `TRUE` and `fun` is not `NULL`, add
#'                       `x` and `y` to the data frame passed to `fun`
#'                       for each feature.
#' @param     stack_apply   if `TRUE`, apply `fun` independently to
#'                          each layer or `x` (and its corresponding layer
#'                          of `weights`, if provided.) The number of
#'                          layers in `x` and `weights` must equal
#'                          each other or `1`, in which case the
#'                          single layer raster will be recycled.
#'                          If `FALSE`, apply `fun` to all layers of
#'                          `x` (and `weights`) simultaneously.
#' @param     max_cells_in_memory the maximum number of raster cells to load at
#'                                a given time when using a named summary operation
#'                                for `fun` (as opposed to a function defined using
#'                                R code). If a polygon covers more than `max_cells_in_memory`
#'                                raster cells, it will be processed in multiple chunks.
#' @param     grid_compat_tol     require value and weight grids to align within
#'                                `grid_compat_tol` times the smaller of the two
#'                                grid resolutions.
#' @param     progress if `TRUE`, display a progress bar during processing
#' @param     ... additional arguments to pass to `fun`
#' @return a vector, data frame, or list of data frames, depending on the type
#'         of `x` and the value of `fun` (see Details)
#' @examples
#' rast <- raster::raster(matrix(1:100, ncol=10), xmn=0, ymn=0, xmx=10, ymx=10)
#' poly <- sf::st_as_sfc('POLYGON ((2 2, 7 6, 4 9, 2 2))')
#'
#' # named summary operation on RasterLayer, returns vector
#' exact_extract(rast, poly, 'mean')
#'
#' # two named summary operations on RasterLayer, returns data frame
#' exact_extract(rast, poly, c('min', 'max'))
#'
#' # named summary operation on RasterStack, returns data frame
#' stk <- raster::stack(list(a=rast, b=sqrt(rast)))
#' exact_extract(stk, poly, 'mean')
#'
#' # named weighted summary operation, returns vector
#' weights <- raster::raster(matrix(runif(100), ncol=10), xmn=0, ymn=0, xmx=10, ymx=10)
#' exact_extract(rast, poly, 'weighted_mean', weights=weights)
#'
#' # custom summary function, returns vector
#' exact_extract(rast, poly, function(value, cov_frac) length(value[cov_frac > 0.9]))
#'
#' @name exact_extract
#' @md
NULL

.exact_extract <- function(x, y, fun=NULL, ...,
                           weights=NULL,
                           append_cols=NULL,
                           coverage_area=FALSE,
                           default_value=NA_real_,
                           default_weight=NA_real_,
                           include_area=FALSE,
                           include_cell=FALSE,
                           include_cols=NULL,
                           include_xy=FALSE,
                           force_df=FALSE,
                           full_colnames=FALSE,
                           stack_apply=FALSE,
                           summarize_df=FALSE,
                           quantiles=NULL,
                           progress=TRUE,
                           max_cells_in_memory=30000000,
                           grid_compat_tol=1e-3,
                           colname_fun=NULL
                           ) {
  area_weights <- is.character(weights) && length(weights) == 1 && weights == 'area'
  if (area_weights) {
    weights <- NULL
  }

  .validateFlag(coverage_area, 'coverage_area')
  .validateFlag(force_df, 'force_df')
  .validateFlag(full_colnames, 'full_colnames')
  .validateFlag(include_area, 'include_area')
  .validateFlag(include_cell, 'include_cell')
  .validateFlag(include_xy, 'include_xy')
  .validateFlag(progress, 'progress')
  .validateFlag(stack_apply, 'stack_apply')
  .validateFlag(summarize_df, 'summarize_df')
  .validateNumericScalar(max_cells_in_memory, 'max_cells_in_memory')
  .validateNumericScalar(grid_compat_tol, 'grid_compat_tol')
  .validateNumericScalarOrNA(default_value, 'default_value')
  .validateNumericScalarOrNA(default_weight, 'default_weight')

  .validateUniqueNames(x)
  .validateUniqueNames(weights)

  if(!is.null(append_cols)) {
    if (!inherits(y, 'sf')) {
      stop(sprintf('append_cols only supported for sf arguments (received %s)',
                   paste(class(y), collapse = ' ')))
    }

    force_df <- TRUE
  }

  if(!is.null(include_cols)) {
    if (!inherits(y, 'sf')) {
      stop(sprintf('include_cols only supported for sf arguments (received %s)',
                   paste(class(y), collapse = ' ')))
    }
  }

  if(sf::st_geometry_type(y, by_geometry = FALSE) == 'GEOMETRY') {
    if (!all(sf::st_dimension(y) == 2)) {
      stop("Features in sfc_GEOMETRY must be polygonal")
    }
  }

  if(!is.null(weights)) {
    if (!(.isRaster(weights) || weights == 'area')) {
      stop("Weights must be a Raster object or \"area\".")
    }

    if (is.character(fun) && !any(startsWith(fun, "weighted"))) {
      warning("Weights provided but no requested operations use them.")
    }

    if (inherits(weights, 'BasicRaster') && !is.na(sf::st_crs(x))) {
      if (is.na(sf::st_crs(weights))) {
        warning("No CRS specified for weighting raster; assuming it has the same CRS as the value raster.")
      } else if (sf::st_crs(x) != sf::st_crs(weights)) {
        stop("Weighting raster does not have the same CRS as value raster.")
      }
    }
  }

  analysis_crs <- sf::st_crs(x)
  if(is.na(sf::st_crs(x)) && !is.na(sf::st_crs(y))) {
    warning("No CRS specified for raster; assuming it has the same CRS as the polygons.")
    analysis_crs <- sf::st_crs(y)
  } else if(is.na(sf::st_crs(y)) && !is.na(sf::st_crs(x))) {
    warning("No CRS specified for polygons; assuming they have the same CRS as the raster.")
  } else if(sf::st_crs(x) != sf::st_crs(y)) {
    y <- sf::st_transform(y, sf::st_crs(x))
    warning("Polygons transformed to raster CRS (EPSG:", sf::st_crs(x)$epsg, ")")
  }
  if(area_weights || include_area || coverage_area) {
    area_method <- .areaMethod(analysis_crs)
  } else {
    area_method <- NULL
  }

  if (is.character(fun)) {
    if (length(fun) == 0) {
      stop("No summary operations provided.")
    }

    if (length(list(...)) > 0) {
      stop("exact_extract was called with a named summary operation that ",
           "does not accept additional arguments ...")
    }

    if (include_xy) {
      stop("include_xy must be FALSE for named summary operations")
    }

    if (include_cell) {
      stop("include_cell must be FALSE for named summary operations")
    }

    if (include_area) {
      stop("include_area must be FALSE for named summary operations")
    }

    if (!is.null(include_cols)) {
      stop("include_cols not supported for named_summary operations (see argument append_cols)")
    }

    if (summarize_df) {
      stop("summarize_df can only be used when `fun` is an R function")
    }
  } else if (is.function(fun)) {
    if (summarize_df) {
      if (.num_expected_args(fun) < 1) {
        stop("exact_extract was called with a function that does not appear to ",
             "be of the form `function(df, ...`).")
      }
    } else if (is.null(weights)) {
      if (.num_expected_args(fun) < 2) {
        stop("exact_extract was called with a function that does not appear to ",
             "be of the form `function(values, coverage_fractions, ...)`. If ",
             "the summary function should accept a single data frame argument, ",
             "set `summarize_df = TRUE`.")
      }
    } else if (.num_expected_args(fun) < 3) {
        stop("exact_extract was called with a function that does not appear to ",
             "be of the form `function(values, coverage_fractions, weights, ...)`.",
             "If the summary function should accept a single data frame argument, ",
             "set `summarize_df = TRUE`.")
    }
  } else if (is.null(fun)) {
    if (length(list(...)) > 0) {
      stop("Unexpected arguments: ", paste(names(list(...)), collapse = ','))
    }

    if (summarize_df) {
      stop("summarize_df can only be used when `fun` is an R function")
    }
    if (stack_apply) {
      stop("stack_apply can only be used when `fun` is a summary operation or function")
    }
    if (!is.null(append_cols)) {
      stop("append_cols can only be used when `fun` is a summary operation or function. See `include_cols`.")
    }
  } else {
    stop("fun must be a character vector, function, or NULL")
  }

  geoms <- sf::st_geometry(y)

  if (requireNamespace('terra', quietly = TRUE)) {
    strategies <- c('check_block_size', 'eager_load')
  } else {
    strategies = c()
  }

  x_orig <- NULL
  if ('eager_load' %in% strategies && length(geoms) > 1 && (!.isInMemory(x))) {
    # Eagerly load the entire area to be processed into memory. If the raster
    # block sizes are large, this potentially allows us to cache data in memory
    # that would not fit within the GDAL block cache (because we can cache an
    # area smaller than a single block). We only do this when the terra package
    # is available, because raster::crop throws an error when we set snap =
    # 'out'.
    if (include_cell) {
      # retain a reference to the original so that we can use it for include_cell
      x_orig <- x
    }
    x <- .eagerLoad(x, geoms, max_cells_in_memory, message_on_fail = progress)
    weights <- .eagerLoad(weights, geoms, max_cells_in_memory, message_on_fail = progress)
  }

  # Calculate extent and resolution outside of loop for performance (yes, really)
  x_ext <- .extent(x)
  x_res <- .res(x)

  # At this point, if the data have not been preloaded into memory, either:
  # - we don't have the terra package available
  # - we can't fit the whole processing area in memory
  # Whether this is a problem depends on how the raster is chunked. If the
  # raster is poorly chunked, we can't do anything to improve the perormance,
  # but we try to detect the situation so we can alert the user.
  if (!.isInMemory(x)) {
    # - Do we have a RasterStack? Suggest using terra instead.
    if (inherits(x, 'RasterStack')) {
        message('exact_extract may perform poorly when extracting from a RasterStack. ',
                'It is recommended to use a SpatRaster from the terra package instead. ',
                'Convert using terra::rast(x)')
    }

    if (('check_block_size' %in% strategies) && inherits(x, 'SpatRaster')) {
      # Can we fit at least one block from every layer in GDAL's block cache?
      # If not, warn the user of expected poor performance.
      block_dim <- .blockSize(x)
      bytes_per_pixel <- 8L # terra has no datatype function?
      block_sz_mb <- prod(block_dim[1:2])* bytes_per_pixel / 1024 / 1024
      cache_sz_mb <- terra::gdalCache()

      min_cache_needed_mb <- ceiling(block_sz_mb) * .numLayers(x)


      if (min_cache_needed_mb >= cache_sz_mb) {
        message('Loading one raster block of data per layer requires approximately ',
                min_cache_needed_mb, ' MB but the GDAL block size cache is only ',
                cache_sz_mb, ' MB. This is likely to result in very slow performance. ',
                'It is recommended to increase the cache size using ',
                'terra::gdalCache(new_size), reduce the number of layers in the ',
                'input raster, or rewrite the input raster using a smaller chunk size.')
      }
    }
  }

  update_progress <- .createProgress(progress, length(geoms))
  tryCatch({
    x <- .startReading(x)
    weights <- .startReading(weights)

    if (is.character(fun)) {
      # Compute all stats in C++.
      # CPP_stats returns a matrix, which gets turned into a column by sapply
      # Results has one column per feature and one row per stat/raster layer
      if((is.null(weights) && !area_weights) && any(.isWeighted(fun))) {
        stop("Weighted stat requested but no weights provided.")
      }

      results <- lapply(sf::st_as_binary(geoms, EWKB=TRUE), function(wkb) {
        ret <- CPP_stats(x, x_ext, x_res, weights, wkb, default_value, default_weight, coverage_area, area_method, fun, max_cells_in_memory, grid_compat_tol, quantiles)
        update_progress()
        return(ret)
      })

      if ('frac' %in% fun || 'weighted_frac' %in% fun) {
        unique_values <- sort(unique(do.call(c, lapply(results, function(r) attr(r, 'unique_values')))))
      } else {
        unique_values <- numeric()
      }

      result_cols <- .resultColumns(names(x), names(weights), fun, full_colnames, quantiles, unique_values, colname_fun = colname_fun)
      consistent_cols <- !(result_cols$stat_name %in% c('frac', 'weighted_frac'))

      # Construct an empty matrix that we can populate with stats returned
      # for each geometry, with 0 as a default where a geometry does not
      # return a stat (e.g., 'frac' for a specific value). Then convert the
      # filled matrix to a data frame. (This is faster than populating the
      # data frame directly, because the data frame assignment operator is
      # slow.)
      result_mat <- matrix(0.0, nrow = length(geoms), ncol = nrow(result_cols))
      for (i in seq_along(results)) {
        cols <- consistent_cols | result_cols$base_value %in% attr(results[[i]], 'unique_values')
        result_mat[i, cols] <- results[[i]]
      }
      colnames(result_mat) <- result_cols$colname

      result_df <- as.data.frame(result_mat)

      if (ncol(result_df) == 1 && !force_df) {
        return(result_df[[1]])
      }

      # drop duplicated columns (occurs when an unweighted stat is
      # requested alongside a weighted stat, with a stack of weights)
      result_df <- result_df[, unique(names(result_df)), drop = FALSE]

      if (!is.null(append_cols)) {
        result_df <- cbind(sf::st_drop_geometry(y[, append_cols]), result_df)
      }

      return(result_df)
    } else {
      num_values <- .numLayers(x)
      value_names <- names(x)
      if (.isRaster(weights)) {
        num_weights <- .numLayers(weights)
        weight_names <- names(weights)
      } else if (area_weights) {
        num_weights <- 1
        weight_names <- 'area'
        weights <- NULL
      } else {
        num_weights <- 0
        weight_names <- NULL
      }

      if (stack_apply || (num_values == 1 && num_weights <= 1)) {
        apply_layerwise <- TRUE

        if (num_values > 1 && num_weights > 1 && num_values != num_weights) {
          stop(sprintf("Can't apply function layerwise with stacks of %d value layers and %d layers", num_values, num_weights))
        }

        result_names <- .resultColNames(value_names, weight_names, fun, full_colnames, colname_fun = colname_fun)
        num_results <- max(num_weights, num_values)
        ind <- .valueWeightIndexes(num_values, num_weights)
      } else {
        apply_layerwise <- FALSE
      }

      # For R summary functions and data frame output, we avoid using
      # input layer names if there is only one value/weight layer
      if (length(value_names) == 1) {
        value_names <- 'value'
      }
      if (length(weight_names) == 1) {
        weight_names <- 'weight'
      }

      ret <- lapply(seq_along(geoms), function(feature_num) {
        wkb <- sf::st_as_binary(geoms[[feature_num]], EWKB=TRUE)

        if (!is.null(include_cols)) {
          include_col_values <- sf::st_drop_geometry(y[feature_num, include_cols])
        } else {
          include_col_values <- NULL
        }

        # only raise a disaggregation warning for the first feature
        warn_on_disaggregate <- feature_num == 1

        col_list <- CPP_exact_extract(x,
                                      x_ext,
                                      x_res,
                                      x_orig,
                                      weights,
                                      wkb,
                                      default_value,
                                      default_weight,
                                      include_xy,
                                      include_cell,
                                      include_area,
                                      area_weights,
                                      coverage_area,
                                      area_method,
                                      include_col_values,
                                      value_names,
                                      weight_names,
                                      warn_on_disaggregate,
                                      grid_compat_tol)
        if (coverage_area) {
          coverage_col <- 'coverage_area'
        } else {
          coverage_col <- 'coverage_fraction'
        }

        if (!is.null(include_cols)) {
          # Replicate the include_cols vectors to be as long as the other columns,
          # so we can use quickDf
          nrow <- length(col_list[[coverage_col]])
          col_list[include_cols] <- lapply(col_list[include_cols], rep, nrow)
        }
        df <- .quickDf(col_list)

        update_progress()

        # No summary function? Return the whole data frame.
        if (is.null(fun)) {
          return(df)
        }

        # Summary function accepts a data frame? Pass it along.
        if (summarize_df && !apply_layerwise) {
          return(fun(df, ...))
        }

        # Break the data frame into components that we can pass
        # separately to the summary functions.
        included_cols_df <- df[, !(names(df) %in% c(value_names, weight_names, coverage_col)), drop = FALSE]
        vals_df <- df[, value_names, drop = FALSE]
        weights_df <- df[, weight_names, drop = FALSE]
        cov_fracs <- df[[coverage_col]]

        if (apply_layerwise) {
          result <- lapply(seq_len(num_results), function(i) {
            if (summarize_df) {
              # Pack everything into a single data frame and pass it to `fun`
              arg_df <- cbind(value = vals_df[[ind$values[i]]],
                              included_cols_df)
              if (num_weights > 0) {
                arg_df$weight <- weights_df[[ind$weights[i]]]
              }
              arg_df[[coverage_col]] <- df[[coverage_col]]

              return(fun(arg_df, ...))
            } else {
              # Pull values and weights out into vectors, unless we have
              # included columns (x/y/cell, etc.) in which case values
              # remain a data frame. Retained for backwards compat.

              vx <- vals_df[, ind$values[i]]
              if (ncol(included_cols_df) > 0) {
                vx <- cbind(data.frame(value = vx), included_cols_df)
              }
              if (num_weights == 0) {
                return(fun(vx, cov_fracs, ...))
              } else {
                return(fun(vx, cov_fracs, weights_df[, ind$weights[i]], ...))
              }
            }
          })

          if (num_results == 1) {
            return(result[[1]])
          }

          names(result) <- result_names

          return(.quickDf(result))
        } else {
          # Pass all layers to callback, to be handled together
          # Included columns (x/y/cell) are passed with the values.
          # Pass single-column data frames as vectors.
          vals_df <- .singleColumnToVector(cbind(vals_df, included_cols_df))
          weights_df <- .singleColumnToVector(weights_df)

          if (num_weights == 0) {
            return(fun(vals_df, cov_fracs, ...))
          } else {
            return(fun(vals_df, cov_fracs, weights_df, ...))
          }
        }
      })

      # if we have columns to append, iterate over the results and
      # append the columns to each, coercing into a data frame if
      # necessary. We need to iterate over the results before binding
      # them together because we don't know the legnth of each result
      # or even if their lengths are constant.
      if (!is.null(append_cols)) {
        for (i in seq_along(ret)) {
          if (!is.data.frame(ret[[i]])) {
            ret[[i]] = data.frame(result = ret[[i]])
          }

          if (nrow(ret[[i]]) >= 1) {
            append_row <- i
          } else {
            # cbinding row 0 cleanly brings in zero-length columns
            # of the correct names and types, in the correct positions
            append_row <- 0
          }

          ret[[i]] <- cbind(sf::st_drop_geometry(y[append_row, append_cols]),
                            ret[[i]],
                            row.names = NULL)
        }
      }

      if (!is.null(fun)) {
        if (all(sapply(ret, is.data.frame))) {
          # function returned a data frame for each polygon? rbind them
          if (requireNamespace('dplyr', quietly = TRUE)) {
            ret <- dplyr::bind_rows(ret) # handle column name mismatches
          } else {
            ret <- do.call(rbind, ret)
          }
        } else {
          # function returned something else; combine the somethings into
          # an array
          ret <- simplify2array(ret)

          if (force_df) {
            ret <- data.frame(result = ret)
          }
        }
      }

      return(ret)
    }
  }, finally={
    .stopReading(x)
    .stopReading(weights)
  })
}

# faster replacement for as.data.frame when input is a named list
# with equal-length columns
# from Advanced R, sec. 24.4.2
.quickDf <- function(lst) {
  class(lst) <- 'data.frame'
  attr(lst, 'row.names') <- .set_row_names(length(lst[[1]]))
  lst
}

.singleColumnToVector <- function(df) {
  if (ncol(df) == 1) {
    df[, 1]
  } else {
    df
  }
}

#' @import sf
#' @import raster
#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='Raster', y='sf'),
          .exact_extract)

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='Raster', y='SpatialPolygonsDataFrame'),
          function(x, y, ...) .exact_extract(x, sf::st_as_sf(y), ...))

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='Raster', y='SpatialPolygons'),
          function(x, y, ...) .exact_extract(x, sf::st_as_sf(y), ...))

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='Raster', y='sfc_MULTIPOLYGON'), .exact_extract)

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='Raster', y='sfc_POLYGON'), .exact_extract)

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='Raster', y='sfc_GEOMETRY'), .exact_extract)

# CRAN version of sf does not explicitly declare this class. If we do not do it
# ourselves, documentation is not generated for the `sfc_GEOMETRYCOLLECTION`
# overload.
setOldClass('sfc_GEOMETRYCOLLECTION')

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='Raster', y='sfc_GEOMETRYCOLLECTION'), .exact_extract)

#' @import sf
#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='SpatRaster', y='sf'),
          .exact_extract)

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='SpatRaster', y='SpatialPolygonsDataFrame'),
          function(x, y, ...) .exact_extract(x, sf::st_as_sf(y), ...))

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='SpatRaster', y='SpatialPolygons'),
          function(x, y, ...) .exact_extract(x, sf::st_as_sf(y), ...))

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='SpatRaster', y='sfc_MULTIPOLYGON'), .exact_extract)

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='SpatRaster', y='sfc_POLYGON'), .exact_extract)

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='SpatRaster', y='sfc_GEOMETRY'), .exact_extract)

#' @useDynLib exactextractr
#' @rdname exact_extract
#' @export
setMethod('exact_extract', signature(x='SpatRaster', y='sfc_GEOMETRYCOLLECTION'), .exact_extract)

# Copyright (c) 2018-2021 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

setGeneric('coverage_fraction', function(x, y, crop=FALSE, ...)
	standardGeneric('coverage_fraction'))

.coverage_fraction <- function(x, y, crop) {
  if(is.na(sf::st_crs(x)) && !is.na(sf::st_crs(y))) {
    warning("No CRS specified for raster; assuming it has the same CRS as the polygons.")
  } else if(is.na(sf::st_crs(y)) && !is.na(sf::st_crs(x))) {
    warning("No CRS specified for polygons; assuming they have the same CRS as the raster.")
  } else if(sf::st_crs(x) != sf::st_crs(y)) {
    y <- sf::st_transform(y, sf::st_crs(x))
    warning("Polygons transformed to raster CRS (EPSG:", sf::st_crs(x)$epsg, ")")
  }

  lapply(sf::st_as_binary(y, EWKB=TRUE), function(wkb) {
    CPP_coverage_fraction(x, wkb, crop)
  })
}

#' Compute the fraction of raster cells covered by a polygon
#'
#' @param     x a (possibly empty) \code{RasterLayer} whose resolution and
#'            extent will be used for the generated \code{RasterLayer}.
#' @param     y a \code{sf} object with polygonal geometries
#' @param     crop if \code{TRUE}, each generated \code{RasterLayer} will be
#'                 cropped to the extent of its associated feature.
#' @return    a list with a \code{RasterLayer} for each feature in \code{y}.
#'            Values of the raster represent the fraction of each
#'            cell in \code{x} that is covered by \code{y}.
#' @examples
#' rast <- raster::raster(matrix(1:100, ncol=10), xmn=0, ymn=0, xmx=10, ymx=10)
#' poly <- sf::st_as_sfc('POLYGON ((2 2, 7 6, 4 9, 2 2))')
#'
#' cov_frac <- coverage_fraction(rast, poly)[[1]]
#' @name coverage_fraction
NULL

#' @import sf
#' @import raster
#' @useDynLib exactextractr
#' @rdname coverage_fraction
#' @export
setMethod('coverage_fraction', signature(x='RasterLayer', y='sf'), function(x, y, crop=FALSE) {
  coverage_fraction(x, sf::st_geometry(y), crop)
})

#' @rdname coverage_fraction
#' @export
setMethod('coverage_fraction', signature(x='RasterLayer', y='sfc_MULTIPOLYGON'), .coverage_fraction)

#' @rdname coverage_fraction
#' @export
setMethod('coverage_fraction', signature(x='RasterLayer', y='sfc_POLYGON'), .coverage_fraction)

#' @rdname coverage_fraction
#' @export
setMethod('coverage_fraction', signature(x='SpatRaster', y='sf'), function(x, y, crop=FALSE) {
  coverage_fraction(x, sf::st_geometry(y), crop)
})

#' @rdname coverage_fraction
#' @export
setMethod('coverage_fraction', signature(x='SpatRaster', y='sfc_MULTIPOLYGON'), .coverage_fraction)

#' @rdname coverage_fraction
#' @export
setMethod('coverage_fraction', signature(x='SpatRaster', y='sfc_POLYGON'), .coverage_fraction)

# Copyright (c) 2018-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License ta http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

default_proj <- '+init=epsg:26918' # UTM 18N; avoid wgs84 to keep cartesian calcs in sf

make_rect <- function(xmin, ymin, xmax, ymax, crs) {
  sf::st_sfc(
    sf::st_polygon(
      list(
        matrix(
          c(xmin, ymin,
            xmax, ymin,
            xmax, ymax,
            xmin, ymax,
            xmin, ymin),
          ncol=2,
          byrow=TRUE))),
    crs=crs)
}

make_circle <- function(x, y, r, crs) {
  suppressWarnings(sf::st_buffer(
    sf::st_sfc(
      sf::st_point(c(x, y)),
      crs=crs),
    r))
}

make_square_raster <- function(vals, crs=default_proj) {
  n <- sqrt(length(vals))

  stopifnot(as.integer(n) == n)

  raster::raster(matrix(vals, nrow=n, byrow=TRUE),
                 xmn=0, xmx=n, ymn=0, ymx=n,
                 crs=crs)
}

make_square_rast <- function(vals, crs=default_proj) {
  n <- sqrt(length(vals))

  stopifnot(as.integer(n) == n)

  x <- terra::rast(nrows = n, ncols = n,
                   xmin=0, xmax=n, ymin=0, ymax=n,
                   crs = gsub("+init=", "", crs, fixed = TRUE))
  terra::values(x) <- vals
  x
}

# Copyright (c) 2018-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

context('exact_extract eager loading')

test_that("message emitted when working area doesn't fit in memory", {
  rast_fname <- system.file(file.path('sao_miguel', 'clc2018_v2020_20u1.tif'),
                            package = 'exactextractr')

  poly_fname <- system.file(file.path('sao_miguel', 'concelhos.gpkg'),
                            package = 'exactextractr')

  r <- terra::rast(rast_fname)
  polys <- st_read(poly_fname, quiet = TRUE)

  # no output when everything fits in memory
  capture.output({
    msg <- capture_messages({
      exact_extract(r, polys, 'mode', progress = TRUE, max_cells_in_memory = 1e7)
    })
  })
  expect_equal(msg, character())

  # message emitted when it doesn't fit
  capture.output({
    expect_message(
      exact_extract(r, polys, 'mode', progress = TRUE, max_cells_in_memory = 1e6),
      'Cannot preload'
    )
  })

  # if progress is disabled, so are hints
  expect_silent(
    exact_extract(r, polys, 'mode', progress = FALSE, max_cells_in_memory = 1e6)
  )

  # get additional warning by blowing out the GDAL block cache
  prevCacheSize <- terra::gdalCache()
  terra::gdalCache(1)

  capture.output({
    expect_message(
      exact_extract(r, polys, 'mode', max_cells_in_memory = 1e6),
      'GDAL block size cache is only 1 MB'
    )
  })

  # get additional warning if we are using a RasterStack
  capture.output({
    expect_message(
      exact_extract(stack(r), polys, 'mode', max_cells_in_memory = 1e6),
      'It is recommended to use a SpatRaster'
    )
  })

  terra::gdalCache(prevCacheSize)
})

test_that('cropping does not introduce grid incompatibility', {
  rast_fname <- system.file(file.path('sao_miguel', 'clc2018_v2020_20u1.tif'),
                            package = 'exactextractr')

  poly_fname <- system.file(file.path('sao_miguel', 'concelhos.gpkg'),
                            package = 'exactextractr')

  weight_fname <- system.file(file.path('sao_miguel', 'gpw_v411_2020_density_2020.tif'),
                              package = 'exactextractr')

  r <- terra::rast(rast_fname)
  p <- st_read(poly_fname, quiet = TRUE)
  w <- terra::rast(weight_fname)

  expect_silent({
    exact_extract(r, p, weights = w, grid_compat_tol = 1e-3, progress = FALSE)
  })
})

test_that("eager loading does not change values", {
  # this will fail if terra::crop is not called with snap = 'out'

  rast_fname <- system.file(file.path('sao_miguel', 'clc2018_v2020_20u1.tif'),
                            package = 'exactextractr')

  poly_fname <- system.file(file.path('sao_miguel', 'concelhos.gpkg'),
                            package = 'exactextractr')

  weight_fname <- system.file(file.path('sao_miguel', 'gpw_v411_2020_density_2020.tif'),
                              package = 'exactextractr')

  r <- terra::rast(rast_fname)
  p <- st_read(poly_fname, quiet = TRUE)
  w <- terra::rast(weight_fname)

  no_eager_load <- exact_extract(r, p, weights = w,
                                 include_xy = TRUE,
                                 include_cell = TRUE,
                                 max_cells_in_memory = 2000,
                                 progress = FALSE)

  eager_load <- exact_extract(r, p, weights = w,
                              include_xy = TRUE,
                              include_cell = TRUE,
                              progress = FALSE)

  expect_equal(eager_load, no_eager_load, tol = 2e-7)
})

test_that('eager loading does not error when geometry is outside extent of raster', {
  ras <- terra::rast(matrix(1:100, nrow=10))

  touches_corner <- make_rect(xmin = 10, xmax = 20, ymin = 10, ymax = 20,
                              crs = sf::st_crs(ras))

  loaded <- .eagerLoad(ras, touches_corner, Inf, '')
  expect_equal(
    nrow(exact_extract(loaded, touches_corner)[[1]]),
    0)
})

# Copyright (c) 2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

context('rasterize_polygons')

test_that('value is assigned to polygon with greatest coverage area', {
  polys <-
    st_as_sf(
      data.frame(id = 1:3,
                 geom = c(
                  'POLYGON ((10 0, 10 5, 5 5, 10 0))',
                  'POLYGON ((0 0, 10 0, 5 5, 1 10, 0 10, 0 0))',
                  'POLYGON ((5 5, 10 5, 10 10, 1 10, 5 5))'
                 )),
      wkt = 'geom'
    )

  rt <- terra::rast(xmin = 0, xmax = 10, ymin = 0, ymax = 10, res = 2)

  r <- rasterize_polygons(polys, rt)

  # lower-right is a tie, so it goes to the first feature encountered
  expect_equal(
    extract(r, cbind(9, 1))[[1]],
    1)

  # center tell is touched by all three, goes to polygon that covers the greatest area
  expect_equal(
    extract(r, cbind(5, 5))[[1]],
    2)
})

test_that('min_coverage excludes cells with small coverage area', {
  rt <- terra::rast(xmin = 0, xmax = 10, ymin = 0, ymax = 10, res = 1)
  circ <- make_circle(5, 5, 3.5, crs=st_crs(rt))
  circ_pieces <- st_sf(st_intersection(circ, st_make_grid(circ, 1)))

  cfrac <- coverage_fraction(rt, circ, crop = FALSE)[[1]]

  # by default, all touched cells are included in output
  r <- rasterize_polygons(circ_pieces, rt)
  expect_equal(
    values(cfrac) > 0,
    !is.na(values(r))
  )

  # min_coverage excludes cells with small coverage area
  r <- rasterize_polygons(circ_pieces, rt, min_coverage = 0.5)
  expect_equal(
    values(cfrac) > 0.5,
    !is.na(values(r))
  )
})

test_that('input type is preserved', {
  rt <- terra::rast(xmin = 0, xmax = 10, ymin = 0, ymax = 10, res = 2)
  rr <- raster::raster(rt)

  circ <- st_sf(make_circle(5, 5, 3.5, crs=st_crs(rt)))

  r <- rasterize_polygons(circ, rt)
  expect_s4_class(r, 'SpatRaster')

  r <- rasterize_polygons(circ, rr)
  expect_s4_class(r, 'RasterLayer')
})

test_that('no error when polygon does not intersect raster', {
  rt <- terra::rast(xmin = 0, xmax = 10, ymin = 0, ymax = 10, res = 2, crs=NA)

  circ <- st_sf(make_circle(500, 500, 3.5, crs=st_crs(rt)))

  r <- rasterize_polygons(circ, rt)

  expect_true(all(is.na(values(r))))
})

test_that('no error when polygon partially intersects raster', {
  rt <- terra::rast(xmin = 0, xmax = 10, ymin = 0, ymax = 10, res = 2, crs=NA)

  circ <- st_sf(make_circle(10, 5, 3.5, crs=st_crs(rt)))

  expect_invisible(
    r <- rasterize_polygons(circ, rt)
  )
})

# Copyright (c) 2018-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License ta http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

library(testthat)
library(exactextractr)
context('exact_extract include* arguments')

test_that('when include_xy = TRUE, center coordinates area included in the output', {
  rast <- raster::raster(matrix(1:100, nrow=10),
                         xmn=0, xmx=10, ymn=0, ymx=10,
                         crs='+proj=longlat +datum=WGS84')

  poly <- sf::st_sfc(sf::st_polygon(
    list(
      matrix(
        c(3.5, 4.4, 7.5, 4.5, 7.5, 6.5, 3.5, 6.5, 3.5, 4.4),
        ncol=2,
        byrow=TRUE
      )
    )
  ), crs=sf::st_crs(rast))

  results <- exact_extract(rast, poly, include_xy=TRUE, include_cell=TRUE)[[1]]

  # check that correct ranges of X,Y values are output
  expect_equal( c(3.5, 4.5, 5.5, 6.5, 7.5), sort(unique(results[, 'x'])))
  expect_equal( c(4.5, 5.5, 6.5),           sort(unique(results[, 'y'])))

  expect_equal(results[, 'cell'], raster::cellFromXY(rast, results[, c('x', 'y')]))

  # check the XY values of an individual cell with a known coverage fraction
  expect_equal( results[results[, 'x']==3.5 & results[,'y']==4.5, 'coverage_fraction'],
                0.2968749999999998,
                tolerance=1e-8,
                check.attributes=FALSE)

  # we can also send the weights to a callback
  exact_extract(rast, sf::st_sf(data.frame(id=1), geom=poly), include_xy=TRUE, fun=function(values, weights) {
    expect_equal(3, ncol(values))
  }, progress=FALSE)
})

test_that('We can use the stack_apply argument with include_xy and include_cols', {
  set.seed(123)

  stk <- raster::stack(list(a = make_square_raster(runif(100)),
                            b = make_square_raster(runif(100))))

  circles <- c(
    make_circle(5, 4, 2, sf::st_crs(stk)),
    make_circle(3, 1, 1, sf::st_crs(stk)))

  result <- exact_extract(stk, circles, include_xy = TRUE, stack_apply = TRUE, progress = FALSE,
                          function(df, frac) {
                            weighted.mean(df$value[df$y > 1],
                                          frac[df$y > 1])
                          })

  expect_named(result, c('fun.a', 'fun.b'))
})

test_that('when include_area = TRUE, cell areas are included in output (geographic) and are accurate to 1%', {
  rast <- raster::raster(matrix(1:54000, ncol=360),
                         xmn=-180, xmx=180, ymn=-65, ymx=85,
                         crs='+proj=longlat +datum=WGS84')
  accuracy_pct_tol <- 0.01

  suppressMessages({
    circle <- make_circle(0, 45, 15, crs=st_crs(rast))
  })

  results <- exact_extract(rast, circle, include_cell = TRUE, include_area = TRUE)[[1]]

  expected_areas <- raster::area(rast)[results$cell]
  actual_areas <- results$area / 1e6

  expect_true(all(abs(actual_areas - expected_areas) / expected_areas < accuracy_pct_tol))
})

test_that('when include_area = TRUE, cell areas are included in output (projected)', {
  rast_utm <- make_square_raster(1:100)

  circle <- make_circle(5, 5, 5, crs=st_crs(rast_utm))

  areas <- exact_extract(rast_utm, circle, include_area = TRUE)[[1]]$area
  expect_true(all(areas == 1))
})

test_that('include_cols copies columns from the source data frame to the returned data frames', {
  rast <- make_square_raster(1:100)

  circles <- st_sf(
    fid = c(2, 9),
    size = c('large', 'small'),
    geometry =  c(
    make_circle(5, 4, 2, sf::st_crs(rast)),
    make_circle(3, 1, 1, sf::st_crs(rast))))

  combined_result <- do.call(rbind, exact_extract(rast, circles, include_cols = 'fid', progress = FALSE))
  expect_named(combined_result, c('fid', 'value', 'coverage_fraction'))
})

test_that('When disaggregating values, xy coordinates refer to disaggregated grid', {
  rast <- make_square_raster(1:100)
  rast2 <- raster::disaggregate(rast, 4)

  circle <- make_circle(7.5, 5.5, 0.4, sf::st_crs(rast))

  xy_disaggregated <- exact_extract(rast2, circle, include_xy = TRUE)[[1]][, c('x', 'y')]

  suppressWarnings({
    xy_weighted <- exact_extract(rast, circle, include_xy = TRUE, weights = rast2)[[1]][, c('x', 'y')]
    xy_weighted2 <- exact_extract(rast2, circle, include_xy = TRUE, weights = rast)[[1]][, c('x', 'y')]
  })

  expect_equal(xy_weighted, xy_disaggregated)
  expect_equal(xy_weighted2, xy_disaggregated)
})

test_that('When value and weighting rasters have different grids, cell numbers refer to value raster', {
  anom <- raster(xmn=-180, xmx=180, ymn=-90, ymx=90, res=10)
  values(anom) <- rnorm(length(anom))

  pop <- raster(xmn=-180, xmx=180, ymn=-65, ymx=85, res=5)
  values(pop) <- rlnorm(length(pop))

  circle <- make_circle(17, 21, 18, sf::st_crs(anom))

  suppressWarnings({
    extracted <- exact_extract(anom, circle, weights=pop, include_cell=TRUE)[[1]]
  })

  expect_equal(extracted$value, anom[extracted$cell])
})

test_that('include_ arguments supported with weighted summary function', {
  rast1 <- 5 + make_square_raster(1:100)
  rast2 <- make_square_raster(runif(100))

  circle <- st_sf(
    id = 77,
    make_circle(7.5, 5.5, 4, sf::st_crs(rast1)))

  x <- exact_extract(rast1, circle, function(v, c, w) {
    expect_is(v, 'data.frame')
    expect_named(v, c('value', 'id'))
    expect_true(all(v$id ==  77))

    expect_is(c, 'numeric')
    expect_is(w, 'numeric')
  }, weights=rast2, include_cols = 'id')

  x <- exact_extract(rast1, circle, function(v, c, w) {
    expect_is(v, 'data.frame')
    expect_named(v, c('value', 'id', 'x', 'y', 'cell'))
    expect_true(all(v$id ==  77))
    expect_equal(v$value, rast1[v$cell])
    expect_equal(w, rast2[v$cell])
    expect_equal(v$x, raster::xFromCell(rast1, v$cell))
    expect_equal(v$y, raster::yFromCell(rast1, v$cell))

    expect_is(c, 'numeric')
    expect_is(w, 'numeric')
  }, weights=rast2, include_cols = 'id', include_cell = TRUE, include_xy = TRUE)
})

test_that('we get a zero-row data frame for a polygon not intersecting a raster', {
  # https://github.com/isciences/exactextractr/issues/68

  rast <- raster(matrix(0, nrow = 100, ncol = 100))

  nonoverlap_poly <- st_sf(st_sfc(st_polygon(list(matrix(c(0, 0, 1, 0, 1,
                                                           -0.25, 0, -0.25, 0, 0),
                                                         ncol = 2, byrow = TRUE)))))

  df <- exact_extract(rast, nonoverlap_poly)[[1]]
  expect_named(df, c('value', 'coverage_fraction'))
  expect_equal(nrow(df), 0)

  df <- exact_extract(rast, nonoverlap_poly, include_xy = TRUE)[[1]]
  expect_named(df, c('value', 'x', 'y', 'coverage_fraction'))
  expect_equal(nrow(df), 0)

  df <- exact_extract(rast, nonoverlap_poly, include_cell = TRUE)[[1]]
  expect_named(df, c('value', 'cell', 'coverage_fraction'))
  expect_equal(nrow(df), 0)

  df <- exact_extract(rast, nonoverlap_poly, include_area = TRUE)[[1]]
  expect_named(df, c('value', 'area', 'coverage_fraction'))
  expect_equal(nrow(df), 0)
})

# Copyright (c) 2020-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

context('exact_resample (terra)')

test_that("exact_resample supports SpatRaster arguments", {
  set.seed(123)

  # generate a random raster with a strange extent and resolution
  src <- raster::raster(matrix(runif(10000), nrow=100),
                               xmn=runif(1), xmx=runif(1) + 9,
                               ymn=runif(1), ymx=runif(1) + 9)

  # resample it to a raster with a larger grid with different resolution
  dst <- raster::raster(xmn=0, xmx=10, ymn=0, ymx=10, res=c(1, 2),
                        crs=raster::crs(src))

  dst <- exact_resample(src, dst, 'sum')

  dst_terra <- exact_resample(terra::rast(src), terra::rast(dst), 'sum')

  expect_equal(terra::rast(dst), dst_terra)
})

test_that("resampling can be weighted with coverage areas instead of coverage fractions", {
  r <- terra::rast(nrows = 10, ncols = 10,
                   xmin = 0, xmax = 10, ymin = 60, ymax = 70, crs = 'EPSG:4326')
  terra::values(r) <- seq(1, terra::ncell(r))

  r2 <- terra::rast(nrows = 1, ncols = 1,
                    xmin = 0, xmax = 10, ymin = 60, ymax = 70, crs = 'EPSG:4326')

  unweighted <- exact_resample(r, r2, 'mean')

  area_weighted <- exact_resample(r, r2, 'mean', coverage_area = TRUE)

  expect_true(area_weighted[1] > unweighted[1])
})

test_that("an R function can be used for resampling", {
  r1 <- make_square_rast(1:100)

  r2 <- terra::rast(nrows = 4, ncols = 4,
                    xmin = 0, xmax = 10, ymin = 0, ymax = 10,
                    crs = terra::crs(r1))

  r2_rfun <- exact_resample(r1, r2, function(value, cov_frac) {
    sum(value * cov_frac)
  })

  r2_stat <- exact_resample(r1, r2, 'sum')

  expect_equal(terra::values(r2_rfun),
               terra::values(r2_stat))
})

test_that("a multi-layer SpatRaster can be provided to an R summary function", {
  r1 <- make_square_rast(1:100, crs = 'EPSG:4326')

  r2 <- terra::rast(nrows = 4, ncols = 4,
                    xmin = 0, xmax = 10, ymin = 0, ymax = 10,
                    crs = terra::crs(r1))

  # calculate an area-weighed mean by putting areas in a second layer
  r1_area <- terra::cellSize(r1)
  r1_stk <- terra::rast(list(r1, r1_area))
  result_a <- exact_resample(r1_stk, r2, function(values, coverage_fraction) {
    weighted.mean(values[,1], values[,2] * coverage_fraction)
  })

  # compare this to the more straightforward method of setting coverage_area = TRUE
  result_b <- exact_resample(r1, r2, 'mean', coverage_area = TRUE)

  expect_equal(
    terra::values(result_a),
    terra::values(result_b),
    tolerance = 1e-3
  )

  expect_error(
    exact_resample(r1_stk, r2, 'mean'),
    'must have a single layer'
  )
})

test_that("error thrown if R function returns non-scalar value", {
  r1 <- make_square_rast(1:100)

  r2 <- terra::rast(nrows = 4, ncols = 4,
                    xmin = 0, xmax = 10, ymin = 0, ymax = 10,
                    crs = terra::crs(r1))

  expect_error(
    exact_resample(r1, r2, function(value, cov_frac) {
      return(1:2)
    }),
    'must return a single value'
  )

  expect_error(
    exact_resample(r1, r2, function(value, cov_frac) {
      return(numeric())
    }),
    'must return a single value'
  )

  expect_error(
    exact_resample(r1, r2, function(value, cov_frac) {
      return(NULL)
    }),
    'Not compatible'
  )

  expect_error(
    exact_resample(r1, r2, function(value, cov_frac) {
      'abc'
    }),
    'Not compatible'
  )
})

test_that("error thrown if R function has wrong signature", {
  r1 <- make_square_rast(1:100)

  r2 <- terra::rast(nrows = 4, ncols = 4,
                    xmin = 0, xmax = 10, ymin = 0, ymax = 10,
                    crs = terra::crs(r1))

  expect_error(
    exact_resample(r1, r2, sum),
    'does not appear to be of the form'
  )
})

# Copyright (c) 2020-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

context('exact_resample')

test_that("exact_resample preserves values", {
  set.seed(123)

  # generate a random raster with a strange extent and resolution
  src <- raster::raster(matrix(runif(10000), nrow=100),
                               xmn=runif(1), xmx=runif(1) + 9,
                               ymn=runif(1), ymx=runif(1) + 9)

  # resample it to a raster with a larger grid with different resolution
  dst <- raster::raster(xmn=0, xmx=10, ymn=0, ymx=10, res=c(1, 2),
                        crs=raster::crs(src))

  dst <- exact_resample(src, dst, 'sum')

  # total values should be preserved
  expect_equal(cellStats(src, 'sum'),
               cellStats(dst, 'sum'))

  # resample it to a raster with a larger grid and a smaller resolution
  dst <- raster::raster(xmn=0, xmx=10, ymn=0, ymx=10, res=c(0.01, 0.02),
                        crs=raster::crs(src))

  dst <- exact_resample(src, dst, 'sum')

  # total values should be preserved
  expect_equal(cellStats(src, 'sum'),
               cellStats(dst, 'sum'))
})

test_that("error thrown if multiple or no stats provided", {
  src <- make_square_raster(1:100)
  dst <- make_square_raster(1:4)

  expect_error(
    exact_resample(src, dst, c('sum', 'mean')),
    'Only a single')

  expect_error(
    exact_resample(src, dst, character()),
    'Only a single')
})

test_that("error thrown if weighted stat provided", {
  r <- raster::raster(resolution = 2)
  target <- raster::shift(r, 2.5, 1)

  expect_error(
    exact_resample(r, target, fun = "weighted_mean"),
    'cannot be used for resampling'
  )
})

test_that("error thrown if rasters have different CRS", {
  src <- make_square_raster(1:100, crs='+init=epsg:4326')
  dst <- make_square_raster(1:100, crs='+init=epsg:4269')

  expect_error(
    exact_resample(src, dst, 'sum'),
    'same CRS')
})

test_that("warning raised if one CRS undefined", {
  a <- make_square_raster(1:100, crs='+init=epsg:4326')
  b <- make_square_raster(1:100, crs=NA)

  expect_warning(
    exact_resample(a, b, 'sum'),
    'No CRS specified for destination'
  )

  expect_warning(
    exact_resample(b, a, 'sum'),
    'No CRS specified for source'
  )
})

test_that("stats requiring stored values can be used", {
  # https://github.com/isciences/exactextractr/issues/47

  r <- raster::raster(resolution = 2)
  target <- raster::shift(r, 2.5, 1)

  set.seed(1111)
  raster::values(r) = as.integer(round(rnorm(raster::ncell(r), 0, 1)))

  vals <- unique(raster::getValues(r))
  mode_vals <- sort(unique(raster::getValues(exactextractr::exact_resample(r, target, fun = "mode"))))

  expect_true(length(mode_vals) > 1)
  expect_true(all(mode_vals %in% vals))
})

# Copyright (c) 2021-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License ta http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

library(testthat)
library(exactextractr)
context('exact_extract (terra)')

test_that('terra inputs supported (single layer)', {
  ras <- make_square_raster(1:100)

  terra_ras <- terra::rast(ras)

  circ <- make_circle(3, 2, 4, sf::st_crs(ras))

  expect_equal(
    exact_extract(ras, circ),
    exact_extract(terra_ras, circ)
  )

  expect_equal(
    exact_extract(ras, circ, 'mean'),
    exact_extract(terra_ras, circ, 'mean')
  )

  expect_equal(
    exact_extract(ras, circ, weighted.mean),
    exact_extract(terra_ras, circ, weighted.mean)
  )
})

test_that('terra inputs supported (single layer, weighted)', {
  ras <- make_square_raster(1:100)
  ras_w <- sqrt(ras)

  terra_ras <- terra::rast(ras)
  terra_ras_w <- terra::rast(ras_w)

  circ <- make_circle(3, 2, 4, sf::st_crs(ras))

  expect_equal(
    exact_extract(ras, circ, weights = ras_w),
    exact_extract(terra_ras, circ, weights = terra_ras_w)
  )

  expect_equal(
    exact_extract(ras, circ, 'weighted_mean', weights = ras_w),
    exact_extract(terra_ras, circ, 'weighted_mean', weights = terra_ras_w)
  )

  # mixed inputs supported: terra values, raster weights
  expect_equal(
    exact_extract(ras, circ, 'weighted_mean', weights = ras_w),
    exact_extract(terra_ras, circ, 'weighted_mean', weights = ras_w)
  )

  # mixed inputs supported: raster values, terra weights
  expect_equal(
    exact_extract(ras, circ, 'weighted_mean', weights = ras_w),
    exact_extract(ras, circ, 'weighted_mean', weights = terra_ras_w)
  )

  expect_equal(
    exact_extract(ras, circ, weighted.mean),
    exact_extract(terra_ras, circ, weighted.mean)
  )
})


test_that('terra inputs supported (multi-layer)', {
  stk <- raster::stack(list(a = make_square_raster(1:100),
                            b = make_square_raster(101:200)))

  terra_stk <- terra::rast(stk)

  circ <- make_circle(3, 2, 4, sf::st_crs(stk))

  expect_equal(
    exact_extract(stk, circ, 'mean'),
    exact_extract(terra_stk, circ, 'mean')
  )

  expect_equal(
    exact_extract(stk, circ),
    exact_extract(terra_stk, circ)
  )
})

test_that('terra inputs supported (weighted, multi-layer)', {
  stk <- raster::stack(list(a = make_square_raster(1:100),
                            a = make_square_raster(101:200)))
  stk <- terra::rast(stk)
  names(stk) <- c('a', 'a')

  ras <- terra::rast(make_square_raster(runif(100)))
  ras <- terra::disagg(ras, 2)

  circ <- make_circle(3, 2, 4, sf::st_crs(ras))

  expect_error(
    exact_extract(stk, circ, 'mean'),
    'names.*must be unique'
  )
})

test_that('include_* arguments supported for terra inputs', {
  ras <- make_square_raster(1:100)

  terra_ras <- terra::rast(ras)

  circ <- make_circle(3, 2, 4, sf::st_crs(ras))

  expect_equal(
    exact_extract(terra_ras, circ, include_cell = TRUE, include_xy = TRUE),
    exact_extract(ras, circ, include_cell = TRUE, include_xy = TRUE)
  )
})

# Copyright (c) 2018-2021 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License ta http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

library(testthat)
library(exactextractr)
context('exact_extract')

test_that("Basic stat functions work", {
  # This test just verifies a successful journey from R
  # to C++ and back. The correctness of the algorithm
  # is tested at the C++ level.
  data <- matrix(1:9, nrow=3, byrow=TRUE)
  rast <- raster::raster(data,
                         xmn=0, xmx=3, ymn=0, ymx=3,
                         crs='+proj=longlat +datum=WGS84')

  square <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(rast))

  dat <- exact_extract(rast, square)

  # Calling without a function returns a data frame with values and coverage fractions
  expect_equal(dat[[1]],
    data.frame(value=1:9,
               coverage_fraction=c(0.25, 0.5, 0.25, 0.5, 1, 0.5, 0.25, 0.5, 0.25))
  )

  # Calling with a function(w, v) returns the result of the function
  expect_equal(exact_extract(rast, square, fun=weighted.mean),
               5)

  # Calling with a string computes a named operation from the C++ library
  expect_equal(exact_extract(rast, square, fun='count'), 4)
  expect_equal(exact_extract(rast, square, fun='mean'), 5)
  expect_equal(exact_extract(rast, square, fun='median'), 5)
  expect_equal(exact_extract(rast, square, fun='quantile', quantiles=0.25), 3.5)
  expect_equal(exact_extract(rast, square, fun='quantile', quantiles=0.75), 6.5)
  expect_equal(exact_extract(rast, square, fun='min'), 1)
  expect_equal(exact_extract(rast, square, fun='max'), 9)
  expect_equal(exact_extract(rast, square, fun='mode'), 5)
  expect_equal(exact_extract(rast, square, fun='majority'), 5)
  expect_equal(exact_extract(rast, square, fun='minority'), 1)
  expect_equal(exact_extract(rast, square, fun='variety'), 9)
  expect_equal(exact_extract(rast, square, fun='variance'), 5)
  expect_equal(exact_extract(rast, square, fun='stdev'), sqrt(5))
  expect_equal(exact_extract(rast, square, fun='coefficient_of_variation'), sqrt(5)/5)

  # Can also do multiple stats at once
  expect_equal(exact_extract(rast, square, fun=c('min', 'max', 'mode')),
               data.frame(min=1, max=9, mode=5))

  expect_equal(exact_extract(rast, c(square, square), fun=c('min', 'max', 'mode'), progress = FALSE),
               data.frame(min=c(1, 1), max=c(9, 9), mode=c(5, 5)))
})

test_that('Weighted stat functions work', {
  data <- matrix(1:9, nrow=3, byrow=TRUE)
  rast <- raster::raster(data,
                         xmn=0, xmx=3, ymn=0, ymx=3,
                         crs='+proj=longlat +datum=WGS84')

  equal_weights <- raster::raster(matrix(1, nrow=3, ncol=3),
                                  xmn=0, xmx=3, ymn=0, ymx=3,
                                  crs='+proj=longlat +datum=WGS84')

  bottom_row_only <- raster::raster(rbind(c(0, 0, 0), c(0, 0, 0), c(1, 1, 1)),
                                    xmn=0, xmx=3, ymn=0, ymx=3,
                                    crs='+proj=longlat +datum=WGS84')

  square <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(rast))

  # equal weights
  expect_equal(exact_extract(rast, square, 'weighted_mean', weights=equal_weights),
               exact_extract(rast, square, 'mean'))

  expect_equal(exact_extract(rast, square, 'weighted_sum', weights=equal_weights),
               exact_extract(rast, square, 'sum'))

  expect_equal(exact_extract(rast, square, 'weighted_stdev', weights=equal_weights),
               exact_extract(rast, square, 'stdev'))

  expect_equal(exact_extract(rast, square, 'weighted_variance', weights=equal_weights),
               exact_extract(rast, square, 'variance'))

  # unequal weights
  expect_equal(exact_extract(rast, square, 'weighted_mean', weights=bottom_row_only),
               (0.25*7 + 0.5*8 + 0.25*9)/(0.25 + 0.5 + 0.25))

  expect_equal(exact_extract(rast, square, 'weighted_sum', weights=bottom_row_only),
               (0.25*7 + 0.5*8 + 0.25*9))

  expect_equal(exact_extract(rast, square, 'weighted_stdev', weights=bottom_row_only),
               0.7071068, tolerance = 1e-7) # Weighted.Desc.Stat::w.sd(x = c(7, 8, 9), mu = c(0.25, 0.5, 0.25)))

  expect_equal(exact_extract(rast, square, 'weighted_variance', weights=bottom_row_only),
               0.5) # Weighted.Desc.Stat::w.var(x = c(7, 8, 9), mu = c(0.25, 0.5, 0.25)))
})

test_that('Grouped stat functions work', {
  rast <- raster::raster(matrix(rep(1:3, each = 3), nrow=3, byrow=TRUE),
                         xmn=0, xmx=3, ymn=0, ymx=3,
                         crs='+proj=longlat +datum=WGS84')

  weights <- raster::raster(matrix(rep(3:1, each = 3), nrow = 3, byrow=TRUE),
                            xmn=0, xmx=3, ymn=0, ymx=3,
                            crs='+proj=longlat +datum=WGS84')


  square1 <- make_rect(0.5, 0.5, 1.0, 1.0, sf::st_crs(rast))
  square2 <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(rast))

  squares <- c(square1, square2)

  expect_equal(
    exact_extract(rast, squares, c('count', 'frac'), progress = FALSE),
    rbind(
      data.frame(count = 0.25, frac_1 = 0,    frac_2 = 0,   frac_3 = 1.00),
      data.frame(count = 4.00, frac_1 = 0.25, frac_2 = 0.5, frac_3 = 0.25)))

  expect_equal(
    exact_extract(rast, squares, c('weighted_frac', 'sum'), weights = weights, progress = FALSE),
    rbind(
      data.frame(weighted_frac_1 =     0, weighted_frac_2 =   0, weighted_frac_3 =     1, sum = 0.75),
      data.frame(weighted_frac_1 = 0.375, weighted_frac_2 = 0.5, weighted_frac_3 = 0.125, sum = 8)
    ))
})

test_that('Grouped stat functions work (multilayer)', {
  rast <- raster::raster(matrix(rep(1:3, each = 3), nrow=3, byrow=TRUE),
                         xmn=0, xmx=3, ymn=0, ymx=3,
                         crs='+proj=longlat +datum=WGS84')
  rast <- raster::stack(list(a = rast, b = rast + 1))

  weights <- raster::raster(matrix(rep(3:1, each = 3), nrow = 3, byrow=TRUE),
                            xmn=0, xmx=3, ymn=0, ymx=3,
                            crs='+proj=longlat +datum=WGS84')

  square1 <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(rast))
  square2 <- make_rect(0.5, 0.5, 1.0, 1.0, sf::st_crs(rast))
  squares <- c(square1, square2)

  stats <- c('count', 'frac', 'quantile')
  quantiles <- c(0.25, 0.75)

  single_layer_a <- exact_extract(rast[['a']], squares, stats, quantiles = quantiles, progress = FALSE)
  single_layer_b <- exact_extract(rast[['b']], squares, stats, quantiles = quantiles, progress = FALSE)
  multi_layer <- exact_extract(rast, squares, stats, quantiles = quantiles, progress = FALSE)

  # for each layer (a, b) we get a column with the coverage fraction of each
  # value that occurs in a OR b. If a value does not occur for a given layer,
  # the values in its associated column will be zero.
  for (col in unique(c(names(single_layer_a), names(single_layer_b)))) {
    if (col %in% names(single_layer_a)) {
      expect_equal(single_layer_a[[col]], multi_layer[[paste(col, 'a', sep='.')]])
    } else {
      expect_equal(c(0, 0), multi_layer[[paste(col, 'a', sep='.')]])
    }

    if (col %in% names(single_layer_b)) {
      expect_equal(single_layer_b[[col]], multi_layer[[paste(col, 'b', sep='.')]])
    } else {
      expect_equal(c(0, 0), multi_layer[[paste(col, 'b', sep='.')]])
    }
  }
})

test_that('Raster NA values are correctly handled', {
  data <- matrix(1:100, nrow=10, byrow=TRUE)
  data[7:10, 1:4] <- NA # cut out lower-left corner
  rast <- raster::raster(data,
                         xmn=0, xmx=10, ymn=0, ymx=10,
                         crs='+proj=longlat +datum=WGS84')

  # check polygon entirely within NA region
  circ <- sf::st_sfc(sf::st_buffer(sf::st_point(c(2,2)), 0.9),
                     crs=sf::st_crs(rast))

  expect_equal(0, exact_extract(rast, circ, 'count'))
  expect_equal(NA_real_, exact_extract(rast, circ, 'mean'))
  expect_equal(NA_real_, exact_extract(rast, circ, weighted.mean))

  # check polygon partially within NA region
  square <- make_rect(3.5, 3.5, 4.5, 4.5, sf::st_crs(rast))

  expect_equal(43.5, exact_extract(rast, square, 'sum'))
  expect_equal(NA_real_, exact_extract(rast, square, weighted.mean))
  expect_equal(58, exact_extract(rast, square, weighted.mean, na.rm=TRUE))
})

test_that('MultiPolygons also work', {
  data <- matrix(1:100, nrow=10, byrow=TRUE)
  rast <- raster::raster(data,
                         xmn=0, xmx=10, ymn=0, ymx=10,
                         crs='+proj=longlat +datum=WGS84')

  multipoly <- sf::st_sfc(
    sf::st_multipolygon(list(
      sf::st_polygon(
        list(
          matrix(
            c(0.5, 0.5, 2.5, 0.5, 2.5, 2.5, 0.5, 2.5, 0.5, 0.5),
            ncol=2,
            byrow=TRUE))),
      sf::st_polygon(
        list(
          matrix(
            4 + c(0.5, 0.5, 2.5, 0.5, 2.5, 2.5, 0.5, 2.5, 0.5, 0.5),
            ncol=2,
            byrow=TRUE))))),
    crs=sf::st_crs(rast))

  expect_equal(exact_extract(rast, multipoly, fun='variety'), 18)
})

test_that('sp inputs supported', {
  rast <- make_square_raster(1:100)

  circles <- c(
    make_circle(3, 2, 4, sf::st_crs(rast)),
    make_circle(7, 7, 2, sf::st_crs(rast))
  )
  circles_sf <- sf::st_sf(id = 1:2, geometry = circles)

  result <- exact_extract(rast, circles, 'mean', progress = FALSE)

  # SpatialPolygons
  circles_sp <- sf::as_Spatial(circles)
  result_sp <- exact_extract(rast, circles_sp, 'mean', progress = FALSE)
  expect_equal(result, result_sp)

  # SpatialPolygonsDataFrame
  circles_spdf <- sf::as_Spatial(circles_sf)
  result_spdf <- exact_extract(rast, circles_spdf, 'mean', progress = FALSE)
  expect_equal(result, result_spdf)
})

test_that('Generic sfc_GEOMETRY works if the features are polygonal', {
  rast <- make_square_raster(1:100)
  polys <- st_as_sfc(c('POLYGON ((0 0, 2 0, 2 2, 0 2, 0 0))',
                       'MULTIPOLYGON (((2 2, 4 2, 4 4, 2 4, 2 2)), ((4 4, 8 4, 8 8, 4 8, 4 4)))'),
                     crs=sf::st_crs(rast))

  expect_equal(exact_extract(rast, polys, 'count', progress = FALSE),
               c(4, 4+16))
})

test_that('GeometryCollections are supported if they are polygonal', {
  rast <- make_square_raster(1:100)
  gc <- st_as_sfc('GEOMETRYCOLLECTION( POLYGON ((0 0, 2 0, 2 2, 0 2, 0 0)), POLYGON ((2 2, 4 2, 4 4, 2 4, 2 2)))',
                  crs = st_crs(rast))

  mp <- st_as_sfc('MULTIPOLYGON (((0 0, 2 0, 2 2, 0 2, 0 0)), ((2 2, 4 2, 4 4, 2 4, 2 2)))',
                  crs = st_crs(rast))

  expect_equal(
    exact_extract(rast, gc),
    exact_extract(rast, mp)
  )
})

test_that('We ignore portions of the polygon that extend outside the raster', {
  rast <- raster::raster(matrix(1:(360*720), nrow=360),
                         xmn=-180, xmx=180, ymn=-90, ymx=90,
                         crs='+proj=longlat +datum=WGS84')

  rect <- make_rect(179.5, 0, 180.5, 1, sf::st_crs(rast))

  cells_included <- exact_extract(rast, rect, include_xy=TRUE)[[1]][, c('x', 'y')]

  expect_equal(cells_included,
               data.frame(x=179.75, y=c(0.75, 0.25)),
               check.attributes=FALSE)


  index_included <- exact_extract(rast, rect, include_xy=TRUE, include_cell = TRUE)[[1]][, c('x', 'y', 'cell')]
  expect_equivalent(as.matrix(cells_included[c("x", "y")]),
               raster::xyFromCell(rast, index_included$cell))
  expect_equal(index_included$cell,
               raster::cellFromXY(rast, cbind(cells_included$x, cells_included$y)))
})

test_that('Additional arguments can be passed to fun', {
  data <- matrix(1:9, nrow=3, byrow=TRUE)
  rast <- raster::raster(data,
                         xmn=0, xmx=3, ymn=0, ymx=3,
                         crs='+proj=longlat +datum=WGS84')

  square <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(rast))

  exact_extract(rast, square, function(x, w, custom) {
    expect_equal(custom, 6)
  }, progress=FALSE, 6)
})

test_that('We can extract values from a RasterStack', {
  rast <- raster::raster(matrix(1:16, nrow=4, byrow=TRUE),
                         xmn=0, xmx=4, ymn=0, ymx=4,
                         crs='+proj=longlat +datum=WGS84')

  stk <- raster::stack(rast, sqrt(rast))

  square <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(rast))

  extracted <- exact_extract(stk, square)[[1]]

  expect_equal(names(extracted),
               c('layer.1', 'layer.2', 'coverage_fraction'))
  expect_equal(extracted[, 'layer.2'],
               sqrt(extracted[, 'layer.1']))
  expect_equal(extracted[extracted$coverage_fraction==0.25, 'layer.1'],
               c(5, 7, 13, 15))
  expect_equal(extracted[extracted$coverage_fraction==0.50, 'layer.1'],
               c(6, 9, 11, 14))
  expect_equal(extracted[extracted$coverage_fraction==1.00, 'layer.1'],
               10)
})

test_that('We can pass extracted RasterStack values to an R function', {
  population <- raster::raster(matrix(1:16, nrow=4, byrow=TRUE),
                               xmn=0, xmx=4, ymn=0, ymx=4,
                               crs='+proj=longlat +datum=WGS84')
  income <- sqrt(population)

  square <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(population))

  mean_income <- exact_extract(raster::stack(list(population=population, income=income)), square, function(vals, weights) {
    weighted.mean(vals[, 'population']*vals[, 'income'], weights)
  })

  expect_equal(mean_income, 32.64279, tolerance=1e-5)
})

test_that('We can pass extracted RasterStack values to a C++ function', {
  rast <- raster::raster(matrix(runif(16), nrow=4),
                         xmn=0, xmx=4, ymn=0, ymx=4,
                         crs='+proj=longlat +datum=WGS84')

  square <- make_rect(0.5, 0.5, 2.5, 2.5, sf::st_crs(rast))

  stk <- raster::stack(list(a=rast, b=sqrt(rast)))
  brk <- raster::brick(stk)

  for (input in c(stk, brk)) {
    expect_equal(
      exact_extract(input, square, 'variety'),
      data.frame(variety.a=9, variety.b=9)
    )

    twostats <- exact_extract(input, square, c('variety', 'mean'))

    expect_equal(nrow(twostats), 1)
    expect_named(twostats, c('variety.a', 'variety.b', 'mean.a', 'mean.b'))
  }
})

test_that('We can apply the same function to each layer of a RasterStack', {
  set.seed(123)

  stk <- raster::stack(list(a = make_square_raster(runif(100)),
                            b = make_square_raster(runif(100))))

  circles <- c(
    make_circle(5, 4, 2, sf::st_crs(stk)),
    make_circle(3, 1, 1, sf::st_crs(stk)))

  # by default layers are processed together
  expect_error(
    exact_extract(stk, circles, weighted.mean, progress=FALSE),
    'must have the same length'
  )

  # but we can process them independently with stack_apply
  means <- exact_extract(stk, circles, weighted.mean, progress=FALSE, stack_apply=TRUE)

  expect_named(means, c('weighted.mean.a', 'weighted.mean.b'))

  # results are same as we would get by processing layers independently
  for (i in 1:raster::nlayers(stk)) {
    expect_equal(means[, i], exact_extract(stk[[i]], circles, weighted.mean, progress=FALSE))
  }
})

test_that('Layers of a RasterBrick can be processed independently with stack_apply', {
  # https://github.com/isciences/exactextractr/issues/54

  data <- matrix(1:100, nrow=10, byrow=TRUE)
  data[7:10, 1:4] <- NA # cut out lower-left corner
  rast <- raster::raster(
    data,
    xmn=0, xmx=10, ymn=0, ymx=10,
    crs='+proj=longlat +datum=WGS84'
  )
  rast_brick <- brick(rast, rast)
  square <- make_rect(3.5, 3.5, 4.5, 4.5, sf::st_crs(rast))

  expect_equal(
    exact_extract(rast_brick, square, weighted.mean, stack_apply = T),
    data.frame(weighted.mean.layer.1 = NA_real_,
               weighted.mean.layer.2 = NA_real_))
})

test_that('We can summarize a RasterStack / RasterBrick using weights from a RasterLayer', {
  set.seed(123)

  stk <- raster::stack(list(a = make_square_raster(1:100),
                            b = make_square_raster(101:200)))

  weights <- make_square_raster(runif(100))


  circle <- make_circle(5, 4, 2, sf::st_crs(stk))

  # same weights get used for both
  expect_equal(exact_extract(stk, circle, 'weighted_mean', weights=weights),
               data.frame(weighted_mean.a = 63.0014,
                          weighted_mean.b = 163.0014),
               tolerance=1e-6)

  # error when trying to use a non-raster as weights
  expect_error(exact_extract(stk, circle, 'weighted_mean', weights='stk'),
               "Weights must be a Raster")
})

test_that('We get acceptable default values when processing a polygon that does
           not intersect the raster', {
  rast <- raster::raster(matrix(runif(100), nrow=5),
                         xmn=-180, xmx=180, ymn=-65, ymx=85,
                         crs='+proj=longlat +datum=WGS84') # extent of GPW

  poly <- make_rect(-180, -90, 180, -65.5, sf::st_crs(rast)) # extent of Antarctica in Natural Earth

  # RasterLayer
  expect_equal(list(data.frame(value=numeric(), coverage_fraction=numeric())),
               exact_extract(rast, poly))

  expect_equal(list(data.frame(value=numeric(),
                               x=numeric(),
                               y=numeric(),
                               cell=numeric(),
                               coverage_fraction=numeric())),
               exact_extract(rast, poly, include_xy=TRUE, include_cell=TRUE))

  expect_equal(0, exact_extract(rast, poly, function(x, c) sum(x)))
  expect_equal(0, exact_extract(rast, poly, 'count'))
  expect_equal(0, exact_extract(rast, poly, 'sum'))
  expect_equal(0, exact_extract(rast, poly, 'variety'))
  expect_equal(NA_real_, exact_extract(rast, poly, 'majority'))
  expect_equal(NA_real_, exact_extract(rast, poly, 'minority'))
  expect_equal(NA_real_, exact_extract(rast, poly, 'minority'))
  expect_equal(NA_real_, exact_extract(rast, poly, 'mean'))
  expect_equal(NA_real_, exact_extract(rast, poly, 'min'))
  expect_equal(NA_real_, exact_extract(rast, poly, 'max'))

  # RasterStack
  rast2 <- as.integer(rast)
  raster::dataType(rast2) <- 'INT4S'

  stk <- raster::stack(list(q=rast, xi=rast2, area=raster::area(rast)))

  expect_equal(list(data.frame(q=numeric(), xi=integer(), area=numeric(), coverage_fraction=numeric())),
               exact_extract(stk, poly))

  expect_equal(list(data.frame(q=numeric(),
                               xi=integer(),
                               area=numeric(),
                               x=numeric(),
                               y=numeric(),
                               cell=numeric(),
                               coverage_fraction=numeric())),
               exact_extract(stk, poly, include_xy=TRUE, include_cell=TRUE))

  exact_extract(stk, poly, function(values, cov) {
    expect_equal(values, data.frame(q=numeric(), xi=integer(), area=numeric()))
    expect_equal(cov, numeric())
  })
})

test_that('Coverage area can be output instead of coverage fraction (projected)', {
  rast_utm <- disaggregate(make_square_raster(1:100), c(2, 3))

  circle <- make_circle(5, 5, 5, crs=st_crs(rast_utm))

  df_frac <- exact_extract(rast_utm, circle, include_area = TRUE)[[1]]

  df_area <- exact_extract(rast_utm, circle, coverage_area = TRUE)[[1]]
  expect_named(df_area, c('value', 'coverage_area'))

  expect_equal(df_frac$coverage_fraction * df_frac$area,
               df_area$coverage_area)
})

test_that('Coverage area can be output instead of coverage fraction (geographic)', {
  rast <- raster::raster(matrix(1:54000, ncol=360),
                         xmn=-180, xmx=180, ymn=-65, ymx=85,
                         crs='+proj=longlat +datum=WGS84')

  suppressMessages({
    circle <- make_circle(0, 45, 15, crs=st_crs(rast))
  })

  df_frac <- exact_extract(rast, circle, include_area = TRUE)[[1]]

  df_area <- exact_extract(rast, circle, coverage_area = TRUE)[[1]]

  expect_equal(df_frac$coverage_fraction * df_frac$area,
               df_area$coverage_area)
})

test_that('coverage_area argument can be used with named summary operations', {
  rast1 <- raster(matrix(1:54000, ncol=360),
                  xmn=-180, xmx=180, ymn=-65, ymx=85,
                  crs='+proj=longlat +datum=WGS84')
  rast2 <- sqrt(rast1)

  suppressMessages({
    circle <- make_circle(0, 45, 15, crs=st_crs(rast1))
  })

  # using only area as weighting
  expect_equal(exact_extract(rast1, circle, 'weighted_mean', weights = 'area'),
               exact_extract(rast1, circle, 'mean', coverage_area = TRUE))

  # using area x weight as weighting
  expect_equal(
    exact_extract(rast1, circle, 'weighted_mean', weights = rast2, coverage_area = TRUE),

    exact_extract(rast1, circle, fun = function(x, cov, w) {
      weighted.mean(x, cov * w$rast2 * w$area)
    }, weights = stack(list(rast2 = rast2, area = area(rast2)))),

    tol = 1e-2
  )
})

test_that('We can weight with cell areas (projected coordinates)', {
  rast_utm <- raster(matrix(1:100, ncol=10),
                     xmn=0, xmx=5,
                     ymn=0, ymx=5,
                     crs='+init=epsg:26918')
  circle1 <- make_circle(5, 5, 5, crs=st_crs(rast_utm))

  # for projected (Cartesian coordinates), means with cell area and
  # coverage fraction are the same
  expect_equal(exact_extract(rast_utm, circle1, 'mean'),
               exact_extract(rast_utm, circle1, 'weighted_mean', weights='area'))

  # same result with R summary function
  expect_equal(
    exact_extract(rast_utm, circle1, 'weighted_mean', weights='area'),
    exact_extract(rast_utm, circle1, function(x,c,w) {
      weighted.mean(x, c*w)
    }, weights='area'),
    1e-5
  )

  # name doesn't pop out in data frame columns
  expect_named(
    exact_extract(rast_utm, circle1, c('sum', 'weighted_mean'), weights='area', force_df = TRUE),
    c('sum', 'weighted_mean'))

  # sums differ by the cell area
  expect_equal(prod(res(rast_utm)) * exact_extract(rast_utm, circle1, 'sum'),
               exact_extract(rast_utm, circle1, 'weighted_sum', weights='area'))

  # when using area weighting, disaggregating does not affect the sum
  expect_equal(exact_extract(rast_utm, circle1, 'weighted_sum', weights='area'),
               exact_extract(disaggregate(rast_utm, 8), circle1, 'weighted_sum', weights='area'))
})

test_that('We can weight with cell areas (geographic coordinates)', {
  rast <- raster::raster(matrix(1:54000, ncol=360),
                         xmn=-180, xmx=180, ymn=-65, ymx=85,
                         crs='+proj=longlat +datum=WGS84')

  accuracy_pct_tol <- 0.01

  suppressMessages({
    circle <- make_circle(0, 45, 15, crs=st_crs(rast))
  })

  # result is reasonably close to what we get with raster::area, which uses
  # a geodesic calculation
  expected <- exact_extract(rast, circle, 'weighted_sum', weights = area(rast) * 1e6)
  actual <- exact_extract(rast, circle, 'weighted_sum', weights = 'area')

  expect_true(abs(actual - expected) / expected < accuracy_pct_tol)
})

test_that('Correct results obtained when max_cells_in_memory is limited', {
  rast <- make_square_raster(1:100)
  poly <- make_circle(5, 5, 3, sf::st_crs(rast))

  expect_equal(exact_extract(rast, poly, 'mean'),
               exact_extract(rast, poly, 'mean', max_cells_in_memory=1))
})

test_that('Weighted stats work when polygon is contained in weight raster but
          only partially contained in value raster', {
  values <- raster(matrix(1:15, nrow=3, ncol=5, byrow=TRUE),
                   xmn=0, xmx=5, ymn=2, ymx=5)
  weights <- raster(sqrt(matrix(1:25, nrow=5, ncol=5, byrow=TRUE)),
                    xmn=0, xmx=5, ymn=0, ymx=5)
  poly <- make_circle(2.1, 2.1, 1, NA_real_)

  value_tbl <- exact_extract(values, poly, include_xy=TRUE)[[1]]
  weight_tbl <- exact_extract(weights, poly, include_xy=TRUE)[[1]]

  tbl <- merge(value_tbl, weight_tbl, by=c('x', 'y'))

  expect_equal(
    exact_extract(values, poly, 'weighted_mean', weights=weights),
    weighted.mean(tbl$value.x, tbl$coverage_fraction.x * tbl$value.y),
    tol=1e-6
  )
})

test_that('When part of a polygon is within the value raster but not the
           weighting raster, values for unweighted stats requested at the
           same time as weighted stats are correct', {

  values <- raster(matrix(1:25, nrow=5, ncol=5, byrow=TRUE),
                    xmn=0, xmx=5, ymn=0, ymx=5)
  weights <- raster(sqrt(matrix(1:15, nrow=3, ncol=5, byrow=TRUE)),
                   xmn=0, xmx=5, ymn=2, ymx=5)
  poly <- make_circle(2.1, 2.1, 1, NA_real_)

  expect_equal(
    exact_extract(values, poly, 'sum'),
    exact_extract(values, poly, c('sum', 'weighted_mean'), weights=weights)$sum
  )
})

test_that('When polygon is entirely outside the value raster and entirely
           within the weighting raster, we get NA instead of an exception', {
  values <- raster(matrix(1:25, nrow=5, ncol=5, byrow=TRUE),
                    xmn=5, xmx=10, ymn=5, ymx=10)
  weights <- raster(matrix(1:10, nrow=10, ncol=10, byrow=TRUE),
                   xmn=0, xmx=10, ymn=0, ymx=10)
  poly <- make_circle(2.1, 2.1, 1, NA_real_)

  expect_equal(NA_real_,
               exact_extract(values, poly, 'weighted_mean', weights=weights))
})

test_that('Z dimension is ignored, if present', {
  # see https://github.com/isciences/exactextractr/issues/26
  poly <- st_as_sfc('POLYGON Z ((1 1 0, 4 1 0, 4 4 0, 1 1 0))')
  values <- raster(matrix(1:25, nrow=5, ncol=5, byrow=TRUE),
                   xmn=0, xmx=5, ymn=0, ymx=5)

  expect_equal(exact_extract(values, poly, 'sum'), 70.5) # CPP code path
  expect_equal(exact_extract(values, poly, function(x,f) sum(x*f)), 70.5) # R code path
})

test_that('No error thrown when weighting with different resolution grid (regression)', {
   poly <- st_as_sfc(structure(list(
     '01060000000200000001030000000100000008000000065bb0055b7866401c222222223233c0454444242e776640338ee338842d33c0abaaaacac0776640338ee338962733c0676666469f776640a4aaaaaa362033c03a8ee3784f7866404f555555a41c33c0a64ffa840b7966406c1cc771522133c0454444645a796640f4a44ffa9c2b33c0065bb0055b7866401c222222223233c0010300000001000000080000004b9ff4499f7c6640a3aaaaaaaaaa32c0bdbbbb3b747a6640f8ffff7f549632c0ea933e09aa7b664004b6608b399132c0b1055bb0637e6640dc388e63278f32c0d9822d58827e6640dc388ee3109432c09a999979837c6640590bb660159c32c0676666867c7d664070777777039c32c04b9ff4499f7c6640a3aaaaaaaaaa32c0'),
     class='WKB'), EWKB=TRUE)

   v <- raster(matrix(1:360*720, nrow=360, ncol=720),
               xmn=-180, xmx=180, ymn=-90, ymx=90)

   w <- raster(matrix(1:360*720*36, nrow=360*6, ncol=720*6),
               xmn=-180, xmx=180, ymn=-90, ymx=90)

   exact_extract(v, poly, 'weighted_sum', weights=w)
   succeed()
})

test_that('when force_df = TRUE, exact_extract always returns a data frame', {
  rast <- make_square_raster(1:100)
  names(rast) <- 'z'
  poly <- c(make_circle(5, 5, 3, sf::st_crs(rast)),
            make_circle(3, 1, 1, sf::st_crs(rast)))

  vals <- exact_extract(rast, poly, 'mean', progress=FALSE)

  # named summary operation
  vals_df <- exact_extract(rast, poly, 'mean', force_df=TRUE, progress=FALSE)
  expect_s3_class(vals_df, 'data.frame')
  expect_equal(vals, vals_df[['mean']])

  # R function
  vals2_df <- exact_extract(rast, poly, weighted.mean, force_df=TRUE, progress=FALSE)
  expect_s3_class(vals2_df, 'data.frame')
  expect_equal(vals, vals2_df[['result']], tol=1e-6)
})

test_that('We can have include the input raster name in column names even if
           the input raster has only one layer', {
  rast <- make_square_raster(1:100)
  names(rast) <- 'z'
  poly <- c(make_circle(5, 5, 3, sf::st_crs(rast)),
            make_circle(3, 1, 1, sf::st_crs(rast)))

  vals <- exact_extract(rast, poly, c('mean', 'sum'), progress=FALSE)
  expect_named(vals, c('mean', 'sum'))

  # named summary operations
  vals_named <- exact_extract(rast, poly, c('mean', 'sum'), full_colnames=TRUE, progress=FALSE)
  expect_named(vals_named, c('mean.z', 'sum.z'))
})

test_that('We can summarize a categorical raster by returning a data frame from a custom function', {
  set.seed(456) # smaller circle does not have class 5

  classes <- c(1, 2, 3, 5)

  rast <- raster::raster(xmn = 0, xmx = 10, ymn = 0, ymx = 10, res = 1)
  values(rast) <- sample(classes, length(rast), replace = TRUE)

  circles <- c(
    make_circle(5, 4, 2, sf::st_crs(rast)),
    make_circle(3, 1, 1, sf::st_crs(rast)))

  # approach 1: classes known in advance
  result <- exact_extract(rast, circles, function(x, c) {
    row <- lapply(classes, function(cls) sum(c[x == cls]))
    names(row) <- paste('sum', classes, sep='_')
    do.call(data.frame, row)
  }, progress = FALSE)

  expect_named(result, c('sum_1', 'sum_2', 'sum_3', 'sum_5'))

  # check a single value
  expect_equal(result[2, 'sum_3'],
               exact_extract(rast, circles[2], function(x, c) {
                sum(c[x == 3])
               }))

  if (requireNamespace('dplyr', quietly = TRUE)) {
    # approach 2: classes not known in advance (requires dplyr::bind_rows)
    result2 <- exact_extract(rast, circles, function(x, c) {
      found_classes <- unique(x)
      row <- lapply(found_classes, function(cls) sum(c[x == cls]))
      names(row) <- paste('sum', found_classes, sep='_')
      do.call(data.frame, row)
    }, progress = FALSE)

    for (colname in names(result)) {
      expect_equal(result[[colname]], dplyr::coalesce(result2[[colname]], 0))
    }
  }
})

test_that('We can append columns from the source data frame in the results', {
  rast <- make_square_raster(1:100)

  circles <- st_sf(
    fid = c(2, 9),
    size = c('large', 'small'),
    geometry =  c(
    make_circle(5, 4, 2, sf::st_crs(rast)),
    make_circle(3, 1, 1, sf::st_crs(rast))))

  result_1 <- exact_extract(rast, circles, 'mean', append_cols = c('size', 'fid'), progress = FALSE)
  expect_named(result_1, c('size', 'fid', 'mean'))

  result_2 <- exact_extract(rast, circles, weighted.mean, append_cols = c('size', 'fid'), progress = FALSE)
  # result_2 won't be identical to result_2 because the column names are different
  # instead, check that the naming is consistent with what we get from the force_df argument
  expect_identical(result_2,
                   cbind(sf::st_drop_geometry(circles[, c('size', 'fid')]),
                         exact_extract(rast, circles, weighted.mean, force_df = TRUE, progress = FALSE)))
})

test_that('We can get multiple quantiles with the "quantiles" argument', {
 rast <- make_square_raster(1:100)

  circles <- st_sf(
    fid = c(2, 9),
    size = c('large', 'small'),
    geometry =  c(
    make_circle(5, 4, 2, sf::st_crs(rast)),
    make_circle(3, 1, 1, sf::st_crs(rast))))

  result <- exact_extract(rast, circles, 'quantile', quantiles=c(0.25, 0.50, 0.75), progress=FALSE)
  expect_true(inherits(result, 'data.frame'))

  expect_named(result, c('q25', 'q50', 'q75'))
})

test_that('Both value and weighting rasters can be a stack', {
  vals <- stack(replicate(3, make_square_raster(runif(100))))
  names(vals) <- c('a', 'b', 'c')

  weights <- stack(replicate(2, make_square_raster(rbinom(100, 2, 0.5))))
  names(weights) <- c('w1', 'w2')

  circle <- make_circle(2, 7, 3, sf::st_crs(vals))

  extracted <- exact_extract(vals, circle, weights=weights)[[1]]

  expect_named(extracted, c('a', 'b', 'c', 'w1', 'w2', 'coverage_fraction'))

  # stack of values, stack of weights: both passed as data frames
  exact_extract(vals, circle, function(v, c, w) {
    expect_true(is.data.frame(v))
    expect_true(is.data.frame(w))
    expect_named(v, names(vals))
    expect_named(w, names(weights))
  }, weights = weights)

  # stack of values, single layer of weights: weights passed as vector
  exact_extract(vals, circle, function(v, c, w) {
    expect_true(is.data.frame(v))
    expect_true(is.vector(w))
  }, weights = weights[[1]])

  # single layer of values, stack of weights: values passed as vector
  exact_extract(vals[[1]], circle, function(v, c, w) {
    expect_true(is.vector(v))
    expect_true(is.data.frame(w))
  }, weights = weights)

  # single layer of values, single layer of weights: both passed as vector
  exact_extract(vals[[1]], circle, function(v, c, w) {
    expect_true(is.vector(v))
    expect_true(is.vector(w))
  }, weights = weights[[1]])
})

test_that('Named summary operations support both stacks of values and weights', {
  vals <- stack(replicate(3, make_square_raster(runif(100))))
  names(vals) <- c('v1', 'v2', 'v3')

  weights <- stack(replicate(3, make_square_raster(rbinom(100, 2, 0.5))))
  names(weights) <- c('w1', 'w2', 'w3')

  circle <- make_circle(2, 7, 3, sf::st_crs(vals))

  stats <- c('sum', 'weighted_mean')

  # stack of values, stack of weights: values and weights are applied pairwise
  result <- exact_extract(vals, circle, stats, weights=weights)
  expect_named(result, c(
    'sum.v1', 'sum.v2', 'sum.v3',
    'weighted_mean.v1.w1', 'weighted_mean.v2.w2', 'weighted_mean.v3.w3'))
  expect_equal(result$sum.v1, exact_extract(vals[[1]], circle, 'sum'))
  expect_equal(result$sum.v2, exact_extract(vals[[2]], circle, 'sum'))
  expect_equal(result$sum.v3, exact_extract(vals[[3]], circle, 'sum'))
  expect_equal(result$weighted_mean.v1, exact_extract(vals[[1]], circle, 'weighted_mean', weights=weights[[1]]))
  expect_equal(result$weighted_mean.v2, exact_extract(vals[[2]], circle, 'weighted_mean', weights=weights[[2]]))
  expect_equal(result$weighted_mean.v3, exact_extract(vals[[3]], circle, 'weighted_mean', weights=weights[[3]]))

  # stack of values, layer of weights: weights are recycled
  result <- exact_extract(vals, circle, stats, weights=weights[[1]])
  expect_named(result, c(
    'sum.v1', 'sum.v2', 'sum.v3',
    'weighted_mean.v1', 'weighted_mean.v2', 'weighted_mean.v3'))
  expect_equal(result$sum.v1, exact_extract(vals[[1]], circle, 'sum'))
  expect_equal(result$sum.v2, exact_extract(vals[[2]], circle, 'sum'))
  expect_equal(result$sum.v3, exact_extract(vals[[3]], circle, 'sum'))
  expect_equal(result$weighted_mean.v1, exact_extract(vals[[1]], circle, 'weighted_mean', weights=weights[[1]]))
  expect_equal(result$weighted_mean.v2, exact_extract(vals[[2]], circle, 'weighted_mean', weights=weights[[1]]))
  expect_equal(result$weighted_mean.v3, exact_extract(vals[[3]], circle, 'weighted_mean', weights=weights[[1]]))

  # layer of values, stack of weights: values are recycled
  result <- exact_extract(vals[[3]], circle, stats, weights=weights)
  expect_named(result, c('sum', 'weighted_mean.w1', 'weighted_mean.w2', 'weighted_mean.w3'))
  expect_equal(result$sum, exact_extract(vals[[3]], circle, 'sum'))
  expect_equal(result$weighted_mean.w1, exact_extract(vals[[3]], circle, 'weighted_mean', weights=weights[[1]]))
  expect_equal(result$weighted_mean.w2, exact_extract(vals[[3]], circle, 'weighted_mean', weights=weights[[2]]))
  expect_equal(result$weighted_mean.w3, exact_extract(vals[[3]], circle, 'weighted_mean', weights=weights[[3]]))
})

test_that('We can use stack_apply with both values and weights', {
  vals <- stack(replicate(3, make_square_raster(runif(100))))
  names(vals) <- c('v1', 'v2', 'v3')

  weights <- stack(replicate(3, make_square_raster(rbinom(100, 2, 0.5))))
  names(weights) <- c('w1', 'w2', 'w3')

  circle <- make_circle(2, 7, 3, sf::st_crs(vals))

  weighted_mean <- function(v, c, w) {
    expect_equal(length(v), length(c))
    expect_equal(length(v), length(w))

    weighted.mean(v, c*w)
  }

  # stack of values, stack of weights: values and weights are applied pairwise
  result <- exact_extract(vals, circle, weighted_mean, weights = weights, stack_apply = TRUE)
  expect_named(result, c('fun.v1.w1', 'fun.v2.w2', 'fun.v3.w3'))
  expect_equal(result$fun.v2.w2,
               exact_extract(vals[[2]], circle, 'weighted_mean', weights=weights[[2]]),
               tol = 1e-6)

  # stack of values, layer of weights: weights are recycled
  result <- exact_extract(vals, circle, weighted_mean, weights = weights[[2]], stack_apply = TRUE, full_colnames = TRUE)
  expect_named(result, c('fun.v1.w2', 'fun.v2.w2', 'fun.v3.w2'))
  expect_equal(result$fun.v1.w2,
               exact_extract(vals[[1]], circle, 'weighted_mean', weights=weights[[2]]),
               tol = 1e-6)

  # layer of values, stack of weights: values are recycled
  result <- exact_extract(vals[[3]], circle, weighted_mean, weights = weights, stack_apply = TRUE, full_colnames = TRUE)
  expect_named(result, c('fun.v3.w1', 'fun.v3.w2', 'fun.v3.w3'))
  expect_equal(result$fun.v3.w1,
               exact_extract(vals[[3]], circle, 'weighted_mean', weights=weights[[1]]),
               tol = 1e-6)
})

test_that('Layers are implicity renamed if value layers have same name as weight layers', {
  # this happens when a stack is created and no names are provided
  # raster package assigns layer.1, layer.2
  # here we assign our own identical names to avoid relying on raster package
  # implementation detail
  vals <- stack(replicate(2, make_square_raster(runif(100))))
  names(vals) <- c('a', 'b')

  weights <- stack(replicate(2, make_square_raster(runif(100))))
  names(weights) <- c('a', 'b')

  circle <- make_circle(2, 7, 3, sf::st_crs(vals))

  result <- exact_extract(vals, circle, weights=weights)[[1]]
  expect_named(result, c('a', 'b', 'a.1', 'b.1', 'coverage_fraction'))
})

test_that('Progress bar updates incrementally', {
  rast <- make_square_raster(1:100)

  npolys <- 13

  polys <- st_sf(fid = seq_len(npolys),
                 geometry = st_sfc(replicate(npolys, {
                   x <- runif(1, min=0, max=10)
                   y <- runif(1, min=0, max=10)
                   r <- runif(1, min=0, max=2)
                   make_circle(x, y, r, crs=sf::st_crs(rast))
                 }), crs=sf::st_crs(rast)))

  for (fun in list('sum', weighted.mean)) {
    for (input in list(polys, sf::st_geometry(polys))) {
      output <- capture.output(q <- exact_extract(rast, input, fun))
      lines <- strsplit(output, '\r', fixed=TRUE)[[1]]
      numlines <- lines[endsWith(lines, '%')]
      len <- nchar(numlines[1])
      pcts <- as.integer(substr(numlines, len - 3, len - 1))

      expect_length(pcts, 1 + npolys)
      expect_equal(pcts[1], 0)
      expect_equal(pcts[length(pcts)], 100)
      expect_false(is.unsorted(pcts))
    }
  }
})

test_that('generated column names follow expected pattern', {
  values <- c('v1', 'v2', 'v3')
  weights <- c('w1', 'w2', 'w3')

  stats <- c('mean', 'weighted_mean')

  test_mean <- function(x, c) { weighted.mean(x, c) }

  # layer of values, no weights
  # named summary operations
  expect_equal(.resultColNames(values[[2]], NULL, c('mean', 'sum'), TRUE),
               c('mean.v2', 'sum.v2'))
  expect_equal(.resultColNames(values[[2]], NULL, c('mean', 'sum'), FALSE),
               c('mean', 'sum'))

  # generic method (we can recover its name)
  expect_equal(.resultColNames(values[[2]], NULL, weighted.mean, TRUE),
               'weighted.mean.v2')
  expect_equal(.resultColNames(values[[2]], NULL, weighted.mean, FALSE),
               'weighted.mean')

  # regular function (we can't recover its name)
  expect_equal(.resultColNames(values[[2]], NULL, test_mean, TRUE),
               'fun.v2')
  expect_equal(.resultColNames(values[[2]], NULL, test_mean, FALSE),
               'fun')

  # stack of values, no weights
  for (full_colnames in c(TRUE, FALSE)) {
    expect_equal(.resultColNames(values, NULL, c('mean', 'sum'), full_colnames),
                 c('mean.v1', 'mean.v2', 'mean.v3',
                   'sum.v1', 'sum.v2', 'sum.v3'))
    expect_equal(.resultColNames(values, NULL, test_mean, full_colnames),
                 c('fun.v1', 'fun.v2', 'fun.v3'))
  }

  # values, weights processed in parallel
  for (full_colnames in c(TRUE, FALSE)) {
    expect_equal(.resultColNames(values, weights, stats, full_colnames),
                 c('mean.v1', 'mean.v2', 'mean.v3',
                   'weighted_mean.v1.w1', 'weighted_mean.v2.w2', 'weighted_mean.v3.w3'))
    expect_equal(.resultColNames(values, weights, test_mean, full_colnames),
                 c('fun.v1.w1', 'fun.v2.w2', 'fun.v3.w3'))
  }

  # values recycled (full names)
  expect_equal(.resultColNames(values[1], weights, stats, TRUE),
               c('mean.v1', 'mean.v1', 'mean.v1',
                 'weighted_mean.v1.w1', 'weighted_mean.v1.w2', 'weighted_mean.v1.w3'))
  expect_equal(.resultColNames(values[1], weights, test_mean, TRUE),
               c('fun.v1.w1', 'fun.v1.w2', 'fun.v1.w3'))
  expect_equal(.resultColNames(values[1], weights, 'weighted_frac', full_colnames = TRUE, unique_values = c(4, 8)),
               c('weighted_frac_4.v1.w1', 'weighted_frac_4.v1.w2', 'weighted_frac_4.v1.w3',
                 'weighted_frac_8.v1.w1', 'weighted_frac_8.v1.w2', 'weighted_frac_8.v1.w3'))

  # here the values are always the same so we don't bother adding them to the names
  expect_equal(.resultColNames(values[1], weights, stats, FALSE),
               c('mean', 'mean', 'mean',
                 'weighted_mean.w1', 'weighted_mean.w2', 'weighted_mean.w3'))
  expect_equal(.resultColNames(values[1], weights, test_mean, FALSE),
               c('fun.w1', 'fun.w2', 'fun.w3'))

  # weights recycled (full names)
  expect_equal(.resultColNames(values, weights[1], stats, TRUE),
               c('mean.v1', 'mean.v2', 'mean.v3',
                 'weighted_mean.v1.w1', 'weighted_mean.v2.w1', 'weighted_mean.v3.w1'))
  expect_equal(.resultColNames(values, weights[1], test_mean, TRUE),
               c('fun.v1.w1', 'fun.v2.w1', 'fun.v3.w1'))

  # here the weights are always the same so we don't bother adding them to the name
  expect_equal(.resultColNames(values, weights[1], stats, FALSE),
               c('mean.v1', 'mean.v2', 'mean.v3',
                 'weighted_mean.v1', 'weighted_mean.v2', 'weighted_mean.v3'))
  expect_equal(.resultColNames(values, weights[1], test_mean, FALSE),
               c('fun.v1', 'fun.v2', 'fun.v3'))

  # custom colnames_fun
  expect_equal(
    .resultColNames(values, weights[1], stats, full_colnames = FALSE,
                    colname_fun = function(fun_name, values, weights, ...) {
                      paste(weights, values, fun_name, sep = '-')
                    }),
    c('NA-v1-mean', 'NA-v2-mean', 'NA-v3-mean',
      'w1-v1-weighted_mean', 'w1-v2-weighted_mean', 'w1-v3-weighted_mean')

  )
})

test_that('We can replace NA values in the value and weighting rasters with constants', {
  set.seed(05401)

  x <- runif(100)
  x[sample(length(x), 0.5*length(x))] <- NA

  y <- runif(100)
  y[sample(length(y), 0.5*length(y))] <- NA

  rx <- make_square_raster(x)
  ry <- make_square_raster(y)

  poly <- make_circle(4.5, 4.8, 4, crs=st_crs(rx))

  # manually fill the missing values with 0.5 and missing weights with 0.3
  rx_filled <- make_square_raster(ifelse(is.na(x), 0.5, x))
  ry_filled <- make_square_raster(ifelse(is.na(y), 0.3, y))

  expected <- exact_extract(rx_filled, poly, 'weighted_mean', weights = ry_filled)

  # fill values on the fly and verify that we get the same result
  expect_equal(
    exact_extract(rx, poly, 'weighted_mean', weights = ry, default_value = 0.5, default_weight = 0.3),
    expected)

  # check same calculation but using R summary function
  expect_equal(
    exact_extract(rx, poly, weights = ry, default_value = 0.5, default_weight = 0.3,
      fun = function(value, cov_frac, weight) {
        weighted.mean(value, cov_frac*weight)
      }),
    expected, 1e-6)

  # check substitution in raw returned values
  expect_equal(
    which(is.na(exact_extract(rx, poly)[[1]]$value)),
    which(44 == exact_extract(rx, poly, default_value = 44)[[1]]$value)
  )
})

test_that('All summary function arguments combined when summarize_df = TRUE', {
  rast <- make_square_raster(1:100)

  values <- stack(list(a = rast - 1,
                       b = rast,
                       c = rast + 1))

  weights <- sqrt(values)
  names(weights) <- c('d', 'e', 'f')

  circle <- st_sf(
    id = 77,
    make_circle(7.5, 5.5, 4, sf::st_crs(rast)))

  # in the tests below, we check names inside the R summary function
  # to verify that our checks were actually hit, we have the summary
  # function return NULL and check for it with `expect_null`.

  # values only
  expect_null(
    exact_extract(values, circle, summarize_df = TRUE, fun = function(df) {
      expect_named(df, c('a', 'b', 'c', 'coverage_fraction'))
      NULL
    })[[1]])

  expect_null(
    exact_extract(rast, circle, coverage_area = TRUE, summarize_df = TRUE, fun = function(df) {
      expect_named(df, c('value', 'coverage_area'))
      NULL
    })[[1]])

  expect_null(
    exact_extract(values[[1]], circle, coverage_area = TRUE, summarize_df = TRUE, fun = function(df) {
      expect_named(df, c('value', 'coverage_area'))
      NULL
    })[[1]])

  # values and weights
  expect_null(
    exact_extract(values, circle, summarize_df = TRUE, fun = function(df) {
      expect_named(df, c('a', 'b', 'c', 'd', 'e', 'f', 'coverage_fraction'))
      NULL
    }, weights = weights)[[1]])

  expect_null(
    exact_extract(values, circle,
                  include_cell = TRUE,
                  include_xy = TRUE,
                  include_area = TRUE,
                  include_cols = 'id',
                  summarize_df = TRUE,
                  fun = function(df, extra_arg) {
      expect_named(df,
        c('id', 'a', 'b', 'c', 'd', 'e', 'f', 'x', 'y', 'cell', 'area', 'coverage_fraction'))
      expect_equal(extra_arg, 600)
      NULL
    }, weights = weights, extra_arg = 600)[[1]])

  # values and weights, stack_apply = TRUE
  expect_equal(
    exact_extract(values, circle, weights = weights, summarize_df = TRUE, stack_apply = TRUE,
                  fun = function(df, extra_arg) {
                    expect_named(df, c('value', 'weight', 'coverage_fraction'))
                    extra_arg
                  }, extra_arg = 30809),
    data.frame(fun.a.d = 30809,
               fun.b.e = 30809,
               fun.c.f = 30809))
})

test_that('floating point errors do not cause an error that
          "logical subsetting requires vectors of identical size"', {
  rast <- raster(matrix(1:100, nrow=10), xm=0, xmx=1, ymn=0, ymx=1)
  poly <- make_rect(0.4, 0.7, 0.5, 0.8, crs = st_crs(rast))

  val <- exact_extract(rast, poly, weights = rast, fun = NULL, include_cell = TRUE)[[1]]

  expect_equal(val$value, rast[val$cell])
  expect_equal(val$weight, rast[val$cell])
})

test_that("append_cols works correctly when summary function returns multi-row data frame", {
  rast <- make_square_raster(1:100)

  circles <- st_sf(
    id = c('a', 'b'),
    geom = c(
      make_circle(3, 2, 4, sf::st_crs(rast)),
      make_circle(7, 7, 2, sf::st_crs(rast))
  ))

  expect_silent({
    result <- exact_extract(rast,
                            circles,
                            function(x, cov)
                              data.frame(x = 1:3,
                                         x2 = 4:6),
                            append_cols = 'id',
                            progress = FALSE)
  })

  expect_named(result, c('id', 'x', 'x2'))

  expect_equal(result$id, c('a', 'a', 'a', 'b', 'b', 'b'))
  expect_equal(result$x,  c(1:3, 1:3))
  expect_equal(result$x2,  c(4:6, 4:6))
})

test_that("append_cols works correctly when summary function returns vector with length > 1", {
  rast <- make_square_raster(1:100)

  circles <- st_sf(
    id = c('a', 'b'),
    geom = c(
      make_circle(3, 2, 4, sf::st_crs(rast)),
      make_circle(7, 7, 2, sf::st_crs(rast))
  ))

  expect_silent({
    result <- exact_extract(rast,
                            circles,
                            function(x, cov)
                              1:3,
                            append_cols = 'id',
                            progress = FALSE)
  })

  expect_named(result, c('id', 'result'))

  expect_equal(result$id, c('a', 'a', 'a', 'b', 'b', 'b'))
  expect_equal(result$result,  c(1:3, 1:3))
})

test_that("append_cols works correctly when summary function returns data frame with length 0", {
  rast <- make_square_raster(1:100)

  circles <- st_sf(
    id = c('a', 'b'),
    geom = c(
      make_circle(3, 2, 4, sf::st_crs(rast)),
      make_circle(7, 7, 2, sf::st_crs(rast))
  ))

  expect_silent({
    result <- exact_extract(rast,
                            circles,
                            function(x, cov)
                              data.frame(x = character(0),
                                         x2 = numeric(0)),
                            append_cols = 'id',
                            progress = FALSE)
  })

  expect_named(result, c('id', 'x', 'x2'))
  expect_equal(nrow(result), 0)
  expect_equal(class(result$id), class(circles$id))
  expect_equal(class(result$x), 'character')
  expect_equal(class(result$x2), 'numeric')
})

# Copyright (c) 2018-2021 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License ta http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

library(testthat)
library(exactextractr)
context('exact_extract input validation')

test_that('Error thrown if weighted stat requested but weights not provided', {
  rast <- make_square_raster(1:9)
  square <- make_circle(2, 2, 0.5, sf::st_crs(rast))

  for (stat in c('weighted_mean', 'weighted_sum')) {
    expect_error(exact_extract(rast, square, stat),
                 'no weights provided')
  }
})

test_that('Warning raised if weights provided but weighted stat not requested', {
  rast <- make_square_raster(1:9)
  square <- make_circle(2, 2, 0.5, sf::st_crs(rast))

  for (stat in c('count', 'sum', 'mean', 'min', 'max', 'minority', 'majority', 'mode', 'variety')) {
    expect_warning(exact_extract(rast, square, stat, weights=rast),
                   'Weights provided but no.*operations use them')
  }
})

test_that('Generic sfc_GEOMETRY fails if a feature is not polygonal', {
  rast <- make_square_raster(1:100)
  features <- st_as_sfc(c('POLYGON ((0 0, 2 0, 2 2, 0 2, 0 0))',
                          'POINT (2 7)'), crs=sf::st_crs(rast))

  expect_error(exact_extract(rast, features, 'sum', progress = FALSE),
               'must be polygonal')
})

test_that('Incorrect argument types are handled gracefully', {
  data <- matrix(1:9, nrow=3, byrow=TRUE)
  rast <- raster::raster(data,
                         xmn=0, xmx=3, ymn=0, ymx=3,
                         crs='+proj=longlat +datum=WGS84')

  point <- sf::st_sfc(sf::st_point(1:2),
                      crs=sf::st_crs(rast))

  linestring <- sf::st_sfc(sf::st_linestring(matrix(1:4, nrow=2)),
                           crs=sf::st_crs(rast))

  multipoint <- sf::st_sfc(sf::st_multipoint(matrix(1:4, nrow=2)),
                           crs=sf::st_crs(rast))

  multilinestring <- sf::st_sfc(
    sf::st_multilinestring(list(
      matrix(1:4, nrow=2),
      matrix(5:8, nrow=2)
    )),
    crs=sf::st_crs(rast))

  geometrycollection <- sf::st_sfc(
    sf::st_geometrycollection(list(
      sf::st_geometry(point)[[1]],
      sf::st_geometry(linestring)[[1]])),
    crs=sf::st_crs(rast))

  expect_error(exact_extract(rast, point), 'unable to find.* method')
  expect_error(exact_extract(rast, linestring, 'unable to find.* method'))
  expect_error(exact_extract(rast, multipoint, 'unable to find.* method'))
  expect_error(exact_extract(rast, multilinesetring, 'unable to find.* method'))
  expect_error(exact_extract(rast, geometrycollection, 'unable to find.* method'))
})

test_that('Warning is raised on CRS mismatch', {
  rast <- raster::raster(matrix(1:100, nrow=10),
                         xmn=-180, xmx=180, ymn=-90, ymx=90,
                         crs='+proj=longlat +datum=WGS84')

  poly <- sf::st_buffer(
    sf::st_as_sfc('POINT(442944.5 217528.7)', crs=32145),
    150000)

  expect_warning(exact_extract(rast, poly, weighted.mean, na.rm=TRUE),
                 'transformed to raster')
})

test_that('Warning is raised on undefined CRS', {
  rast <- raster::raster(matrix(1:100, nrow=10),
                         xmn=0, xmx=10, ymn=0, ymx=10)

  weights <- raster::raster(matrix(runif(100), nrow=10),
                            xmn=0, xmx=10, ymn=0, ymx=10)

  poly <- make_circle(8, 4, 0.4, crs=NA_integer_)

  # neither has a defined CRS
  expect_silent(exact_extract(rast, poly, 'sum'))

  # only raster has defined CRS
  raster::crs(rast) <- '+proj=longlat +datum=WGS84'
  expect_warning(exact_extract(rast, poly, 'sum'),
                 'assuming .* same CRS .* raster')

  # weights have no defined CRS
  expect_warning(exact_extract(rast, poly, 'weighted_mean', weights=weights),
                 'No CRS .* weighting raster.* assuming .* same CRS')

  # both have defined crs
  sf::st_crs(poly) <- sf::st_crs(rast)
  expect_silent(exact_extract(rast, poly, 'sum'))

  # only polygons have defined crs
  raster::crs(rast) <- NULL
  expect_warning(exact_extract(rast, poly, 'sum'),
                 'assuming .* same CRS .* polygon')
})

test_that('Error thrown if value raster and weighting raster have different crs', {
   values <- make_square_raster(runif(100), crs=NA)
   weights <- make_square_raster(runif(100), crs=NA)

   poly <- make_circle(8, 4, 1.5, crs=NA_real_)

   # no CRS for values or weights
   exact_extract(values, poly, 'weighted_mean', weights=weights)

   # values have defined CRS, weights do not
   raster::crs(values) <- '+proj=longlat +datum=WGS84'
   raster::crs(weights) <- '+proj=longlat +datum=NAD83'
   expect_error(
     exact_extract(values, poly, 'weighted_mean', weights=weights),
     'Weighting raster does not have .* same CRS as value raster')
})

test_that('Error thrown if value raster and weighting raster have incompatible grids', {
  poly <- make_circle(5, 4, 2, NA_integer_)

  values <- raster::raster(matrix(runif(10*10), nrow=10),
                           xmn=0, xmx=10, ymn=0, ymx=10)


  # weights have same extent as values, higher resolution
  weights <- raster::raster(matrix(runif(100*100), nrow=100),
                            xmn=0, xmx=10, ymn=0, ymx=10)

  exact_extract(values, poly, 'weighted_mean', weights=weights)

  # weights have same extent as values, lower resolution
  weights <- raster::raster(matrix(1:4, nrow=2),
                            xmn=0, xmx=10, ymn=0, ymx=10)

  exact_extract(values, poly, 'weighted_mean', weights=weights)

  # weights have offset extent from values, same resolution, compatible origin
  weights <- raster::raster(matrix(runif(10*10), nrow=2),
                           xmn=1, xmx=11, ymn=2, ymx=12)

  exact_extract(values, poly, 'weighted_mean', weights=weights)

  # weights have offset extent from values, same resolution, incompatible origin
  weights <- raster::raster(matrix(runif(10*10), nrow=2),
                           xmn=0.5, xmx=10.5, ymn=2, ymx=12)

  expect_error(exact_extract(values, poly, 'weighted_mean', weights=weights),
               'Incompatible extents')
})

test_that('Error is raised if function has unexpected signature', {
  rast <- make_square_raster(1:100)

  poly <- make_circle(5, 5, 3, sf::st_crs(rast))

  # unweighted, standard form
  for (fun in c(length, sum, median, mean, sd)) {
    expect_error(
      exact_extract(rast, poly, fun),
      'function .* not .* of the form')
  }

  expect_silent(exact_extract(rast, poly, weighted.mean))

  # unweighted, summarize_df
  expect_error(
    exact_extract(rast, poly, function() {}, summarize_df = TRUE),
    'function .* not .* of the form'
  )

  # weighted, standard form
  expect_error(
    exact_extract(rast, poly, weights = rast, fun = function(x, frac) {}),
    'function .* not .* of the form')
  expect_error(
    exact_extract(rast, poly, weights = rast, fun = function(x) {}),
    'function .* not .* of the form')
  expect_error(
    exact_extract(rast, poly, weights = rast, fun = function() {}),
    'function .* not .* of the form')

  # weighted, summarize_df
  expect_error(
    exact_extract(rast, poly, weights = rast, fun = function() {}, summarize_df = TRUE),
    'function .* not .* of the form'
  )
})

test_that('Error is raised for unknown summary operation', {
  rast <- make_square_raster(1:100)

  poly <- make_circle(5, 5, 3, sf::st_crs(rast))

  expect_error(exact_extract(rast, poly, 'whatimean'),
               'Unknown stat')
})

test_that('Error is raised if arguments passed without R summary function', {
  rast <- make_square_raster(1:100)

  poly <- make_circle(5, 5, 3, sf::st_crs(rast))

  expect_error(exact_extract(rast, poly, 'sum', na.rm=TRUE),
               'does not accept additional arguments')

  expect_error(
    exact_extract(rast, poly, cookie = FALSE),
    'Unexpected arguments'
  )
})

test_that('Error is raised for invalid max_cells_in_memory', {
  rast <- make_square_raster(1:100)
  poly <- make_circle(5, 5, 3, sf::st_crs(rast))

  expect_error(exact_extract(rast, poly, 'mean', max_cells_in_memory=-123),
               'Invalid.*max_cells')

  expect_error(
    exact_extract(rast, poly, 'mean', max_cells_in_memory = NA),
    'must be a single numeric')

  expect_error(
    exact_extract(rast, poly, 'mean', max_cells_in_memory = numeric()),
    'must be a single numeric')

  expect_error(
    exact_extract(rast, poly, 'mean', max_cells_in_memory = integer()),
    'must be a single numeric')

  expect_error(
    exact_extract(rast, poly, 'mean', max_cells_in_memory = NULL),
    'must be a single numeric')
})

test_that('Error is thrown when using include_* with named summary operation', {
  rast <- make_square_raster(1:100)

  circles <- st_sf(
    fid = c(2, 9),
    size = c('large', 'small'),
    geometry =  c(
    make_circle(5, 4, 2, sf::st_crs(rast)),
    make_circle(3, 1, 1, sf::st_crs(rast))))

  expect_error(exact_extract(rast, circles, 'sum', include_xy = TRUE),
               'include_xy must be FALSE')

  expect_error(exact_extract(rast, circles, 'sum', include_area = TRUE),
               'include_area must be FALSE')

  expect_error(exact_extract(rast, circles, 'sum', include_cell = TRUE),
               'include_cell must be FALSE')

  expect_error(exact_extract(rast, circles, 'sum', include_cols = 'fid'),
               'include_cols not supported')
})

test_that('Error is thrown when using include_cols or append_cols with nonexisting columns', {
  rast <- make_square_raster(1:100)

  circles <- st_sf(
    fid = c(2, 9),
    size = c('large', 'small'),
    geometry =  c(
    make_circle(5, 4, 2, sf::st_crs(rast)),
    make_circle(3, 1, 1, sf::st_crs(rast))))

  # append_cols specified but sfc has no attribute columns
  expect_error(
    exact_extract(rast, st_geometry(circles), 'mean', append_cols = 'fid', progress = FALSE),
    'only supported for sf')

  expect_error(
    exact_extract(rast, st_geometry(circles), weighted.mean, append_cols = 'fid', progress = FALSE),
    'only supported for sf')

  # append_cols specified for misspelled column
  expect_error(
    exact_extract(rast, circles, 'mean', append_cols = 'fidd', progress = FALSE),
    'undefined columns'
  )

  expect_error(
    exact_extract(rast, circles, weighted.mean, append_cols = 'fidd', progress = FALSE),
    'undefined columns'
  )

  # include_cols specified for sfc
  expect_error(
    exact_extract(rast, st_geometry(circles), include_cols = 'fidd', progress = FALSE),
    'only supported for sf'
  )

  # include_cols specified for misspelled column
  expect_error(
    exact_extract(rast, circles, include_cols = 'fidd', progress = FALSE),
    'undefined columns'
  )
})

test_that('Error is thrown if quantiles not specified or not valid', {
 rast <- make_square_raster(1:100)
 square <- make_rect(2, 2, 4, 4, crs=sf::st_crs(rast))

 expect_error(exact_extract(rast, square, 'quantile'),
              'Quantiles not specified')

 expect_error(exact_extract(rast, square, 'quantile', quantiles=NA),
              'must be between 0 and 1')

 expect_error(exact_extract(rast, square, 'quantile', quantiles=c(0.5, 1.1)),
              'must be between 0 and 1')

 expect_error(exact_extract(rast, square, 'quantile', quantiles=numeric()),
              'Quantiles not specified')
})

test_that('Warning emitted when value raster is disaggregated', {
  r1 <- make_square_raster(1:100)
  r2 <- make_square_raster(runif(100))
  r1d <- raster::disaggregate(r1, 2)
  r2d <- raster::disaggregate(r2, 2)

  circle <- make_circle(2, 7, 3, sf::st_crs(r1))

  # no warning, values and weights have same resolution
  expect_silent(exact_extract(r1, circle, weights=r2))

  # no warning, values have higher resolution than weights
  expect_silent(exact_extract(r1d, circle, weights=r2))

  # warning, weights have higher resolution than values
  expect_warning(exact_extract(r1, circle, weights=r2d),
                 'value .* disaggregated')
})

test_that('Error raised when value raster is disaggregated and unweighted sum/count requested', {
  r1 <- make_square_raster(1:100)
  r1d <- raster::disaggregate(r1, 2)

  circle <- make_circle(2, 7, 3, sf::st_crs(r1))

  # no error, requested operations either expect disaggregation
  # or are not impacted by it
  expect_silent(exact_extract(r1, circle, c('weighted_sum', 'weighted_mean', 'mean'), weights=r1d))

  # on the other hand, "count" would be messed up by the disaggregation
  expect_error(exact_extract(r1, circle, c('weighted_sum', 'count'), weights=r1d),
               'raster is disaggregated')

  # as would "sum"
  expect_error(exact_extract(r1, circle, c('weighted_sum', 'count'), weights=r1d),
               'raster is disaggregated')

  # no problem if the weights are disaggregated, though
  expect_silent(exact_extract(r1d, circle, c('weighted_sum', 'count'), weights=r1))
})

test_that('We get an error if using stack_apply with incompatible stacks', {
  vals <- stack(replicate(3, make_square_raster(runif(100))))
  names(vals) <- c('a', 'b', 'c')

  weights <- stack(replicate(2, make_square_raster(runif(100))))
  names(weights) <- c('d', 'e')

  circle <- make_circle(2, 7, 3, sf::st_crs(vals))

  expect_error(
    exact_extract(vals, circle, function(v, c, w) 1, weights=weights, stack_apply=TRUE),
    "Can't apply")
})

test_that('Error thrown if summarize_df set where not applicable', {
  rast <- make_square_raster(1:100)
  circle <- make_circle(7.5, 5.5, 4, sf::st_crs(rast))

  expect_error(
    exact_extract(rast, circle, 'mean',  summarize_df = TRUE),
    'can only be used when .* function')

  expect_error(
    exact_extract(rast, circle, summarize_df = TRUE),
    'can only be used when .* function')
})

test_that('Error thrown if stack_apply set where not applicable', {
  rast <- make_square_raster(1:100)
  circle <- make_circle(7.5, 5.5, 4, sf::st_crs(rast))

  expect_error(
    exact_extract(rast, circle, stack_apply = TRUE),
    'can only be used when .* is a summary operation or function'
  )
})

test_that('Error thrown if append_cols set where not applicable', {
  rast <- make_square_raster(1:100)
  circle <- st_sf(make_circle(7.5, 5.5, 4, sf::st_crs(rast)))

  expect_error(
    exact_extract(rast, circle, append_cols = TRUE),
    'can only be used when .* is a summary operation or function'
  )
})

test_that('Error thrown if scalar args have length != 1', {
  rast <- make_square_raster(1:100)
  circle <- make_circle(7.5, 5.5, 4, sf::st_crs(rast))

  flags <- c(
    'coverage_area',
    'force_df',
    'full_colnames',
    'include_area',
    'include_cell',
    'include_xy',
    'progress',
    'stack_apply',
    'summarize_df')

  for (flag in flags) {
    base_args <- list(rast, circle)

    for (bad_value in list(logical(), c(TRUE, TRUE), NA)) {
      args <- base_args
      args[[flag]] <- bad_value

      expect_error(
        do.call(exact_extract, args),
        'must be TRUE or FALSE'
      )
    }
  }
})

test_that('Error thrown if fun is empty', {
  rast <- make_square_raster(1:100)
  circle <- make_circle(7.5, 5.5, 4, sf::st_crs(rast))

  expect_error(
    exact_extract(rast, circle, character()),
    'No summary operations'
  )
})

test_that('Error thrown if fun is incorrect type', {
  rast <- make_square_raster(1:100)
  circle <- make_circle(7.5, 5.5, 4, sf::st_crs(rast))

  expect_error(
    exact_extract(rast, circle, 44),
    'must be a character vector, function')
  expect_error(
    exact_extract(rast, circle, list(function() {}, function() {})),
    'must be a character vector, function')
})

test_that('Error thrown if default values have incorrect type/length', {
  rast <- make_square_raster(1:100)
  circle <- make_circle(7.5, 5.5, 4, sf::st_crs(rast))

  expect_error(
    exact_extract(rast, circle, 'mean', default_value = numeric()),
    'must be a single numeric value'
  )
  expect_error(
    exact_extract(rast, circle, 'mean', default_value = c(3, 8)),
    'must be a single numeric value'
  )
  expect_error(
    exact_extract(rast, circle, 'mean', default_value = NULL),
    'must be a single numeric value'
  )
  expect_error(
    exact_extract(rast, circle, 'mean', default_value = FALSE),
    'must be a single numeric value'
  )

})

# Copyright (c) 2018-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

.resultColNames <- function(...) {
  .resultColumns(...)$colname
}

#' Return column names to be used for summary operations
#'
#' @param value_names names of value raster layers
#' @param weight_names names of weighting raster layers
#' @param fun functions or names of summary operations
#' @param full_colnames return a complete column name even when there is no
#'                      ambiguity?
#' @param quantiles quantiles to use when \code{stat_names} contains \code{quantile}
#' @return character vector of column names
#' @keywords internal
.resultColumns <- function(value_names, weight_names, fun, full_colnames, quantiles=numeric(), unique_values=numeric(), colname_fun = NULL) {
  if (inherits(fun, 'standardGeneric')) {
    stat_names <- fun@generic[1]
  } else if (is.function(fun)) {
    stat_names <- 'fun'
  } else if (is.null(fun)) {
    stat_names <- ''
  } else {
    stat_names <- fun
  }

  quantile_index = which(stat_names == 'quantile')
  if (length(quantile_index) != 0) {
    stat_names <- splice(stat_names, quantile_index, rep('quantile', length(quantiles)))
  }

  for (stat in c('frac', 'weighted_frac')) {
    frac_index = which(stat_names == stat)
    if (length(frac_index) != 0) {
      stat_names <- splice(stat_names, frac_index, rep(stat, length(unique_values)))
    }
  }

  ind <- .valueWeightIndexes(length(value_names), length(weight_names))
  vn <- value_names[ind$values]
  wn <- weight_names[ind$weights]

  # determine all combinations of index and stat
  z <- expand.grid(index=seq_along(vn),
                   stat_name=stat_names, stringsAsFactors=FALSE)

  z$values <- vn[z$index]
  z$base_value <- NA_real_

  for (stat in c('frac', 'weighted_frac')) {
    ifrac <- which(z$stat_name == stat)
    z$base_value[ifrac] <- rep(unique_values, each = length(ifrac) / length(unique_values))
  }

  iquantile <- which(z$stat_name == 'quantile')
  z$base_value[iquantile] <- rep(quantiles, each = length(iquantile) / length(quantiles))

  if (is.null(wn)) {
    z$weights <- NA
  } else {
    z$weights <- wn[z$index]
  }
  z$weights[!.includeWeightInColName(z$stat_name)] <- NA

  if (is.null(colname_fun)) {
    colname_fun <- function(...) {
      .makeColname(full_colnames = full_colnames, ...)
    }
  }

  z$colname <- mapply(colname_fun,
                      fun_name = z$stat_name,
                      values = z$values,
                      weights = z$weights,
                      fun_value = z$base_value,
                      MoreArgs = list(nvalues = length(value_names),
                                      nweights = length(weight_names)),
                      USE.NAMES = FALSE)

  return(z)
}

.makeColname <- function(fun_name, values, weights, fun_value, full_colnames, nvalues, nweights) {
  # construct column names for each index, stat
  # add weight layer name only if layer is ambiguously weighted
  if (fun_name == 'quantile') {
    fun_component <- sprintf('q%02d', as.integer(100 * fun_value))
  } else if (fun_name %in% c('frac', 'weighted_frac')) {
    fun_component <- sprintf('%s_%s', fun_name, fun_value)
  } else {
    fun_component <- fun_name
  }

  ret <- fun_component
  if (full_colnames || nvalues > 1) {
    ret <- paste(ret, values, sep='.')
  }
  if ((!is.na(weights)) && ((full_colnames & nweights > 0) || nweights > 1)) {
    ret <- paste(ret, weights, sep='.')
  }

  return(ret)
}

.includeWeightInColName <- function(fun) {
  .isWeighted(fun) | fun == 'fun'
}

.isWeighted <- function(stat_name) {
  stat_name %in% c('weighted_mean', 'weighted_sum', 'weighted_frac', 'weighted_stdev', 'weighted_variance')
}

#' Compute indexes for the value and weight layers that should be
#' processed together
#'
#' @param num_values number of layers in value raster
#' @param num_weights number of layers in weighting raster
#' @return list with \code{values} and \code{weights} elements
#'         providing layer indexes
#' @keywords internal
.valueWeightIndexes <- function(num_values, num_weights) {
  if (num_weights == 0) {
    vi <- seq_len(num_values)
    wi <- NA
  } else if (num_values == num_weights) {
    # process in parallel
    vi <- seq_len(num_values)
    wi <- seq_len(num_weights)
  } else if (num_values == 1 && num_weights > 1) {
    # recycle values
    vi <- rep.int(1, num_weights)
    wi <- seq_len(num_weights)
  } else if (num_values > 1 && num_weights == 1) {
    # recycle weights
    vi <- seq_len(num_values)
    wi <- rep.int(1, num_values)
  }

  list(values = vi, weights = wi)
}

.areaMethod <- function(crs_obj) {
  if (!(is.na(crs_obj)) && crs_obj$units_gdal == 'degree') {
    return('spherical')
  } else {
    return('cartesian')
  }
}

.validateFlag <- function(value, name) {
  if(!(is.logical(value) && length(value) == 1 && !is.na(value))) {
    stop(name, ' must be TRUE or FALSE')
  }
}

.validateNumericScalar <- function(value, name) {
  if (!(is.numeric(value) && length(value) == 1 && !is.na(value))) {
    stop(name, ' must be a single numeric value')
  }
}

.validateNumericScalarOrNA <- function(value, name) {
  if (!(is.numeric(value) && length(value) == 1)) {
    stop(name, ' must be a single numeric value')
  }
}

.validateUniqueNames <- function(x) {
  nm <- names(x)
  if (!is.null(nm)) {
    if (length(nm) != length(unique(nm))) {
      stop('names of input rasters must be unique')
    }
  }
}

# faster replacement for as.data.frame when input is a named list
# with equal-length columns
# from Advanced R, sec. 24.4.2
.quickDf <- function(lst) {
  class(lst) <- 'data.frame'
  attr(lst, 'row.names') <- .set_row_names(length(lst[[1]]))
  lst
}

.singleColumnToVector <- function(df) {
  if (ncol(df) == 1) {
    df[, 1]
  } else {
    df
  }
}

# Return the number of standard (non-...) arguments in a supplied function that
# do not have a default value. This is used to fail if the summary function
# provided by the user cannot accept arguments of values and weights.
.num_expected_args <- function(fun) {
  a <- formals(args(fun))
  a <- a[names(a) != '...']
  sum(sapply(a, nchar) == 0)
}

.startReading <- function(r) {
  if(inherits(r, 'BasicRaster')) {
    return(raster::readStart(r))
  } else if (inherits(r, 'SpatRaster')) {
    terra::readStart(r)
  }

  return(r)
}

.stopReading <- function(r) {
  if(inherits(r, 'BasicRaster')) {
    return(raster::readStop(r))
  } else if (inherits(r, 'SpatRaster')) {
    terra::readStop(r)
  }

  return(r)
}

.crs <- function(r) {
  if(inherits(r, 'BasicRaster')) {
    if (utils::packageVersion('raster') < numeric_version('3.5')) {
      return(raster::crs(r))
    } else {
      return(terra::crs(r))
    }
  } else if (inherits(r, 'SpatRaster')) {
    return(terra::crs(r))
  } else {
    stop('Unknown type: ', class(r))
  }
}

.setValues <- function(r, x) {
  if(inherits(r, 'BasicRaster')) {
    if (utils::packageVersion('raster') < numeric_version('3.5')) {
      raster::values(r) <- x
    } else {
      terra::values(r) <- x
    }
  } else if (inherits(r, 'SpatRaster')) {
    raster::values(r) <- x
  } else {
    stop('Unknown type: ', class(r))
  }

  return(r)
}

.numLayers <- function(r) {
  if(inherits(r, 'BasicRaster')) {
    return(raster::nlayers(r))
  } else if (inherits(r, 'SpatRaster')) {
    return(terra::nlyr(r))
  } else {
    stop('Unknown type: ', class(r))
  }
}

.isRaster <- function(r) {
  inherits(r, 'BasicRaster') | inherits(r, 'SpatRaster')
}

.xFromCol <- function(r, col) {
  if (inherits(r, 'BasicRaster')) {
    raster::xFromCol(r, col)
  } else if (inherits(r, 'SpatRaster')) {
    terra::xFromCol(r, col)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.colFromX <- function(r, x) {
  if (inherits(r, 'BasicRaster')) {
    raster::colFromX(r, x)
  } else if (inherits(r, 'SpatRaster')) {
    terra::colFromX(r, x)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.yFromRow <- function(r, row) {
  if (inherits(r, 'BasicRaster')) {
    raster::yFromRow(r, row)
  } else if (inherits(r, 'SpatRaster')) {
    terra::yFromRow(r, row)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.rowFromY <- function(r, y) {
  if (inherits(r, 'BasicRaster')) {
    raster::rowFromY(r, y)
  } else if (inherits(r, 'SpatRaster')) {
    terra::rowFromY(r, y)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.cellFromRowCol <- function(r, row, col) {
  if (inherits(r, 'BasicRaster')) {
    raster::cellFromRowCol(r, row, col)
  } else if (inherits(r, 'SpatRaster')) {
    terra::cellFromRowCol(r, row, col)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.extent <- function(r) {
  if (inherits(r, 'BasicRaster')) {
    ex <- r@extent
    c(ex@xmin, ex@ymin, ex@xmax, ex@ymax)
  } else if (inherits(r, 'SpatRaster')) {
    ex <- terra::ext(r)
    c(ex$xmin, ex$ymin, ex$xmax, ex$ymax)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.res <- function(r) {
  if (inherits(r, 'BasicRaster')) {
    raster::res(r)
  } else if (inherits(r, 'SpatRaster')) {
    terra::res(r)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.getValuesBlock <- function(r, row, nrows, col, ncols) {
  if (inherits(r, 'BasicRaster')) {
    raster::getValuesBlock(r, row, nrows, col, ncols, format = 'm')
  } else if (inherits(r, 'SpatRaster')) {
    terra::readValues(r, row, nrows, col, ncols, mat = TRUE)
  } else {
    stop('Unknown type: ', class(r))
  }
}

.createProgress <- function(progress, n) {
  if (progress && n > 1) {
    pb <- utils::txtProgressBar(min = 0, max = n, initial=0, style=3)
    update_progress <- function() {
      i <- 1 + utils::getTxtProgressBar(pb)
      utils::setTxtProgressBar(pb, i)
      if (i == n) {
        close(pb)
      }
    }
  } else {
    update_progress <- function() {}
  }

  return(update_progress)
}

.isInMemory <- function(r) {
  if (inherits(r, 'BasicRaster')) {
    return(raster::inMemory(r))
  } else if (inherits(r, 'SpatRaster')) {
    return(terra::inMemory(r)[1])
  } else {
    stop('Unknown type: ', class(r))
  }
}

.netCDFBlockSize <- function(fname, varname) {
  nc <- NULL
  sz <- NA

  tryCatch({
    nc <- ncdf4::nc_open(fname)
    sz <- nc$var[[varname]]$chunksizes

    dim_index <- nc$var[[varname]]$dimids + 1L
    dim_names <- sapply(dim_index, function(i) nc$dim[[i]]$name)

    if (all(is.na(sz))) {
      # file is not compressed
      sz <- rep.int(1, length(dim_names))
    }

    names(sz) <- dim_names
  }, finally = {
    if (!is.null(nc)) {
      ncdf4::nc_close(nc)
    }
  })

  # flip dimensions 1 and 2 so we return row/col
  return(sz[c(2, 1, seq_along(sz)[-(1:2)])])
}

.blockSize <- function(r) {
  # set default return value in case file is uncompressed and has
  # has no block size, or we simply can't figure it out
  ret <- c(1, 1)

  if (inherits(r, 'BasicRaster')) {
    if (r[[1]]@file@driver == 'netcdf') {
      ret <- .netCDFBlockSize(r[[1]]@file@name, attr(r[[1]]@data, 'zvar'))
    } else if (r@file@driver == 'gdal') {
      ret <- c(r@file@blockrows, r@file@blockcols)
    }
  } else if (inherits(r, 'SpatRaster')) {
    ret <- terra::fileBlocksize(r)[1, ]
  }

  unname(ret)
}

.eagerLoad <- function(r, geoms, max_cells_in_memory, message_on_fail) {
  if (is.null(r)) {
    return(NULL)
  }

  cells_required <- .numCells(r, geoms)

  if (cells_required <= max_cells_in_memory) {
    box <- sf::st_bbox(geoms)
    geom_ext <- terra::ext(box[c('xmin', 'xmax', 'ymin', 'ymax')])

    if (!inherits(r, 'SpatRaster')) {
      # current CRAN version of terra (1.4-22) does not preserve
      # names on conversion (https://github.com/rspatial/terra/issues/430)
      nm <- names(r)
      r <- terra::rast(r)
      names(r) <- nm
    }

    overlap_ext <- terra::intersect(terra::ext(r), geom_ext)
    if (is.null(overlap_ext)) {
      # Extents do not overlap, and terra::crop will throw an error
      # if we try to crop. Return the input raster as-is; nothing will be
      # read from it anyway.
      return(r)
    }

    r <- terra::crop(r, geom_ext, snap = 'out')
  } else if (message_on_fail) {
    message('Cannot preload entire working area of ', cells_required,
            ' cells with max_cells_in_memory = ', max_cells_in_memory, '.',
            ' Raster values will be read for each feature individually.')
  }

  return(r)
}

.numCells <- function(r, g) {
  if (is.null(r)) {
    return(0)
  }

  box <- sf::st_bbox(g)

  top <- .rowFromY(r, box['ymax'])
  bottom <- .rowFromY(r, box['ymin'])
  left <- .colFromX(r, box['xmin'])
  right <- .colFromX(r, box['xmax'])

  if (is.na(top) && is.na(bottom)) {
    return(0L)
  }
  if (is.na(left) && is.na(right)) {
    return(0L)
  }
  if (is.na(top)) {
    top <- 1
  }
  if (is.na(bottom)) {
    bottom <- nrow(r)
  }
  if (is.na(left)) {
    left <- 1
  }
  if (is.na(right)) {
    right <- ncol(r)
  }

  return( (bottom - top + 1) * (right - left + 1) * .numLayers(r) )
}

splice <- function(x, i, replacement) {
  c(x[seq_along(x) < i],
    replacement,
    x[seq_along(x) > i])
}

# Copyright (c) 2021-2023 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License ta http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

context('block size detection')

test_that('blockSize reports block size in row-col order', {
  landcov_fname <- system.file(file.path('sao_miguel', 'clc2018_v2020_20u1.tif'),
                               package='exactextractr')

  expect_equal(
    .blockSize(raster::raster(landcov_fname)),
    c(2, 3840)
  )

  expect_equal(
    .blockSize(terra::rast(landcov_fname)),
    c(2, 3840)
  )

  # netCDF uses a different code path, so copy our test input to netCDF format
  # and repeat. GDAL doesn't let us control the block size, so hopefully it
  # is stable.
  if ('netCDF' %in% terra::gdal(drivers=TRUE)$name) {
    nc_fname <- tempfile(fileext = '.nc')
    suppressWarnings({
      terra::writeRaster(terra::rast(landcov_fname), nc_fname, gdal=c('FORMAT=NC4', 'COMPRESS=DEFLATE'))
    })

    expect_equal(
      .blockSize(raster::raster(nc_fname)),
      c(1, 3840)
    )

    expect_equal(
      .blockSize(terra::rast(nc_fname)),
      c(1, 3840)
    )

    file.remove(nc_fname)
  }
})

context(".num_expected_args")

test_that(
  desc = 'Number of arguments that a `fun` expects a user to supply matches
  expectations. That is, the number of non-... arguments that a function expects
  that don\'t have a default value.',
  code = {

    # Function has two arguments and no defaults.
    weighted_mean_no_defaults <- function(df, weighted) {
      if(!weighted) {
        out <- mean(df$value)
      } else {
        out <- weighted.mean(x = df$value, w = df$value)
      }
      out
    }

    # Function has two arguments, but a non-NULL default is supplied
    # for one of them.
    weighted_mean_non_null_defaults <- function(df, weighted = TRUE) {
      if(!weighted) {
        out <- mean(df$value)
      } else {
        out <- weighted.mean(x = df$value, w = df$value)
      }
      out
    }

    # Function has two arguments, but a NULL default is supplied for
    # one of them.
    weighted_mean_null_defaults <- function(df, weighted = NULL) {
      if(is.null(weighted)) {
        out <- mean(df$value)
      } else {
        out <- weighted.mean(x = df$value, w = df$value)
      }
      out
    }

    # Function has two arguments and no defaults. Should count both
    # arguments without defaults.
    expect_equal(.num_expected_args(weighted_mean_no_defaults), 2)

    # Function has two arguments, but a non-NULL default is supplied
    # for one of them. Should only count the one argument without a
    # default.
    expect_equal(.num_expected_args(weighted_mean_non_null_defaults), 1)

    # Function has two arguments, but a NULL default is supplied for
    # one of them. Should only count the one argument without a default.
    expect_equal(.num_expected_args(weighted_mean_null_defaults), 1)
  }
)

# Copyright (c) 2020-2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

setGeneric("exact_resample", function(x, y, ...)
	standardGeneric("exact_resample"))

#' Resample a raster to a new grid
#'
#' @param x a \code{RasterLayer} or \code{SpatRaster} to be resampled
#' @param y a raster of the same class as \code{x} with a grid definition to
#'          which \code{x} should be resampled
#' @param fun a named summary operation or R function to be used for the resampling
#' @param coverage_area use cell coverage areas instead of coverage fractions
#'                      in \code{fun}
#' @return a resampled version of \code{x}, returned as a \code{RasterLayer} or
#'         \code{SpatRaster}, depending on the values of \code{x} and \code{y}
#'
#' @name exact_resample
NULL

.exact_resample <- function(x, y, fun, coverage_area = FALSE) {
  analysis_crs <- sf::st_crs(x)
  if (sf::st_crs(x) != sf::st_crs(y)) {
    if (is.na(sf::st_crs(x))) {
      warning("No CRS specified for source raster; assuming it has the same CRS as destination raster.")
      analysis_crs <- sf::st_crs(y)
    } else if (is.na(sf::st_crs(y))) {
      warning("No CRS specified for destination raster; assuming it has the same CRS as source raster.")
    } else {
      stop('Destination raster must have same CRS as source.')
    }
  }

  if (is.character(fun)) {
    if (length(fun) != 1) {
      stop("Only a single operation may be used for resampling.")
    }

    if (startsWith(fun, 'weighted')) {
      stop("Weighted operations cannot be used for resampling.")
    }

    if (.numLayers(x) != 1) {
      stop("Raster to be resampled must have a single layer.")
    }

    summary_stat <- fun
    summary_fun <- NULL
  } else {
    if (!is.function(fun)) {
      stop("fun must be a named summary operation or an R function")
    }

    if (.num_expected_args(fun) != 2) {
      stop("exact_extract was called with a function that does not appear to ",
           "be of the form `function(values, coverage_fractions)`.")
    }

    summary_stat <- NULL
    summary_fun <- fun
  }

  .validateFlag(coverage_area, 'coverage_area')

  area_method <- .areaMethod(analysis_crs)

  x <- .startReading(x)
  tryCatch({
    ret <- CPP_resample(x,
                        y,
                        summary_stat,
                        summary_fun,
                        coverage_area,
                        area_method)
    if (inherits(x, 'SpatRaster')) {
      terra::rast(ret)
    } else {
      ret
    }
  }, finally={
    .stopReading(x)
  })
}

#' @import sf
#' @import raster
#' @useDynLib exactextractr
#' @rdname exact_resample
#' @export
setMethod('exact_resample', signature(x='RasterLayer', y='RasterLayer'), .exact_resample)

#' @useDynLib exactextractr
#' @rdname exact_resample
#' @export
setMethod('exact_resample', signature(x='SpatRaster', y='SpatRaster'), .exact_resample)

if(getRversion() < "3.3.0") {
  stop("Your version of R is too old. This package requires R-3.3.0 or newer on Windows.")
}

VERSION <- commandArgs(TRUE)
if(!file.exists(sprintf("../windows/gdal2-%s/include/gdal/gdal.h", VERSION))){
  download.file(sprintf("https://github.com/rwinlib/gdal2/archive/v%s.zip", VERSION), "lib.zip", quiet = FALSE)
  dir.create("../windows", showWarnings = FALSE)
  unzip("lib.zip", exdir = "../windows")
  unlink("lib.zip")
}

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

CPP_coverage_fraction <- function(rast, wkb, crop) {
    .Call('_exactextractr_CPP_coverage_fraction', PACKAGE = 'exactextractr', rast, wkb, crop)
}

CPP_exact_extract <- function(rast, rast_ext, rast_res, rast_uncropped, weights, wkb, default_value, default_weight, include_xy, include_cell_number, include_area, area_weights, coverage_areas, p_area_method, include_cols, src_names, p_weights_names, warn_on_disaggregate, grid_compat_tol) {
    .Call('_exactextractr_CPP_exact_extract', PACKAGE = 'exactextractr', rast, rast_ext, rast_res, rast_uncropped, weights, wkb, default_value, default_weight, include_xy, include_cell_number, include_area, area_weights, coverage_areas, p_area_method, include_cols, src_names, p_weights_names, warn_on_disaggregate, grid_compat_tol)
}

CPP_stats <- function(rast, rast_ext, rast_res, weights, wkb, default_value, default_weight, coverage_areas, p_area_method, stats, max_cells_in_memory, grid_compat_tol, quantiles) {
    .Call('_exactextractr_CPP_stats', PACKAGE = 'exactextractr', rast, rast_ext, rast_res, weights, wkb, default_value, default_weight, coverage_areas, p_area_method, stats, max_cells_in_memory, grid_compat_tol, quantiles)
}

CPP_update_max_coverage <- function(extent, res, max_coverage, max_coverage_index, tot_coverage, wkb, index) {
    invisible(.Call('_exactextractr_CPP_update_max_coverage', PACKAGE = 'exactextractr', extent, res, max_coverage, max_coverage_index, tot_coverage, wkb, index))
}

CPP_resample <- function(rast_in, rast_out, p_stat, p_fun, coverage_area, area_method) {
    .Call('_exactextractr_CPP_resample', PACKAGE = 'exactextractr', rast_in, rast_out, p_stat, p_fun, coverage_area, area_method)
}

# Copyright (c) 2022 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

setGeneric("rasterize_polygons", function(x, y, ...)
	standardGeneric("rasterize_polygons"))

#' Create a raster approximation of a polygon coverage
#'
#' Returns a raster whose values indicate the index of the polygon covering
#' each cell. Where multiple polygons cover the same cell, the index of the
#' polygon covering the greatest area will be used, with the lowest index
#' returned in the case of ties. Cells that are not covered by any polygon,
#' or whose total covered fraction is less than \code{min_coverage}, will be
#' set to \code{NA}.
#'
#' @param     x a \code{sf} or \code{sfc} object with polygonal geometries
#'
#' @param     y a (possibly empty) \code{RasterLayer} whose resolution and
#'            extent will be used for the generated \code{RasterLayer}.
#' @param     min_coverage minimum fraction of a cell that must be covered by
#'                         polygons to be included in the output
#' @return a \code{RasterLayer} or \code{SpatRaster}, consistent with the type of \code{y}
#' @name rasterize_polygons
NULL

.rasterize_polygons <- function(x, y, min_coverage = 0) {
  num_rows <- terra::nrow(y)
  num_cols <- terra::ncol(y)

  if (min_coverage == 1.0) {
    # account for error in sum of single-precision plots
    min_coverage <- (min_coverage - 1e-6)
  }

  max_coverage_values <- matrix(0.0, nrow = num_rows, ncol = num_cols)
  max_coverage_indexes <- matrix(NA_integer_, nrow = num_rows, ncol = num_cols)
  tot_coverage <- matrix(0.0, nrow = num_rows, ncol = num_cols)

  dest_extent <- .extent(y)
  dest_res <- .res(y)

  geoms <- sf::st_geometry(x)

  for (i in seq_along(geoms)) {
    wkb <- sf::st_as_binary(geoms[[i]], EWKB=TRUE)

    CPP_update_max_coverage(dest_extent, dest_res, max_coverage_values, max_coverage_indexes, tot_coverage, wkb, i)
  }

  max_coverage_indexes[tot_coverage < min_coverage] <- NA

  if (inherits(y, 'SpatRaster')) {
    ret <- terra::rast(y)
    terra::values(ret) <- max_coverage_indexes
  } else {
    ret <- raster::raster(y)
    raster::values(ret) <- max_coverage_indexes
  }

  return(ret)
}

#' @import sf
#' @import raster
#' @useDynLib exactextractr
#' @rdname rasterize_polygons
#' @export
setMethod('rasterize_polygons', signature(x='sf', y='RasterLayer'), .rasterize_polygons)

#' @useDynLib exactextractr
#' @rdname rasterize_polygons
#' @export
setMethod('rasterize_polygons', signature(x='sf', y='SpatRaster'), .rasterize_polygons)

# Copyright (c) 2018-2020 ISciences, LLC.
# All rights reserved.
#
# This software is licensed under the Apache License, Version 2.0 (the "License").
# You may not use this file except in compliance with the License. You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0.
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

context('coverage_fraction')

test_that("Coverage fraction function works", {
  # This test just verifies a successful journey from R
  # to C++ and back. The correctness of the algorithm
  # is tested at the C++ level.
  square <- sf::st_sfc(sf::st_polygon(
    list(
      matrix(
        c(0.5, 0.5, 2.5, 0.5, 2.5, 2.5, 0.5, 2.5, 0.5, 0.5),
        ncol=2,
        byrow=TRUE))))

  rast <- raster::raster(xmn=0, xmx=3, ymn=0, ymx=3, nrows=3, ncols=3, crs=NA)

  weights <- coverage_fraction(rast, square)[[1]]
  expect_s4_class(weights, 'RasterLayer')

  expect_equal(as.matrix(weights),
               rbind(
                 c(0.25, 0.5, 0.25),
                 c(0.50, 1.0, 0.50),
                 c(0.25, 0.5, 0.25)
               ), check.attributes=FALSE)
})

test_that("Output can be cropped to the extent of the input feature", {
  square <- sf::st_sfc(sf::st_polygon(
    list(
      matrix(
        c(0.5, 0.5, 2.5, 0.5, 2.5, 2.5, 0.5, 2.5, 0.5, 0.5),
        ncol=2,
        byrow=TRUE))))

  rast <- raster::raster(xmn=0, xmx=10, ymn=0, ymx=10, nrows=10, ncols=10, crs=NA)

  weights <- coverage_fraction(rast, square, crop=TRUE)[[1]]

  expect_equal(raster::res(weights), raster::res(rast))
  expect_equal(raster::crs(weights), raster::crs(rast))
  expect_equal(raster::extent(weights), raster::extent(0, 3, 0, 3))
})

test_that("When output is not cropped, cells outside of the processed area are 0, not NA", {
  square <- sf::st_sfc(sf::st_polygon(
    list(
      matrix(
        c(0.5, 0.5, 2.5, 0.5, 2.5, 2.5, 0.5, 2.5, 0.5, 0.5),
        ncol=2,
        byrow=TRUE))))

  rast <- raster::raster(xmn=0, xmx=10, ymn=0, ymx=10, nrows=10, ncols=10, crs=NA)

  weights <- coverage_fraction(rast, square, crop=TRUE)[[1]]

  expect_false(any(is.na(as.matrix(weights))))
})

test_that('Raster returned by coverage_fraction has same properties as the input', {
  r <- raster::raster(xmn=391030, xmx=419780, ymn=5520000, ymx=5547400, crs=NA)
  raster::res(r) = c(100, 100)
  raster::values(r) <- 1:ncell(r)

  p <- sf::st_as_sfc('POLYGON((397199.680921053 5541748.05921053,402813.496710526 5543125.03289474,407103.299342105 5537246.41447368,398470.733552632 5533962.86184211,397199.680921053 5541748.05921053))')

  w <- coverage_fraction(r, p)

  expect_length(w, 1)
  expect_is(w[[1]], 'RasterLayer')

  expect_equal(raster::res(r),    raster::res(w[[1]]))
  expect_equal(raster::extent(r), raster::extent(w[[1]]))
  expect_equal(raster::crs(r),    raster::crs(w[[1]]))
})

test_that('Raster returned by coverage_fraction has same properties as the input (terra)', {
  r <- terra::rast(xmin=391030, xmax=419780, ymin=5520000, ymax=5547400, crs='EPSG:32618')
  terra::res(r) = c(100, 100)
  terra::values(r) <- 1:ncell(r)

  p <- sf::st_as_sfc('POLYGON((397199.680921053 5541748.05921053,402813.496710526 5543125.03289474,407103.299342105 5537246.41447368,398470.733552632 5533962.86184211,397199.680921053 5541748.05921053))',
                     crs = sf::st_crs(r))

  w <- coverage_fraction(r, p)

  expect_length(w, 1)
  expect_is(w[[1]], 'SpatRaster')

  expect_equal(terra::res(r), terra::res(w[[1]]))
  expect_equal(terra::ext(r), terra::ext(w[[1]]))
  expect_equal(terra::crs(r), terra::crs(w[[1]]))
})

test_that('Coverage fractions are exact', {
  r <- raster::raster(xmn=391030, xmx=419780, ymn=5520000, ymx=5547400, crs=NA)
  raster::res(r) = c(100, 100)
  raster::values(r) <- 1:ncell(r)

  p <- sf::st_as_sfc('POLYGON((397199.680921053 5541748.05921053,402813.496710526 5543125.03289474,407103.299342105 5537246.41447368,398470.733552632 5533962.86184211,397199.680921053 5541748.05921053))')

  w <- coverage_fraction(r, p)

  cell_area <- prod(raster::res(w[[1]]))
  ncells <- raster::cellStats(w[[1]], 'sum')

  expect_equal(sf::st_area(sf::st_geometry(p)),
               ncells*cell_area)
})

test_that('Warning is raised on CRS mismatch', {
  rast <- raster::raster(matrix(1:100, nrow=10),
                         xmn=-75, xmx=-70, ymn=41, ymx=46,
                         crs='+proj=longlat +datum=WGS84')

  poly <- sf::st_buffer(
    sf::st_as_sfc('POINT(442944.5 217528.7)', crs=32145),
    150000)

  expect_warning(coverage_fraction(rast, poly),
                 'transformed to raster')
})

test_that('Warning is raised on undefined CRS', {
  rast <- raster::raster(matrix(1:100, nrow=10),
                         xmn=0, xmx=10, ymn=0, ymx=10)

  poly <- sf::st_buffer(sf::st_as_sfc('POINT(8 4)'), 0.4)

  # neither has a defined CRS
  expect_silent(coverage_fraction(rast, poly))

  # only raster has defined CRS
  raster::crs(rast) <- '+proj=longlat +datum=WGS84'
  expect_warning(coverage_fraction(rast, poly),
                 'assuming .* same CRS .* raster')

  # both have defined crs
  sf::st_crs(poly) <- sf::st_crs(rast)
  expect_silent(coverage_fraction(rast, poly))

  # only polygons have defined crs
  raster::crs(rast) <- NULL
  expect_warning(coverage_fraction(rast, poly),
                 'assuming .* same CRS .* polygon')

})

test_that('Z dimension is ignored, if present', {
  # see https://github.com/isciences/exactextractr/issues/26
  polyz <- st_as_sfc('POLYGON Z ((1 1 0, 4 1 0, 4 4 0, 1 1 0))')
  poly <- st_as_sfc('POLYGON ((1 1, 4 1, 4 4, 1 1))')
  values <- raster(matrix(1:25, nrow=5, ncol=5, byrow=TRUE),
                   xmn=0, xmx=5, ymn=0, ymx=5)

  expect_equal(coverage_fraction(values, poly),
               coverage_fraction(values, polyz))
})

---
title: "2. Summarizing categorical data"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{2. Summarizing categorical data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7
)
knitr::opts_knit$set(
  global.par = TRUE
)
```

```{r, include = FALSE}
par(mar = c(1, 1, 1, 1))
```

## Introduction

This vignette builds upon the sample data for São Miguel (introduced in 
[the previous vignette](vig1_population.html)) to demonstrate the use of `exactextractr`
with categorical land cover data. A sample of the
[CORINE 2018](https://land.copernicus.eu/en/products/corine-land-cover/clc2018)
raster dataset is included in `exactextractr`.

As in the previous vignette, the following packages are used:

```{r setup, message = FALSE}
library(exactextractr)
library(dplyr)
library(sf)
library(raster)
```

## Loading the sample data

First, we load the CORINE land cover data and the _concelho_ boundaries.

```{r}
clc <- raster(system.file('sao_miguel/clc2018_v2020_20u1.tif',
                     package = 'exactextractr'))
concelhos <- st_read(system.file('sao_miguel/concelhos.gpkg',
                                 package = 'exactextractr'),
                     quiet = TRUE)
```

```{r, echo = FALSE}
corine_palette <- c(
  "#e6004d", "#ff0000", "#cc4df2", "#cc0000", "#e6cccc", "#e6cce6", "#a600cc",
  "#a64d00", "#ff4dff", "#ffa6ff", "#ffe6ff", "#ffffa8", "#ffff00", "#e6e600",
  "#e68000", "#f2a64d", "#e6a600", "#e6e64d", "#ffe6a6", "#ffe64d", "#e6cc4d",
  "#f2cca6", "#80ff00", "#00a600", "#4dff00", "#ccf24d", "#a6ff80", "#a6e64d",
  "#a6f200", "#e6e6e6", "#cccccc", "#ccffcc", "#000000", "#a6e6cc", "#a6a6ff",
  "#4d4dff", "#ccccff", "#e6e6ff", "#a6a6e6", "#00ccf2", "#80f2e6", "#00ffa6",
  "#a6ffe6", "#e6f2ff", "#ffffff")

plot(clc, col = corine_palette,
     axes = FALSE, legend = FALSE)
plot(st_geometry(concelhos), add = TRUE)
```

The land cover class descriptions are provided in a separate DBF file. We read
this in to a data frame, then use `levels()` to associate the class descriptions
with the raster.

```{r}
clc_classes <- foreign::read.dbf(system.file('sao_miguel/clc2018_v2020_20u1.tif.vat.dbf',
                                             package = 'exactextractr'),
                                 as.is = TRUE) %>%
  dplyr::select(value = Value,
                landcov = LABEL3)

levels(clc) <- list(data.frame(ID = clc_classes$value,
                               landcov = clc_classes$landcov))
```

This association provides us with a way to look up the description for a given
ID. Alternatively, we can relate the values using `merge` or a ``dplyr` join.

```{r}
factorValues(clc, c(2, 18, 24))
```

## Summarizing land cover classifications

One of the most basic questions we might ask is which land cover classification
is predominant in each _concelho_. We can do this with the built-in `mode`
summary operation. The `minority` and `variety` operations are also applicable
to categorical data and provide the least-common classification and number of
distinct classifications, respectively.

```{r landcov-mode}
landcov_mode <- exact_extract(clc, concelhos, 'mode', 
                              append_cols = 'name', progress = FALSE) %>%
  inner_join(clc_classes, by=c(mode = 'value'))
```

```{r landcov-mode-table, echo = FALSE}
landcov_mode %>%
  dplyr::select(-mode) %>%
  knitr::kable()
```

### Summary functions

While `mode` provides a handy way to see the most common land cover category, we
need to write a custom summary function if we want to see the frequency of
different land cover types in an area.

Summary functions are called once per feature from the input `sf` object. They
can return either:

 * a scalar, in which case the return value of `exact_extract` will be a vector
   whose entries correspond with the rows of the input `sf` object, or
    
 * a data frame, in which case `exact_extract` will return a rowwise combination
   of the data frames for each feature. If the data frame returned by the
   summary function will have than a single row, it is useful for some
   identifying information to be included in the returned data frame.

If we are going to perform typical data frame operations on the raster values
and coverage fractions, it can be more convenient for the summary function to
accept a single data frame argument, instead of separate arguments for the cell
values and coverage fractions. This behavior can be enabled with the
`summarize_df` argument.

Using this method, we can calculate the fraction of each _concelho_ that is
covered by each land cover category:

```{r landcov-fracs, message = FALSE}
landcov_fracs <- exact_extract(clc, concelhos, function(df) {
  df %>%
    mutate(frac_total = coverage_fraction / sum(coverage_fraction)) %>%
    group_by(name, value) %>%
    summarize(freq = sum(frac_total))
}, summarize_df = TRUE, include_cols = 'name', progress = FALSE)
```

Here we use the `include_cols` argument here to include the `name` column from
`concelhos` in the data frame passed to the summary function. (Although the
value of `name` will be the same for all rows in  `df`, we include `name` in the
`group_by` expression so that it is not removed by `summarize`.) Other similar
arguments include `include_xy` to get the cell center coordinates,
`include_area` to get the cell area, and `include_cell` to get the cell index
used by the `raster` package.

This provides us with a correspondence between each numeric land cover category
and its frequency in each _concelho_:

```{r}
head(landcov_fracs)
```

Joining this table to `clc_classes`, we can associate the descriptions with the
numeric types and view the three most common land cover classes in each
_concelho_:

```{r landcov-fracs-table}
landcov_fracs %>%
  inner_join(clc_classes, by = 'value') %>%
  group_by(name) %>%
  arrange(desc(freq)) %>%
  slice_head(n = 3) %>%
  mutate(freq = sprintf('%0.1f%%', 100*freq)) %>%
  knitr::kable()
```
Similarly, we can find the top land covers by area:

```{r landcov-areas, message = FALSE}
landcov_areas <- exact_extract(clc, concelhos, function(df) {
  df %>%
    group_by(name, value) %>%
    summarize(area_km2 = sum(coverage_area) / 1e6)
}, summarize_df = TRUE, coverage_area = TRUE, include_cols = 'name', progress = FALSE)
```

```{r landcov-areas-table, echo = FALSE}
landcov_areas %>%
  inner_join(clc_classes, by = 'value') %>%
  dplyr::select(-value) %>%
  group_by(name) %>%
  arrange(desc(area_km2)) %>%
  slice_head(n = 3) %>%
  knitr::kable()
```

## Summarizing population land cover

One extension of the analysis above is to see which land covers are associated
with human population in a given _concelho_. Is the population primary urban or
rural?

As described in the previous vignette, the population density raster provides
the most robust results in the presence of partially-covered pixels.

```{r load-pop-density}
pop_density <- raster(system.file('sao_miguel/gpw_v411_2020_density_2020.tif',
                                  package = 'exactextractr'))
```

We are able to perform this analysis because the CORINE sample distributed with
`exactextractr` has been reprojected from its native Lambert Equal Area
projection into geographic coordinates consistent with GPW. Otherwise, working
with multiple rasters in different projections requires transformation to a
common grid using tools such as `raster::projectRaster` or the `gdalwarp`
command-line utility.

Very little about the call to `exact_extract` requires changing to incorporate
population. We set `weights = pop_density` and, since we are using the
`summarize_df` option, a column called `weight` will be added to the data frame
passed to the summary function. We also set `coverage_area = TRUE` so that we
can multiply the density by the covered pixel area to get a population count.

```{r landcov-pop-areas, message = FALSE, results = FALSE}
landcov_pop_areas <- exact_extract(clc, concelhos, function(df) {
  df %>%
    group_by(name, value) %>%
    summarize(pop = sum(coverage_area * weight / 1e6)) %>%
    mutate(pop_frac = pop / sum(pop))
}, weights = pop_density, coverage_area = TRUE,
   summarize_df = TRUE, include_cols = 'name')
```

Looking at the highest-population land cover type in each _concelho_, we can
can see that the western/central _concelhos_ of Lagoa, Ponta Delgada, Ribeira
Grande, and Vila Franca do Campo have a more urban population than Nordeste or
Povoação to the east.

```{r landcov-pop-areas-table, echo = FALSE}
landcov_pop_areas %>%
  inner_join(clc_classes, by = 'value') %>%
  group_by(name) %>%
  arrange(desc(pop_frac)) %>%
  slice_head(n = 1) %>%
  dplyr::select(name, landcov, pop, pop_frac) %>%
  mutate(pop = round(pop),
         pop_frac = round(pop_frac, 3)) %>%
  knitr::kable()
```

---
title: "1. Summarizing gridded population data"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{1. Summarizing gridded population data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  fig.width = 7
)
knitr::opts_knit$set(
  global.par = TRUE
)
```

```{r, include = FALSE}
par(mar = c(1, 1, 1, 1))
```

## Introduction

This vignette describes the use of `exactextractr` to summarize population 
and elevation data from the
[Gridded Population of the World](https://www.earthdata.nasa.gov/data/projects/gpw)
and [EU-DEM](https://www.eea.europa.eu/en/datahub/dataset-redirect/DAT-193-en)
datasets. 
The `exactextractr` package includes samples of both of these datasets,
cropped to the extent of São Miguel, the largest and most populous island of the
Azores archipelago.

This example uses the following packages:

```{r setup, message = FALSE}
library(dplyr)
library(exactextractr)
library(raster)
library(sf)
```

## Loading the sample data

To begin, we load the population count file from GPW. This raster provides the
total population in each pixel for the calendar year 2020. On top of the
population grid, we plot boundaries for the six municipalities, or _concelhos_,
into which the island is divided. We can see that the population is concentrated
along the coastlines, with smaller communities located in volcanic calderas
inland.

```{r load-data-1}
pop_count <- raster(system.file('sao_miguel/gpw_v411_2020_count_2020.tif',
                                package = 'exactextractr'))
concelhos <- st_read(system.file('sao_miguel/concelhos.gpkg',
                                 package = 'exactextractr'),
                     quiet = TRUE)
plot(pop_count, axes = FALSE)
plot(st_geometry(concelhos), add = TRUE)
```

## Calculating total population

Because the population count raster has been cropped and contains no land area
outside of São Miguel, we can calculate the total population of the island using
the `cellStats` function from the `raster` package.

```{r total-pop-cellstats}
cellStats(pop_count, 'sum')
```

```{r, echo = FALSE}
sao_miguel_pop <- cellStats(pop_count, 'sum')
```

### Calculating population from the GPW population count file

We might also attempt to use `exact_extract` with the population count raster to
see how the population is divided among _concelhos_:

```{r extract-example}
exact_extract(pop_count, concelhos, 'sum', progress = FALSE)
```

The result is a vector with one entry for each feature in `concelhos`. The order
of the result is consistent with the input features, so we can assign the result
of `exact_extract` to a new column in `concelhos` if desired.

To calculate the populations, we used `fun = 'sum'`, where `'sum'` is a named
summary operation recognized by `exactextractr`. A full list of supported
operations can be found in the function documentation for `exact_extract`. If
none of the named operations is suitable, we can set `fun` equal to an R
function such as `function(pixel_value, coverage_fraction) sum(pixel_value
* coverage_fraction)`. However, the named operations are generally faster than R
equivalents and use less memory when rasters or polygons are large.

To review the results more easily, we can use the `append_cols` argument to copy
columns from the input `sf` object into the result of `exact_extract`. We also
use some `dplyr` operations to add a column for the total population of all
_concelhos_:

```{r extract-pop-by-sum, cache = TRUE}
concelho_pop <- exact_extract(pop_count, concelhos, 'sum', 
                              append_cols = 'name', progress = FALSE) %>%
  rename(pop = sum) %>%
  arrange(desc(pop)) %>%
  bind_rows(summarize(., name = 'Total', pop = sum(pop)))
```

This produces the following table:

```{r, echo = FALSE}
concelho_pop %>%
  mutate(pop = prettyNum(round(pop), big.mark = ',')) %>%
  knitr::kable()
```

```{r calc-missing-pop, echo=FALSE, results='hide'}
total_pop <- filter(concelho_pop, name == 'Total') %>% pull(pop)
missing_pop_pct <- (sao_miguel_pop - total_pop) / sao_miguel_pop
missing_pop_pct
```

We might reasonably expect the total population to equal the value of 
`r  prettyNum(sao_miguel_pop, big.mark=',')` we previously obtained using
`cellStats`, but it doesn't. In fact, `r as.integer(100*missing_pop_pct)`% of
the population is unaccounted for in the _concelho_ totals.

The cause of the discrepancy can be seen by looking closely at the densely
populated Ponta Delgada region on the southern coast. Many of the cells
containing population are only partially covered by the _concelho_ boundaries,
so some of the total population calculated by `cellStats` is missing from the
totals.

```{r plot-pop-ponta-delgada}
plot.new()
plot.window(xlim = c(-25.75, -25.55), ylim = c(37.70, 37.77))
rect(par("usr")[1], par("usr")[3], par("usr")[2], par("usr")[4], col = "#9cc0f9")
plot(pop_count, add = TRUE, axes = FALSE, alpha = 0.8, horizontal = TRUE)
plot(st_geometry(concelhos), add = TRUE)
```

### Calculating population from the GPW population density file

It turns out that we need a somewhat more complex solution to get accurate
population counts when our polygons follow coastlines. Instead of using the
population count raster, we bring in the population density raster, which
provides the number of persons per square kilometer of land area in each pixel.

```{r load-data-2}
pop_density <- raster(system.file('sao_miguel/gpw_v411_2020_density_2020.tif',
                                  package = 'exactextractr'))
```

To get a population count, we can multiply the population density by the area of
each cell that is covered by the polygon. One way to do this is by providing the
cell areas as a weighting raster and using a custom summary function. Weighted
summary functions have the signature 
`function(values, coverage_fractions, weights)`.

We can write one as follows:

```{r pop-from-density, cache = TRUE}
concelho_pop2 <- exact_extract(pop_density, concelhos, 
                               function(density, frac, area) {
                                 sum(density * frac * area)
                               }, 
                               weights = raster::area(pop_density),
                               append_cols = 'name',
                               progress = FALSE)
```

This produces the following table:

```{r, echo = FALSE}
concelho_pop2 %>%
  rename(pop = result) %>%
  arrange(desc(pop)) %>%
  bind_rows(summarize(., name = 'Total', pop = sum(pop))) %>%
  mutate(pop = prettyNum(round(pop), big.mark = ',')) %>%
  knitr::kable()
```

```{r pop-missing-from-density, echo=FALSE, results='hide'}
missing_pop_pct <- 100 * (sao_miguel_pop - sum(concelho_pop2$result)) / sao_miguel_pop
stopifnot(missing_pop_pct < 1)
```

The total population obtained using this method is remarkably close 
(within `r sprintf('%.02f%%', abs(missing_pop_pct))`)
to the expected value from `cellStats`.

While this solution works well for the sample data, it has a couple of
disadvantages for larger data sets:

- calling `raster::area(x)` generates an in-memory raster of the same size as
  `x`. For a raster like GPW at 30 arc-second resolution, this would consume
  several gigabytes of memory.
- passing extracted raster values to a summary function written in R requires
  that `exactextractr` load all values associated with a given polygon into
  memory at once. This presents no problem when working with the _concelho_
  boundaries, but could cause excessive memory usage when working with large
  national boundaries.

An alternative formulation that resolves both of these problems uses the
`weighted_sum` summary operation instead of an R function, and uses 
`weights = 'area'`, which instructs `exact_extract` to compute its own cell
areas based on the projection of `pop_density`.

```{r pop-from-density-2, results = 'hide'}
exact_extract(pop_density, concelhos, 'weighted_sum', weights = 'area')
```

## Population-weighted statistics

Suppose that we are interested in calculating the average elevation of a
residence in each of the six _concelhos_. Loading the EU-DEM elevation data for
the island, we can see that each _concelho_ is at least partly occupied by
interior mountains, indicating that the results of a simple mean would be
unrepresentative of the primarily coastal population.

```{r plot-elevation}
elev <- raster(system.file('sao_miguel/eu_dem_v11.tif', package = 'exactextractr'))

plot(elev, axes = FALSE, box = FALSE)
plot(st_geometry(concelhos), add = TRUE)
```

As in the previous section, we avoid working with the population count raster to
avoid losing population along the coastline. We can formulate the
population-weighted average elevation as in terms of population density and
pixel areas as:

$$
\bar{x}_\mathrm{pop} = \frac{ \Sigma_{i=0}^n {x_ic_id_ia_i}}{\Sigma_{i=0}^n{c_id_ia_i}}
$$
where $x_i$ is the elevation of pixel $i$, $c_i$ is the fraction of pixel $i$ 
that is covered by a polygon, $d_i$ is the population density of pixel $i$, and
$a_i$ is the area of pixel $i$.

If we are working with projected data, or geographic data over a small area such
as São Miguel, we can assume all pixel areas to be equivalent, in which case the
$a_i$ components cancel each other out and we are left with the direct usage
of population density as a weighting raster:

```{r pop-weighted-mean-elev, results = 'hide'}
exact_extract(elev, concelhos,  'weighted_mean', weights = pop_density)
```
What if pixel areas do vary across the region of our analysis?

One option is to create a scaled population count raster by multiplying the
population density and the pixel area. For pixels that are partly covered by
water, this inflates the pixel population such that we obtain the correct
population when only the land area is covered by a polygon. This requires that
we create and maintain a separate raster data set.

Another option is to create a `RasterStack` of `pop_density` and `area(pop_density)`,
and then write a summary function to handle the necessary processing. We use the
`summarize_df = TRUE` argument to combine the elevation, population density,
pixel area, and pixel coverage fraction into a single data frame that is passed
to the summary function.

```{r pop-weighted-mean-elev-2, results = 'hide'}
exact_extract(elev, concelhos,
              function(df) {
                weighted.mean(x = df$value,
                              w = df$coverage_fraction * df$pop_density * df$area,
                              na.rm = TRUE)},
              weights = stack(list(pop_density = pop_density,
                                   area = area(pop_density))),
              summarize_df = TRUE,
              progress = FALSE)
```

This solution shares the same limitations with the previous example using an R
summary function with `raster::area()`: we must precompute an area raster and
store it in memory, and we must load all raster values intersecting a given
polygon into memory at a single time.

A better solution is to use the `coverage_area` argument to `exact_extract`, 
which specifies that all calculations use the area of each cell that is covered 
by the polygon instead of the fraction of each cell that is covered by
the polygon.

```{r pop-weighted-mean-elev-3}
concelho_mean_elev <- exact_extract(elev, concelhos, c('mean', 'weighted_mean'), 
                                    weights = pop_density,
                                    coverage_area = TRUE, 
                                    append_cols = 'name', progress = FALSE)
```

Here we also calculate the unweighted mean for comparison. We can see that the
population-weighted mean elevation is substantially lower than the mean
elevation in all _concelhos_.

```{r, echo = FALSE}
concelho_mean_elev %>%
  rename(mean_elev = mean,
         pop_weighted_mean_elev = weighted_mean) %>%
  arrange(name) %>%
  knitr::kable()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exactextractr-package.R
\docType{package}
\name{exactextractr-package}
\alias{exactextractr}
\alias{exactextractr-package}
\title{exactextractr: Fast Extraction from Raster Datasets using Polygons}
\description{
Quickly and accurately summarizes raster values over polygonal areas ("zonal statistics").
}
\seealso{
Useful links:
\itemize{
  \item \url{https://isciences.gitlab.io/exactextractr/}
  \item \url{https://github.com/isciences/exactextractr}
  \item Report bugs at \url{https://github.com/isciences/exactextractr/issues}
}

}
\author{
\strong{Maintainer}: Daniel Baston \email{dbaston@isciences.com}

Other contributors:
\itemize{
  \item ISciences, LLC [copyright holder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exact_resample.R
\name{exact_resample}
\alias{exact_resample}
\alias{exact_resample,RasterLayer,RasterLayer-method}
\alias{exact_resample,SpatRaster,SpatRaster-method}
\title{Resample a raster to a new grid}
\usage{
\S4method{exact_resample}{RasterLayer,RasterLayer}(x, y, fun, coverage_area = FALSE)

\S4method{exact_resample}{SpatRaster,SpatRaster}(x, y, fun, coverage_area = FALSE)
}
\arguments{
\item{x}{a \code{RasterLayer} or \code{SpatRaster} to be resampled}

\item{y}{a raster of the same class as \code{x} with a grid definition to
which \code{x} should be resampled}

\item{fun}{a named summary operation or R function to be used for the resampling}

\item{coverage_area}{use cell coverage areas instead of coverage fractions
in \code{fun}}
}
\value{
a resampled version of \code{x}, returned as a \code{RasterLayer} or
        \code{SpatRaster}, depending on the values of \code{x} and \code{y}
}
\description{
Resample a raster to a new grid
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coverage_fraction.R
\name{coverage_fraction}
\alias{coverage_fraction}
\alias{coverage_fraction,RasterLayer,sf-method}
\alias{coverage_fraction,RasterLayer,sfc_MULTIPOLYGON-method}
\alias{coverage_fraction,RasterLayer,sfc_POLYGON-method}
\alias{coverage_fraction,SpatRaster,sf-method}
\alias{coverage_fraction,SpatRaster,sfc_MULTIPOLYGON-method}
\alias{coverage_fraction,SpatRaster,sfc_POLYGON-method}
\title{Compute the fraction of raster cells covered by a polygon}
\usage{
\S4method{coverage_fraction}{RasterLayer,sf}(x, y, crop = FALSE)

\S4method{coverage_fraction}{RasterLayer,sfc_MULTIPOLYGON}(x, y, crop)

\S4method{coverage_fraction}{RasterLayer,sfc_POLYGON}(x, y, crop)

\S4method{coverage_fraction}{SpatRaster,sf}(x, y, crop = FALSE)

\S4method{coverage_fraction}{SpatRaster,sfc_MULTIPOLYGON}(x, y, crop)

\S4method{coverage_fraction}{SpatRaster,sfc_POLYGON}(x, y, crop)
}
\arguments{
\item{x}{a (possibly empty) \code{RasterLayer} whose resolution and
extent will be used for the generated \code{RasterLayer}.}

\item{y}{a \code{sf} object with polygonal geometries}

\item{crop}{if \code{TRUE}, each generated \code{RasterLayer} will be
cropped to the extent of its associated feature.}
}
\value{
a list with a \code{RasterLayer} for each feature in \code{y}.
           Values of the raster represent the fraction of each
           cell in \code{x} that is covered by \code{y}.
}
\description{
Compute the fraction of raster cells covered by a polygon
}
\examples{
rast <- raster::raster(matrix(1:100, ncol=10), xmn=0, ymn=0, xmx=10, ymx=10)
poly <- sf::st_as_sfc('POLYGON ((2 2, 7 6, 4 9, 2 2))')

cov_frac <- coverage_fraction(rast, poly)[[1]]
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rasterize.R
\name{rasterize_polygons}
\alias{rasterize_polygons}
\alias{rasterize_polygons,sf,RasterLayer-method}
\alias{rasterize_polygons,sf,SpatRaster-method}
\title{Create a raster approximation of a polygon coverage}
\usage{
\S4method{rasterize_polygons}{sf,RasterLayer}(x, y, min_coverage = 0)

\S4method{rasterize_polygons}{sf,SpatRaster}(x, y, min_coverage = 0)
}
\arguments{
\item{x}{a \code{sf} or \code{sfc} object with polygonal geometries}

\item{y}{a (possibly empty) \code{RasterLayer} whose resolution and
extent will be used for the generated \code{RasterLayer}.}

\item{min_coverage}{minimum fraction of a cell that must be covered by
polygons to be included in the output}
}
\value{
a \code{RasterLayer} or \code{SpatRaster}, consistent with the type of \code{y}
}
\description{
Returns a raster whose values indicate the index of the polygon covering
each cell. Where multiple polygons cover the same cell, the index of the
polygon covering the greatest area will be used, with the lowest index
returned in the case of ties. Cells that are not covered by any polygon,
or whose total covered fraction is less than \code{min_coverage}, will be
set to \code{NA}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exact_extract_helpers.R
\name{.valueWeightIndexes}
\alias{.valueWeightIndexes}
\title{Compute indexes for the value and weight layers that should be
processed together}
\usage{
.valueWeightIndexes(num_values, num_weights)
}
\arguments{
\item{num_values}{number of layers in value raster}

\item{num_weights}{number of layers in weighting raster}
}
\value{
list with \code{values} and \code{weights} elements
        providing layer indexes
}
\description{
Compute indexes for the value and weight layers that should be
processed together
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exact_extract.R
\name{exact_extract}
\alias{exact_extract}
\alias{exact_extract,Raster,sf-method}
\alias{exact_extract,Raster,SpatialPolygonsDataFrame-method}
\alias{exact_extract,Raster,SpatialPolygons-method}
\alias{exact_extract,Raster,sfc_MULTIPOLYGON-method}
\alias{exact_extract,Raster,sfc_POLYGON-method}
\alias{exact_extract,Raster,sfc_GEOMETRY-method}
\alias{exact_extract,Raster,sfc_GEOMETRYCOLLECTION-method}
\alias{exact_extract,SpatRaster,sf-method}
\alias{exact_extract,SpatRaster,SpatialPolygonsDataFrame-method}
\alias{exact_extract,SpatRaster,SpatialPolygons-method}
\alias{exact_extract,SpatRaster,sfc_MULTIPOLYGON-method}
\alias{exact_extract,SpatRaster,sfc_POLYGON-method}
\alias{exact_extract,SpatRaster,sfc_GEOMETRY-method}
\alias{exact_extract,SpatRaster,sfc_GEOMETRYCOLLECTION-method}
\title{Extract or summarize values from rasters}
\usage{
\S4method{exact_extract}{Raster,sf}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{Raster,SpatialPolygonsDataFrame}(x, y, ...)

\S4method{exact_extract}{Raster,SpatialPolygons}(x, y, ...)

\S4method{exact_extract}{Raster,sfc_MULTIPOLYGON}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{Raster,sfc_POLYGON}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{Raster,sfc_GEOMETRY}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{Raster,sfc_GEOMETRYCOLLECTION}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{SpatRaster,sf}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{SpatRaster,SpatialPolygonsDataFrame}(x, y, ...)

\S4method{exact_extract}{SpatRaster,SpatialPolygons}(x, y, ...)

\S4method{exact_extract}{SpatRaster,sfc_MULTIPOLYGON}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{SpatRaster,sfc_POLYGON}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{SpatRaster,sfc_GEOMETRY}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)

\S4method{exact_extract}{SpatRaster,sfc_GEOMETRYCOLLECTION}(
  x,
  y,
  fun = NULL,
  ...,
  weights = NULL,
  append_cols = NULL,
  coverage_area = FALSE,
  default_value = NA_real_,
  default_weight = NA_real_,
  include_area = FALSE,
  include_cell = FALSE,
  include_cols = NULL,
  include_xy = FALSE,
  force_df = FALSE,
  full_colnames = FALSE,
  stack_apply = FALSE,
  summarize_df = FALSE,
  quantiles = NULL,
  progress = TRUE,
  max_cells_in_memory = 3e+07,
  grid_compat_tol = 0.001,
  colname_fun = NULL
)
}
\arguments{
\item{x}{a \code{RasterLayer}, \code{RasterStack}, \code{RasterBrick}, or \code{SpatRaster}}

\item{y}{a \code{sf}, \code{sfc}, \code{SpatialPolygonsDataFrame}, or \code{SpatialPolygons}
object with polygonal geometries}

\item{fun}{an optional function or character vector, as described below}

\item{...}{additional arguments to pass to \code{fun}}

\item{weights}{a weighting raster to be used with the \code{weighted_mean}
and \code{weighted_sum} summary operations or a user-defined
summary function. When \code{weights} is set to \code{'area'}, the
cell areas of \code{x} will be calculated and used as weights.}

\item{append_cols}{when \code{fun} is not \code{NULL}, an optional character vector
of columns from \code{y} to be included in returned data frame.}

\item{coverage_area}{if \code{TRUE}, output pixel \code{coverage_area}
instead of \code{coverage_fraction}}

\item{default_value}{an optional value to use instead of \code{NA} in \code{x}}

\item{default_weight}{an optional value to use instead of \code{NA} in \code{weights}}

\item{include_area}{if \code{TRUE}, and \code{fun} is \code{NULL}, augment
the data frame for each feature with a column
for the cell area. If the units of the raster CRS are
degrees, the area in square meters will be calculated
based on a spherical approximation of Earth. Otherwise,
a Cartesian area will be calculated (and will be the
same for all pixels.) If \code{TRUE} and \code{fun} is
not \code{NULL}, add \code{area} to the data frame passed
to \code{fun} for each feature.}

\item{include_cell}{if \code{TRUE}, and \code{fun} is \code{NULL}, augment
the data frame for each feature with a column
for the cell index (\code{cell}). If \code{TRUE} and
\code{fun} is not \code{NULL}, add \code{cell} to the
data frame passed to \code{fun} for each feature.}

\item{include_cols}{an optional character vector of column names in
\code{y} to be added to the data frame for each
feature that is either returned (when \code{fun} is
\code{NULL}) or passed to \code{fun}.}

\item{include_xy}{if \code{TRUE}, and \code{fun} is \code{NULL}, augment
the returned data frame for each feature with columns
for cell center coordinates (\code{x} and \code{y}). If
\code{TRUE} and \code{fun} is not \code{NULL}, add
\code{x} and \code{y} to the data frame passed to \code{fun}
for each feature.}

\item{force_df}{always return a data frame instead of a vector, even if
\code{x} has only one layer and \code{fun} has length 1}

\item{full_colnames}{include the names of \code{x} and \code{weights} in
the names of the data frame for each feature, even if
\code{x} or \code{weights} has only one layer.
This is useful when the results of multiple
calls to \code{exact_extract} are combined with
\code{cbind}.}

\item{stack_apply}{if \code{TRUE}, apply \code{fun} independently to
each layer or \code{x} (and its corresponding layer
of \code{weights}, if provided.) The number of
layers in \code{x} and \code{weights} must equal
each other or \code{1}, in which case the
single layer raster will be recycled.
If \code{FALSE}, apply \code{fun} to all layers of
\code{x} (and \code{weights}) simultaneously.}

\item{summarize_df}{pass values, coverage fraction/area, and weights to
\code{fun} as a single data frame instead of
separate arguments.}

\item{quantiles}{quantiles to be computed when \code{fun = 'quantile'}}

\item{progress}{if \code{TRUE}, display a progress bar during processing}

\item{max_cells_in_memory}{the maximum number of raster cells to load at
a given time when using a named summary operation
for \code{fun} (as opposed to a function defined using
R code). If a polygon covers more than \code{max_cells_in_memory}
raster cells, it will be processed in multiple chunks.}

\item{grid_compat_tol}{require value and weight grids to align within
\code{grid_compat_tol} times the smaller of the two
grid resolutions.}

\item{colname_fun}{an optional function used to construct column names.
Should accept arguments \code{values} (name of value layer),
\code{weights} (name of weight layer), \code{fun_name} (value of
\code{fun}), \code{fun_value} (value associated with \code{fun}, for
\verb{fun \%in\% c('quantile', 'frac', 'weighted_frac)}
\code{nvalues} (number of value layers), \code{weights}
(number of weight layers)}
}
\value{
a vector, data frame, or list of data frames, depending on the type
of \code{x} and the value of \code{fun} (see Details)
}
\description{
Extracts the values of cells in a raster (\code{RasterLayer}, \code{RasterStack}
\code{RasterBrick}, or \code{SpatRaster}) that are covered by polygons in a
simple feature collection (\code{sf} or \code{sfc}) or \code{SpatialPolygonsDataFrame}.
Returns either a summary of the extracted values or the extracted values
themselves.
}
\details{
\code{exact_extract} extracts the values of cells in a raster that are covered
by polygonal features in a simple feature collection (\code{sf} or \code{sfc}) or
\code{SpatialPolygonDataFrame}, as well as the fraction or area of each cell that
is covered by the feature. Pixels covered by all parts of the polygon are
considered. If an (invalid) multipart polygon covers the same pixels more
than once, the pixel may have a coverage fraction greater than one.

The function can either return pixel values directly to the caller, or can
return the result of a predefined summary operation or user-defined R
function applied to the values. These three approaches are described in the
subsections below.
\subsection{Returning extracted values directly}{

If \code{fun} is not specified, \code{exact_extract} will return a list with
one data frame for each feature in the input feature collection. The data
frame will contain a column with cell values from each layer in the input
raster (and optional weighting raster) and a column indicating
the fraction or area of the cell that is covered by the polygon.

If the input rasters have only one layer, the value and weight columns in the
data frame will be named \code{values} or \code{weights}. When the input rasters have
more than one layer, the columns will be named according to \code{names(x)} and
\code{names(weights)}. The column containing pixel coverage will be called
\code{coverage_fraction} when \code{coverage_area = FALSE}, or \code{coverage_area} when
\code{coverage_area = TRUE}. Additional columns can be added to the returned data
frames with the \code{include_area}, \code{include_cell}, and \code{include_xy} arguments.

If the output data frames for multiple features are to be combined (e.g.,
with \code{rbind}), it may be useful to include identifying column(s) from the
input features in the returned data frames using \code{include_cols}.
}

\subsection{Predefined summary operations}{

Often the individual pixel values are not needed; only one or more summary
statistics (e.g., mean, sum) is required for each feature. Common summary
statistics can be calculated by \code{exact_extract} directly using a predefined
summary operation. Where possible, this approach is advantageous because it
allows the package to calculate the statistics incrementally, avoiding the
need to store all pixel values in memory at the same time. This allows the
package to process arbitrarily large data with a small amount of memory. (The
\code{max_pixels_in_memory} argument can be used to fine-tune the amount of memory
made available to \code{exact_extract}.)

To summarize pixel values using a predefined summary option, \code{fun} should be
set to a character vector of one or more operation names. If the input raster
has a single layer and a single summary operation is specified,
\code{exact_extract} will return a vector with the result of the summary operation
for each feature in the input. If the input raster has multiple layers, or if
multiple summary operations are specified, \code{exact_extract} will return a data
frame with a row for each feature and a column for each summary operation /
layer combination. (The \code{force_df} option can be used to always return a data
frame instead of a vector.)

The following summary operations are supported:
\itemize{
\item \code{min} - the minimum non-\code{NA} value in any raster cell wholly or
partially covered by the polygon
\item \code{max} - the maximum non-\code{NA} value in any raster cell wholly or
partially covered by the polygon
\item \code{count} - the sum of fractions of raster cells with non-\code{NA}
values covered by the polygon
\item \code{sum}   - the sum of non-\code{NA} raster cell values, multiplied by
the fraction of the cell that is covered by the polygon
\item \code{mean} - the mean cell value, weighted by the fraction of each cell
that is covered by the polygon
\item \code{median} - the median cell value, weighted by the fraction of each cell
that is covered by the polygon
\item \code{quantile} - arbitrary quantile(s) of cell values, specified in
\code{quantiles}, weighted by the fraction of each cell that is
covered by the polygon
\item \code{mode} - the most common cell value, weighted by the fraction of
each cell that is covered by the polygon. Where multiple
values occupy the same maximum number of weighted cells,
the largest value will be returned.
\item \code{majority} - synonym for \code{mode}
\item \code{minority} - the least common cell value, weighted by the fraction
of each cell that is covered by the polygon. Where
multiple values occupy the same minimum number of
weighted cells, the smallest value will be returned.
\item \code{variety} - the number of distinct values in cells that are wholly or
partially covered by the polygon.
\item \code{variance} - the population variance of cell values, weighted by the
fraction of each cell that is covered by the polygon.
\item \code{stdev} - the population standard deviation of cell values, weighted by
the fraction of each cell that is covered by the polygon.
\item \code{coefficient_of_variation} - the population coefficient of variation of
cell values, weighted by the fraction of each
cell that is covered by the polygon.
\item \code{weighted_mean} - the mean cell value, weighted by the product of
the fraction of each cell covered by the polygon
and the value of a second weighting raster provided
as \code{weights}
\item \code{weighted_sum} - the sum of defined raster cell values, multiplied by
the fraction of each cell that is covered by the polygon
and the value of a second weighting raster provided
as \code{weights}
\item \code{weighted_stdev} - the population standard deviation of cell values,
weighted by the product of the fraction of each cell
covered by the polygon and the value of a second
weighting raster provided as \code{weights}
\item \code{weighted_variance} - the population variance of cell values, weighted by
the product of the fraction of each cell covered by
the polygon and the value of a second weighting
raster provided as \code{weights}
\item \code{frac} - returns one column for each possible value of \code{x}, with the
the fraction of defined raster cells that are equal to that
value.
\item \code{weighted_frac} - returns one column for each possible value of \code{x},
with the fraction of defined cells that are equal
to that value, weighted by \code{weights.}
}

In all of the summary operations, \code{NA} values in the the primary raster (\code{x})
raster are ignored (i.e., \code{na.rm = TRUE}.) If \code{NA} values occur in the
weighting raster, the result of the weighted operation will be \code{NA}. \code{NA}
values in both \code{x} and \code{weights} can be replaced on-the-fly using the
\code{default_value} and \code{default_weight} arguments.
}

\subsection{User-defined summary functions}{

If no predefined summary operation is suitable, a user-defined R function may
be provided as \code{fun}. The function will be called once for each feature and
must return either a single value or a data frame. The results of the
function for each feature will be combined and returned by \code{exact_extract}.

The simplest way to write a summary function is to set
argument \code{summarize_df = TRUE}. (For backwards compatibility, this is not the
default.) In this mode, the summary function takes the signature
\verb{function(df, ...)} where \code{df} is the same data frame that would be returned
by \code{exact_extract} with \code{fun = NULL}.

With \code{summarize_df = FALSE}, the function must have the signature
\verb{function(values, coverage_fractions, ...)} when weights are not used, and
\verb{function(values, coverage_fractions, weights, ...)} when weights are used.
If the value and weight rasters each have a single layer, the function arguments
will be vectors; if either has multiple layers, the function arguments will
be data frames, with column names taken from the names of the value/weight
rasters. Values brought in through the \code{include_xy}, \code{include_area},
\code{include_cell}, and \code{include_cols} arguments will be added to the \code{values}
data frame. For most applications, it is simpler to set \code{summarize_df = TRUE}
and work with all inputs in a single data frame.
}
}
\examples{
rast <- raster::raster(matrix(1:100, ncol=10), xmn=0, ymn=0, xmx=10, ymx=10)
poly <- sf::st_as_sfc('POLYGON ((2 2, 7 6, 4 9, 2 2))')

# named summary operation on RasterLayer, returns vector
exact_extract(rast, poly, 'mean')

# two named summary operations on RasterLayer, returns data frame
exact_extract(rast, poly, c('min', 'max'))

# named summary operation on RasterStack, returns data frame
stk <- raster::stack(list(a=rast, b=sqrt(rast)))
exact_extract(stk, poly, 'mean')

# named weighted summary operation, returns vector
weights <- raster::raster(matrix(runif(100), ncol=10), xmn=0, ymn=0, xmx=10, ymx=10)
exact_extract(rast, poly, 'weighted_mean', weights=weights)

# custom summary function, returns vector
exact_extract(rast, poly, function(value, cov_frac) length(value[cov_frac > 0.9]))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/exact_extract_helpers.R
\name{.resultColumns}
\alias{.resultColumns}
\title{Return column names to be used for summary operations}
\usage{
.resultColumns(
  value_names,
  weight_names,
  fun,
  full_colnames,
  quantiles = numeric(),
  unique_values = numeric(),
  colname_fun = NULL
)
}
\arguments{
\item{value_names}{names of value raster layers}

\item{weight_names}{names of weighting raster layers}

\item{fun}{functions or names of summary operations}

\item{full_colnames}{return a complete column name even when there is no
ambiguity?}

\item{quantiles}{quantiles to use when \code{stat_names} contains \code{quantile}}
}
\value{
character vector of column names
}
\description{
Return column names to be used for summary operations
}
\keyword{internal}
